import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import jp.ne.so_net.ga2.no_ji.jcom.*;

public class JComViewer extends JSplitPane 
{
	ITypeLib typeLib;
	ITypeInfo[] typeInfos;
	public JComViewer(ITypeLib typelib) throws Exception {
		super();
		this.typeLib = typelib;
		typeInfos = new ITypeInfo[typelib.getTypeInfoCount()];
		for(int i=0; i<typeInfos.length; i++) {
			typeInfos[i] = typelib.getTypeInfo(i);
//			System.out.println(typeInfos[i]);
		}

		setOrientation(HORIZONTAL_SPLIT);
		setDividerSize(5);
		// hLgAc[r[Ar[쐬
//		ListModel typeInfoModel = new AbstractListModel() {
//			public int getSize() { return this.typelib.getTypeInfoCount(); }
//			public Object getElementAt(int index) { return this.typeLib.getTypeInfo(index); }
//		};
		JList typeInfoList = new JList(new TypeLibListModel(typeInfos));
//		JList typeInfoList = new JList(typeInfos);

		setLeftComponent(new JScrollPane(typeInfoList));
/*		// r[쐬AC蓖Ă
//		view = new FigureEditor((FigureLayer)layer);
		LayerFactory factory = LayerFactory.getLayerFactory();
		factory.addPath(".");
		factory.addPath("figure");
		factory.addPath("hadron");
		view = factory.getLayerEditor("FigureEditor");
		view.setLayer(layer);
		setRightComponent(view.getPanel());
*/
		setDividerLocation(240);	// Xvb^[̈ʒu
	}

	public class TypeLibListModel extends AbstractListModel {
		ITypeInfo[] typeInfos;
		TypeLibListModel(ITypeInfo[] typeInfos) throws Exception {
			this.typeInfos = typeInfos;
		}
		public int getSize() {
			return typeInfos.length;
		}
		public Object getElementAt(int index) {
			if(index<0 || index >= typeInfos.length) return "@@@";
			try {
				return (String)typeInfos[index].getDocumentation(-1)[0];
			} catch(JComException e) {
				e.printStackTrace();
			}
			return "???";
		}
	}

	static boolean atwork = true;
	public static void main(String[] args) {
		ReleaseManager rm = new ReleaseManager();
		try {
			IDispatch xlApp = new IDispatch(rm, "Excel.Application");  // EXCEL{
			ITypeInfo typeInfo = xlApp.getTypeInfo();
			ITypeLib typeLib = typeInfo.getTypeLib();
			JFrame frame = new JFrame("JComViewer");
			JComViewer viewer = new JComViewer(typeLib);
			frame.getContentPane().add(viewer);
			// EBhEIƂɃAvP[VIBʓ|
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					atwork = false;
				}
			});
			frame.setSize(800,600);
			frame.setVisible(true);
			while(atwork) Thread.sleep(1000);
		}
		catch(Exception e) { e.printStackTrace(); }
		finally { System.out.println("release()"); rm.release(); }
		System.exit(1);
	}
}
