package com.lordjoe.lib.xml;

import com.lordjoe.utilities.Assertion;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Iterator;
import java.util.Set;
import java.util.HashSet;
import java.lang.reflect.*;
import com.lordjoe.utilities.*;

/**
 * Data object used by ClassAnalyzer to hold a property
 * @author Steve Lewis
 * @since july 99
 */

public class ClassProperty
{
    public String m_Name;
    public Class m_Class;
    public Method m_SetMethod;
    public Method m_GetMethod;
    public Class m_Type;
    public Class getType() {
        if(m_Type == null) buildType();
        return(m_Type);
    }
    protected void buildType() {
        if(m_GetMethod != null) 
            m_Type = m_GetMethod.getReturnType();
        else
            m_Type = m_SetMethod.getParameterTypes()[0];
    }
    public boolean isIndexed() {
        if(m_GetMethod != null) {
            Class[] args = m_GetMethod.getParameterTypes();
            return(args.length > 0);
        }
        else {
            Class[] args = m_SetMethod.getParameterTypes();
            return(args.length > 1);
        }
    }
    
    public Class getPropertyType() { return(m_Type); }
    public Method getSetMethod() { return(m_SetMethod); }
    public Method getGetMethod() { return(m_GetMethod); }
    public String getName() { return(m_Name); }
}
