package com.lordjoe.lib.xml;
import com.lordjoe.utilities.*;
import java.util.*;
import java.io.*;
/**{ class
@name SerializerParseException
@function thrown when XMLSerializer cannot parse
}*/ 
public class XMLSerializerException extends LException {
    public XMLSerializerException(Exception ex) {
        super(ex);
    }
    public XMLSerializerException(Exception ex,Vector TagStack,Vector ObjectStack) 
    {
        super(buildErrorMessage(ex,TagStack,ObjectStack),ex);
    }
    
    protected static String buildErrorMessage(Exception ex, Vector TagStack, Vector ObjectStack) 
    {
        String[] Tags = new String[TagStack.size()];
        TagStack.toArray(Tags);
        Object[] Handlers = new Object[ObjectStack.size()];
        ObjectStack.toArray(Handlers);
        StringBuffer sb = new StringBuffer(256);
	sb.append("Error processing XML at:\n");
        for(int i = 0; i < Tags.length; i++) {
            sb.append("     Element: " + Tags[i]);
            if(Handlers.length > i )
                sb.append(" Handler: " + Handlers[i].getClass().getName());
           sb.append("\n");
        }
	sb.append("\n");
	//sb.append(ex.toString());
        return(sb.toString());
        
    }
    
}
