// in order to read files in internal Explorer we need to assert
// make a ms Security manager call
// import com.ms.security.*;

/**{ file
    @name FileUtilities.java
    @function FileUtilities offer a number of services relating to files including
         file dialog, directory enumerators and keeping track of open files
    @author> Steven M. Lewis
    @copyright>
	************************
	*  Copyright (c) 1996,97,98
	*  Steven M. Lewis
	*  www.LordJoe.com
	************************
    @date> Mon Jun 22 21:48:27 PDT 1998
    @version> 1.0
}*/
package com.lordjoe.utilities;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
/**{ class
    @name FileUtilities
    @function FileUtilities offer a number of services relating to files including
         file dialog, directory enumerators and keeping track of open files
}*/
public abstract class FileUtilities extends Nulleton {

    //- *******************
    //- Methods
    public static File[] EMPTY_FILES = new File[0];
    
    
    /**{ method
        @name getAllFiles
        @function get all the files in the directory
        @UnusedParam> FileName starting directory
        @param DirectoryName <Add Comment Here>
        @return the files
    }*/
    public static String[] getAllFiles(String DirectoryName) {
        return(getAllFilesWithFilter(DirectoryName,null));
    }

    /**{ method
        @name getFiles
        @function get all the files in the directory
        @UnusedParam> FileName starting directory
        @param DirectoryName <Add Comment Here>
        @return the files
    }*/
    public static String[] getFiles(String DirectoryName) {
        return(getFilesWithFilter(DirectoryName,null));
    }
    /**{ method
        @name expungeDirectory
        @function delete a directory and all its contents
        @param DirectoryName <Add Comment Here>
    }*/
    public static void expungeDirectory(String DirectoryName)
    {
        expungeDirectory(new File(DirectoryName));
    }
    
    /**{ method
        @name expungeDirectory
        @function delete a directory and all its contents
        @param DirectoryName <Add Comment Here>
    }*/
    public static void expungeDirectory(File TheDir)
    {
        if(TheDir.exists()) {
            expungeDirectoryContents(TheDir);
            TheDir.delete();
        }
        
    }
    /**{ method
        @name expungeDirectory
        @function delete a directory and all its contents
        @param DirectoryName <Add Comment Here>
    }*/
    public static void expungeDirectoryContents(File TheDir)
    {
        String[] items = TheDir.list();
        for(int i = 0; i < items.length; i++) {
            File Test = new File(TheDir,items[i]);
            if(Test.isFile()) {
                Test.delete();
            }
            else {
                expungeDirectory(Test);
            }
        }
                
    }

    /**{ method
        @name getAllDirectoriesWithExtension
        @function get all files ending in ext at current level
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Extension test extension
        @return the Files
    }*/
    public static String[] getAllDirectoriesWithExtension(String DirectoryName,String Extension) 
    {
        File TestFile = new File(DirectoryName);
        if(TestFile.isDirectory()) {
            Vector ret = new Vector();
            getAllDirectoriesWithExtension(TestFile,"",Extension,ret);
            String out[] = new String[ret.size()];
            for(int i = 0; i < ret.size(); i ++) {
                String TestString =(String) ret.elementAt(i);
                if(TestString.equals(""))
                     out[i] = DirectoryName;
                else
                    out[i] = TestString;
            }
            return(out);
        }
        else {
            return(new String[0]);
        }
    }
    
    /**{ method
        @name getAllDirectoriesWithExtension
        @function get all files ending in ext at current level
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Extension test extension
        @return the Files
    }*/
    protected static void getAllDirectoriesWithExtension(File Base,String DirectoryName,
            String Extension,Vector holder) 
    {
        File TestFile = new File(Base,DirectoryName);
        if(! TestFile.isDirectory()) {
            return;
        }
        if(hasFileWithExtension(TestFile,Extension))
                holder.addElement(DirectoryName);
        
        String[] Files = TestFile.list();   
        for(int j = 0; j < Files.length; j ++) {
            String test = pathConcat(DirectoryName,Files[j]);
            getAllDirectoriesWithExtension(Base,test,Extension,holder); 
        }
    }
    
    /**{ method
        @name getAllFilesWithName
        @function get all files ending in ext at current level
         @param DirectoryNamenon-null name of the base directory
        @param Name non-null requested file name
        @return the Files
    }*/
    public static String[] getAllFilesWithName(String DirectoryName,String Name) {
        FilenameFilter TheFilter =(FilenameFilter)(new EndsWithFilter(Name));
        return(getAllFilesWithFilter(DirectoryName,TheFilter));
    }

    /**{ method
        @name getAllFilesWithExtension
        @function get all files ending in ext at current level
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Extension test extension
        @return the Files
    }*/
    public static String[] getAllFilesWithExtension(String DirectoryName,String Extension) {
        if(Extension != null || Extension.length() == 0) {
            FilenameFilter TheFilter =(FilenameFilter)(new HasExtensionFilter(Extension));
            return(getAllFilesWithFilter(DirectoryName,TheFilter));
        }
        else {
            return(getAllFilesWithFilter(DirectoryName,null));
        }
    }
    /**{ method
        @name getAllFilesWithExtension
        @function get all files ending in ext at current level
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Extension test extension
        @return the Files
    }*/
    public static String[] getAllFilesWithExtension(File Directory,String Extension) {
        if(Extension != null || Extension.length() == 0) {
            FilenameFilter TheFilter =(FilenameFilter)(new HasExtensionFilter(Extension));
            return(getAllFilesWithFilter(Directory,TheFilter));
        }
        else {
            return(getAllFilesWithFilter(Directory,null));
        }
    }
    
    public static void renameAllFilesWithExtension(String DirectoryName,String Extension,String NewExtension) {
        String[] files = getAllFilesWithExtension(DirectoryName,Extension);
        for(int i = 0; i < files.length; i++)
            setExtension(files[i],NewExtension);
    }
    
    public static void setExtension(String FileName,String NewExtension) {
        File TheFile = new File(FileName);
        String NewName = getBaseName(FileName) + "." + NewExtension;
        TheFile.renameTo(new File(NewName));
    }
    
    public static String getBaseName(String FileName) {
        int index = FileName.lastIndexOf(".");
        if(index == -1)
            return(FileName);
         int sepIndex = FileName.lastIndexOf(File.pathSeparatorChar);
         if(index < sepIndex)
            return(FileName); // well I suppose directories can have .
         return(FileName.substring(0,index));
    }

    /**{ method
        @name hasFileWithExtension
        @function get all files at the current level passing the filter
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Extension filter to apply
        @return true if ends in extension
    }*/
    public static boolean hasFileWithExtension(String DirectoryName,String Extension) {
        File TestFile = new File(DirectoryName);
        return(hasFileWithExtension(TestFile,Extension));
    }
        
        
     /**{ method
        @name hasFileWithExtension
        @function get all files at the current level passing the filter
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Extension filter to apply
        @return true if ends in extension
    }*/
    public static boolean hasFileWithExtension(File TestFile,String Extension) {
       if(! TestFile.exists()) {
            return(false);
        }
        FilenameFilter TheFilter =(FilenameFilter)(new HasExtensionFilter(Extension));
        String[] Files = TestFile.list(TheFilter);
        if(Files == null) {
            return(false);
        }
        if(Files.length > 0) {
            return(true);
        }
        return(false);
    }

    /**{ method
        @name getLatestFileWithExtension
        @function return the latest date on a file in the directory having
        This was written as a utility to help makefile like programs
        the designated extension 
        @param Directory the directory
        @param Extension test extension
        @return latest modifiaction time
    }*/
    public static long getLatestFileWithExtension(File Directory,String Extension) {
         String[] Files = Directory.list();
         long ret = 0;
         for(int i = 0; i < Files.length; i++) {
            if(Files[i].endsWith(Extension)) {
                File test = new File(Directory,Files[i]);
                if(!test.isDirectory())
                    ret = Math.max(ret,test.lastModified());
            }
         }
         return(ret);
    }
    
    /**{ method
        @name getLatestFileFromList
        @function return the latest date on a file in the directory having
        This was written as a utility to help makefile like programs
        the designated extension 
        @param Directory the directory
        @param testNames File names to test
        @return latest modifiaction time
    }*/
    public static long getLatestFileFromList(File Directory,String[] testNames) {
         long ret = 0;
         for(int i = 0; i < testNames.length; i++) {
             File test = new File(Directory,testNames[i]);
             if(test.exists() && !test.isDirectory()) {
                ret = Math.max(ret,test.lastModified());
            }
         }
         return(ret);
    }

   /**{ method
        @name getAllFullClasses
        @function find classes in BuildBase path and not in CaptureBase path
        @param BuildBase directory of build path
        @return the array of classes present
    }*/
    public static String[] getAllFullClasses(String BuildBase) 
    {
        int BuildLength = BuildBase.length() + 1;
         String[] BuildClasses = FileUtilities.getAllFilesWithExtension(BuildBase, "class");
        Vector holder = new Vector();
        for(int i = 0; i <  BuildClasses.length; i++) {
            if(BuildClasses[i].indexOf("$") == -1)
                holder.addElement(BuildClasses[i].substring(BuildLength).replace('/','.'));
        }
        BuildClasses = new String[holder.size()];
        holder.copyInto(BuildClasses);
        return(BuildClasses);
    }
   /**{ method
        @name relativePath
        @function return a string representing the path of included file ret
        @param IncludedFile non-null existing file in UpperDirectory
        @param UpperDirectory non-null existing directory
        @return string representing the path of the fiel relatove to the directory
    }*/
    public static String relativePath(File IncludedFile,File UpperDirectory) 
    {
        if(!IncludedFile.exists())
            throw new IllegalArgumentException("requested file '" + IncludedFile.getAbsolutePath() + "' does not exist");
        if(!UpperDirectory.exists())
            throw new IllegalArgumentException("requested file '" + UpperDirectory.getAbsolutePath() + "' does not exist");
        if(!UpperDirectory.isDirectory())
            throw new IllegalArgumentException("requested directory '" + UpperDirectory.getAbsolutePath() + "' is not a directory");
        String ret = IncludedFile.getName();
        File Test = new File(IncludedFile.getParent());
        while(Test != null) {
            if(Test.equals(UpperDirectory)) 
                break;
            ret = Test.getName() + "/" + ret;
            Test = new File(Test.getParent());
        }
        if(Test == null)
            throw new IllegalArgumentException("directory '" + UpperDirectory.getAbsolutePath() + 
                "' is not a parent of file '" + IncludedFile.getAbsolutePath() + "'");
        return(ret);
    }

   /**{ method
        @name differenceJavaPaths
        @function find classes in BuildBase path and not in CaptureBase path
        @param BuildBase directory of build path
        @param BuildBase directory of capture path
        @return the array of classes present in BuildBase path and not CaptureBase
    }*/
    public static String[] differenceJavaPaths(String BuildBase,String CaptureBase) 
    {
        String[] BuildClasses = getAllFullClasses(BuildBase);
        String[] CapturedClasses = getAllFullClasses(CaptureBase);
        String[] UnCaptured = Util.differenceStringArrays(CapturedClasses,BuildClasses);
        return(UnCaptured);
    }

    /**{ method
        @name getFilesWithExtension
        @function recursively get all files ending in ext
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Extension test extension
        @return the array of files or null if none
    }*/
    public static String[] getFilesWithExtension(String DirectoryName,String Extension) {
        if(Extension != null) {
            FilenameFilter TheFilter =(FilenameFilter)(new EndsWithFilter(Extension));
            return(getFilesWithFilter(DirectoryName,TheFilter));
        }
        else {
            return(getFilesWithFilter(DirectoryName,null));
        }
    }
    /**{ method
        @name getDirectoriesWithName the idea is to put all resources in a subdirectory called res and then
           package all the contents in these subdirectories
        @function recursively get all files ending in ext
        @param DirectoryName <Add Comment Here>
        @param SubDirectoryName test name
        @return the array of files or null if none
    }*/
    public static String[] getDirectoriesWithName(String DirectoryName,String SubDirectoryName) {
        if(SubDirectoryName != null) {
            FilenameFilter TheFilter =(FilenameFilter)(new DirectoryNamedFilter(SubDirectoryName));
            return(getFilesWithFilter(DirectoryName,TheFilter));
        }
        else {
            return(getFilesWithFilter(DirectoryName,null));
        }
    }

    /**{ method
        @name getAllFilesWithFilter
        @function recursively get all files passing the filter
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Filter test to apply
        @return the array of files or null if none
    }*/
    public static String[] getAllFilesWithFilter(String DirectoryName,FilenameFilter Filter) {
        File TestFile = new File(DirectoryName);
        return(getAllFilesWithFilter(TestFile,Filter));
    }
    
    /**{ method
        @name getAllFilesWithFilter
        @function recursively get all files passing the filter
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Filter test to apply
        @return the array of files or null if none
    }*/
    public static String[] getAllFilesWithFilter(File TestFile,FilenameFilter Filter) 
    {
        String test;
        File Subfile;
        String SubFiles[];
        String Files[];
        Vector ret = new Vector();
        if(TestFile == null) {
            return(null);
        }
        if(! TestFile.isDirectory()) {
            String rfile[] = new String[1];
            rfile[0] = TestFile.getPath().replace('\\','/');
            return(rfile);
        }
        if(Filter == null) {
            Files = TestFile.list();
        }
        else {
            Files = TestFile.list(Filter);
        }
        for(int j = 0; j < Files.length; j ++) {
            Subfile = new File(TestFile,Files[j]);
            if(Subfile.isDirectory()) {
                SubFiles = getAllFilesWithFilter(Subfile,Filter);
                for(int k = 0; k < SubFiles.length; k ++) {
                    ret.addElement(SubFiles[k]);
                }
            }
            else {
                ret.addElement(Subfile.getPath().replace('\\','/'));
            }
        }
        String out[] = new String[ret.size()];
        for(int i = 0; i < ret.size(); i ++) {
            test =(String) ret.elementAt(i);
            out[i] = test;
        }
        return(out);
    }

    /**{ method
        @name getFilesWithFilter
        @function get all files at the current level passing the filter
        @UnusedParam> FileName start directory
        @param DirectoryName <Add Comment Here>
        @param Filter filter to apply
        @return the array of files or null if none
    }*/
    public static String[] getFilesWithFilter(String DirectoryName,FilenameFilter Filter) {
        File TestFile = new File(DirectoryName);
        String test;
        String Files[];
        Vector ret = new Vector();
        if(TestFile == null) {
            return(null);
        }
        if(! TestFile.isDirectory()) {
            String rfile[] = new String[1];
            rfile[0] = DirectoryName;
            return(rfile);
        }
        if(Filter == null) {
            Files = TestFile.list();
        }
        else {
            Files = TestFile.list(Filter);
        }
        for(int j = 0; j < Files.length; j ++) {
            test = pathConcat(DirectoryName,Files[j]);
            ret.addElement(test);
        }
        String out[] = new String[ret.size()];
        for(int i = 0; i < ret.size(); i ++) {
            test =(String) ret.elementAt(i);
            out[i] = test;
        }
        return(out);
    }

    /**{ method
        @name getAllSubDirectories
        @function return the names of all subdirectories at all levels
        @UnusedParam> FileName starting directory
        @param DirectoryName <Add Comment Here>
        @return the array of files or null if none
    }*/
    public static String[] getAllSubDirectories(String DirectoryName) {
        File TestFile = new File(DirectoryName);
        String test;
        File Subfile;
        String SubFiles[];
        String Files[];
        Vector ret = new Vector();
        if(TestFile == null || ! TestFile.isDirectory()) {
            return(null);
        }
        Files = TestFile.list();
        for(int j = 0; j < Files.length; j ++) {
            test = pathConcat(DirectoryName,Files[j]);
            Subfile = new File(test);
            if(Subfile.isDirectory()) {
                SubFiles = getAllSubDirectories(test);
                if(SubFiles != null) {
                    for(int k = 0; k < SubFiles.length; k ++) {
                        ret.addElement(SubFiles[k]);
                    }
                }
                ret.addElement(test);
            }
        }
        String out[] = new String[ret.size()];
        for(int i = 0; i < ret.size(); i ++) {
            test =(String) ret.elementAt(i);
            out[i] = test;
        }
        return(out);
    }

    /**{ method
        @name findWildCardFile
        @function Search a directory for files matching a name with wild cards - i.e. *.java
        @param FileName file name - may have wild cards
        @return the first matching file or null for no match
        @see #findWildCardFile
    }*/
    static public String findWildCardFile(String FileName) {
        String DirectoryName = fileNameToDirectoryName(FileName);
        String FileStub = FileName.substring(DirectoryName.length() + 1,FileName.length());
        return(findWildCardFile(DirectoryName,FileStub));
    }

    /**{ method
        @name findWildCardFile
        @function Search a directory for files matching a name with wild cards - i.e. *.java
        @param DirectoryName directory to search
        @param FileStub file name may have wild cards
        @return the first matching file or null for no match
        @see #findWildCardFile
    }*/
    static public String findWildCardFile(String DirectoryName,String FileStub) {
        File Directory = new File(DirectoryName);
        if(! Directory.exists() || ! Directory.isDirectory()) {
            return(null);
        }
        String[] AllFiles = Directory.list();
        for(int i = 0; i < AllFiles.length; i ++) {
            String test = AllFiles[i].substring(0,FileStub.length());
            if(FileStub.equalsIgnoreCase(test)) {
                return(AllFiles[i]);
            }
        }
        return(null);
    }

    /**{ method
        @name fileNameToDirectoryName
        @function get the directory of a file name i.e. C:/foo/bar/myfile.txt -> C:/foo/bar
        @param FileName file name to parse
        @return directory name
    }*/
    static public String fileNameToDirectoryName(String FileName) {
        int TheIndex = FileName.lastIndexOf(File.pathSeparatorChar);
        if(TheIndex == - 1) {
            return(FileName);
        }
        return(FileName.substring(0,TheIndex - 1));
    }
    
    /**{ method
        @name readInParagraphs
        @function reads all the data in a file into an array of strings - one per 
        paragraph where paragraphs are a blank line
        @param FileName the file name
        @return - array or strings - null if file empty or does not exist
    }*/
    public static String[] readInParagraphs(String FileName) {
        String Text = readInFile(FileName);
        if(Text == null)
            return(null);
        String[] items = Util.parseLinesWithBlanks(Text);
        ArrayList holder = new ArrayList();
        StringBuffer sb = new StringBuffer();
        for(int i = 0; i < items.length; i++) {
            String Text1 = items[i]; 
            if(Text1.length() == 0) {
                if(sb.length() > 0) {
                    holder.add(sb.toString());
                    sb.setLength(0);
                }
            }
            else {
                if(sb.length() > 0) 
                    sb.append("\n");
                sb.append(items[i]);
            }
        }
        if(sb.length() > 0) 
            holder.add(sb.toString());
            
        return((String[])holder.toArray(Util.EMPTY_STRING_ARRAY));
    }

    /**{ method
        @name readInLines
        @function reads all the data in a file into an array of strings - one per line
        @param FileName the file name
        @return - array or strings - null if file empty or does not exist
    }*/
    public static String[] readInLines(String FileName) {
        String s = readInFile(FileName);
        if(s != null) {
            String[] Lines = Util.parseLines(s);
            Lines = nonEmptyStrings(Lines);
            return(Lines);
        }
        return(null);
    }
    
    /**{ method
        @name readInLines
        @function reads all the data in a file into an array of strings - one per line
        @param FileName the file name
        @return - array or strings - null if file empty or does not exist
    }*/
    public static String[] readInLines(Reader TheFile) {
        LineNumberReader r = new LineNumberReader(TheFile);
        java.util.List holder = new ArrayList();
        try {
            String s = r.readLine();
            while(s != null) {
                holder.add(s);
                s = r.readLine();
            }
            String[] ret = new String[holder.size()];
            holder.toArray(ret);
            TheFile.close();
            return(ret);
        }
        catch(IOException ex) {
            throw new IllegalStateException();
        }
    }
    
    public static Reader readerFromLines(String[] lines) {
        String allLines = buildString(lines);
        return(new StringReader(allLines));
    }
    
    
    public static String buildString(String[] lines)
    {
        StringBuffer sb = new StringBuffer(2048);
        for(int i = 0; i < lines.length; i++) {
            sb.append(lines[i]);
            sb.append("\n");
        }
        return(sb.toString());
    }

    /**{ method
        @name readInResourceLines
        @function reads all the data in a file into an array of strings - one per line
        @param source - class for resource
        @param FileName the file name
        @return - array or strings - null if file empty or does not exist
    }*/
    public static String[] readInResourceLines(Class source,String FileName) {
        String s = readInResource(source,FileName);
        if(s != null) {
            String[] Lines = Util.parseLines(s);
            Lines = nonEmptyStrings(Lines);
            return(Lines);
        }
        return(null);
    }

    /**{ method
        @name readInFile
        @function reads all the data in a file into a stringbuffer
        @param FileName the file name
        @return StringBuffer holding file bytes
    }*/
    public static String readInFile(String FileName) {
        File TestFile = new File(FileName);
        return(readInFile(TestFile));
    }
    

    /**{ method
        @name readInFile
        @function reads all the data in a file into a stringbuffer
        @param TestFile non-null Test file - may not exist
        @return String holding file bytes
    }*/
    public static String readInFile(File TestFile) {
        if(!TestFile.exists())
            return(null); // no can find 
        if(!TestFile.canRead())
            return(null); // no can read
        int len = (int)TestFile.length();
            
        try {
            // Microsoft approach only in j++
            // Assert the right to perform file I/O
            // PolicyEngine.assertPermission(PermissionID.FILEIO);
            FileInputStream TheFile = new FileInputStream(TestFile);
            // choose large chunks
            return(readInFile(TheFile,len,4096).toString());
        }
        catch(SecurityException e) {
            Developer.report("Security Exception reading File - " + TestFile.getPath().replace('\\','/'));
            return(null);
        }
        catch(Exception e) {
            return(null);
        }
    }

    /**{ method
        @name readInResource
        @function reads all the data in a resource into a stringbuffer
        @param Source - class for resource
        @param name the file name
        @return StringBuffer holding file bytes - null if resource not found
    }*/
    public static String readInResource(Class Source,String name) {
        InputStream in = Source.getResourceAsStream(name);
        if(in != null)
            return(readInFile(in));
        return(null);
    }
    /**{ method
        @name readInFile
        @function reads all the data in a file into a stringbuffer
        @param TheFile the file stream
        @return StringBuffer holding file bytes
    }*/
    public static String readInFile(Reader TheFile) 
    {
        return(readInFile(TheFile,4096,1).toString());
    }
    /**{ method
        @name readInFile
        @function reads all the data in a file into a stringbuffer
        @param TheFile the file stream
        @param len the file length or a good guess
        @return StringBuffer holding file bytes
    }*/
    public static StringBuffer readInFile(Reader TheFile,int len,int chunk) 
    {
        BufferedReader TheStream = null;
        StringBuffer s = new StringBuffer(len);
        char[] buffer = new char[chunk];
        int NRead = 0;
        try {
            TheStream = new BufferedReader(TheFile);
            NRead = TheStream.read(buffer,0,chunk);
            while(NRead != - 1) {
                s.append(buffer,0,NRead);
                NRead = TheStream.read(buffer,0,chunk);
                // ought to look at non-printing chars
            }
            TheStream.close();
        }
        catch(IOException ex) {
            Assertion.fatalException(ex);
        }
        return(s);
    }
    
    /**{ method
        @name readInFile
        @function reads all the data in a file into a stringbuffer
        @param TheFile the file stream
        @return StringBuffer holding file bytes
    }*/
    public static String readInFile(InputStream TheFile) 
    {
        return(readInFile(TheFile,4096,1).toString());
    }
    /**{ method
        @name readInFile
        @function reads all the data in a file into a stringbuffer
        @param TheFile the file stream
        @param len the file length or a good guess
        @return StringBuffer holding file bytes
    }*/
    public static StringBuffer readInFile(InputStream TheFile,int len,int chunk) 
    {
        BufferedReader TheStream = null;
        StringBuffer s = new StringBuffer(len);
        char[] buffer = new char[chunk];
        int NRead = 0;
        try {
            TheStream = new BufferedReader(new InputStreamReader(TheFile));
            NRead = TheStream.read(buffer,0,chunk);
            while(NRead != - 1) {
                s.append(buffer,0,NRead);
                NRead = TheStream.read(buffer,0,chunk);
                // ought to look at non-printing chars
            }
            TheStream.close();
        }
        catch(IOException ex) {
            Assertion.fatalException(ex);
        }
        return(s);
    }
    /**{ method
        @name getResourceIcon
        @function read an Icon as a Resource
        @param target -  Object holding resource
        @param name the file name
        @return Icon for the resource possibly null
    }*/
    public static Icon getResourceIcon(Object target,String name) {
        return(getResourceIcon(target.getClass(),name));
    }
    
    /**{ method
        @name getResourceIcon
        @function read an Icon as a Resource
        @param target -  Class holding resource
        @param name the file name
        @return Icon for the resource possibly null
    }*/
    public static Icon getResourceIcon(Class target,String name) 
    {
        try {
            // Netscape appears not to support getResource so this 
            // reads an image from a resource 
            // 
  
            InputStream is = target.getResourceAsStream(name); 
            if (is == null) { 
                System.err.println("Resource not found. " + name + 
                    " as Reference in class " + target.getName()); 
                return(null); 
            } 
            ByteArrayOutputStream baos = new ByteArrayOutputStream(); 
             int c; 
            while((c = is.read()) >= 0) 
                baos.write(c); 
            is.close();
            Image TheActualImage = Toolkit.getDefaultToolkit().createImage(baos.toByteArray()); 
            Icon TheImage = new ImageIcon(TheActualImage);
            return(TheImage);
        }
        catch(IOException e) 
        { 
            return(null);
        }
        catch(Exception ex) {
          //  return(SecurityUtilities.secureGetResourceIcon(target,name) );
          return(null);
        }
    }
    
    /**{ method
        @name stringsToFile
        @function reads all the data in a file into an array of strings - one per line
        @param FileName the file name
        @param lines the file data - useing toString method
        @return - true for success
    }*/
    public static boolean stringsToFile(String FileName,Object[] lines) {
        try {
            PrintWriter out = new PrintWriter(new FileOutputStream(FileName));
            for(int i = 0; i < lines.length; i++) 
                out.println(lines[i]);
            out.close();
            return(true);
        }
        catch(IOException ex) {
            return(false);
        }
    }

    /**{ method
        @name readChar
        @function get one char from an input stream without throwing an exception
        @param TheStream the stream
        @return the char
    }*/
    public static int readChar(BufferedInputStream TheStream) {
        int ret = 0;
        try {
            ret = TheStream.read();
        }
        catch(IOException e) {
            ret = - 1;
        }
        return(ret);
    }

    /**{ method
        @name UnixNameFilter
        @function convert pc style filenames foo\bar to unix style foo/bar
        @param Name input name
        @return Filtered file name
    }*/
    public static String UnixNameFilter(String Name) {
        if(Name == null) {
            return(null);
        }
        return(Name.replace('\\','/'));
    }

    /**{ method
        @name baseFileName
        @function peal off name+extension of a full path i.e. C:/foo/bar/myFile.txt => myFile.txt
        @param Name the full path
        @return the base name
    }*/
    public static String baseFileName(String Name) {
        int index = Name.lastIndexOf(File.separatorChar);
        if(index >= 0) {
            return(Name.substring(index + 1));
        }
        if(File.separatorChar == '\\') {
            index = Name.lastIndexOf('/');
            if(index >= 0) {
                return(Name.substring(index + 1));
            }
        }
        index = Name.lastIndexOf(File.pathSeparatorChar);
        if(index >= 0) {
            return(Name.substring(index + 1));
        }
        return(Name);
    }

    /**{ method
        @name baseFromName
        @function given the base directory (part of full path)
             return the rest of the path - for example if Name = "C:/foo/bar/pickle/Myfile.txt"
             and Base = "C:/foo" return "bar/pickle/Myfile.txt"
        @param Name full path
        @param Base part to drop
        @return filtered name
    }*/
    public static String baseFromName(String Name,String Base) {
        if(Name.indexOf(Base) == - 1) {
            return(Name);
        }
        int l = Base.length();
        if(Name.length() == l) {
            return("");
        }
        char c = Name.charAt(l);
        // drop any separator
        if(c == File.separatorChar || c == '/') {
            l ++;
        }
        return(Name.substring(l));
    }

    /**{ method
        @name pathName
        @function pull out all directories dropping filename + ext
             for example if Name = "C:/foo/bar/pickle/Myfile.txt" return
             "C:/foo/bar/pickle"
        @param Name full path
        @return filtered name
    }*/
    public static String pathName(String Name) {
        int index = Name.lastIndexOf(File.separatorChar);
        if(index >= 0) {
            return(Name.substring(0,index));
        }
        if(File.separatorChar == '\\') {
            index = Name.lastIndexOf('/');
            if(index >= 0) {
                return(Name.substring(0,index));
            }
        }
        index = Name.lastIndexOf(File.pathSeparatorChar);
        if(index >= 0) {
            return(Name.substring(0,index));
        }
        return("");
        // no path
    }

    /**{ method
        @name pathConcat
        @function add path and file name or path and subpath adding separator
             if needed For example if s1 = "C:/foo/bar" and s2 = "Myfile.txt"
             return "C:/foo/bar/Myfile.txt"
        @param s1 path
        @param s2 file
        @return filtered name
    }*/
    static public String pathConcat(String s1,String s2) {
        if(s1 == null || s1.length() == 0) {
            return(s2);
        }
        if(s2 == null || s2.length() == 0) {
            return(s1);
        }
        char lastchar = s1.charAt(s1.length() - 1);
        if(lastchar == File.separatorChar || lastchar == '/') {
            return(s1 + s2);
        }
        else {
            return(s1 + "/" + s2);
        }
    }

    /**{ method
        @name guaranteeDirectory
        @function given a path which should represent a directory
             create as many levels of directory as needed to make the
             directory exist
        @param FileName path with directory
        @return true for success
    }*/
    public static boolean guaranteeDirectory(String FileName) {
        String DirName = pathName(FileName);
        if(DirName.length() == 0)
            return(true);
        File testDir = new File(DirName);
        if(testDir.exists()) {
            if(! testDir.isDirectory()) {
                return(false);
            }
            // name is file
            else {
                return(true);
            }
            // exists - is directory
        }
        if(guaranteeDirectory(DirName)) {
            return(testDir.mkdir());
        }
        return(false);
        // no can do
    }

    /**{ method
        @name openPrintWriter
        @function open a PrintWriter to a file with name
        @param name name of file
        @return the stream - null for failure
    }*/
    public static PrintWriter openPrintWriter(String name) {
        FileOutputStream file = null;
        try {
            file = new FileOutputStream(name);
           return new PrintWriter(new BufferedOutputStream(file));
        }
        catch(SecurityException ee) {
            return(null);
        }
        catch(IOException ee) {
            return(null);
        }
    }
    /**{ method
        @name openPrintWriter
        @function open a PrintWriter to a file with name
        @param name name of file
        @return the stream - null for failure
    }*/
    public static PrintWriter openPrintWriter(File name) {
        FileOutputStream file = null;
        try {
            file = new FileOutputStream(name);
           return new PrintWriter(new BufferedOutputStream(file));
        }
        catch(SecurityException ee) {
            return(null);
        }
        catch(IOException ee) {
            return(null);
        }
    }

    /**{ method
        @name openPrintWriter
        @function open a PrintStream to a file with name
        @param name name of file
        @return the stream - null for failure
    }*/
    public static PrintStream openPrintStream(String name) {
        FileOutputStream file = null;
        try {
            file = new FileOutputStream(name);
        }
        catch(Exception ee) {
            return(null);
        }
        return new PrintStream(new BufferedOutputStream(file));
    }

    /**{ method
        @name writeFile
        @function write the string data to the file Filename
        @param FileName name of file to create
        @param data date to write
        @return true = success
    }*/
    public static boolean writeFile(String FileName,String data) {
        try {
            PrintWriter out = openPrintWriter(FileName);
            if(out != null) {
                out.print(data);
                out.close();
                return(true);
            }
            return(false);
            // failure
        }
        catch(SecurityException ex) {
            return(false); // browser disallows
        }
    }

    /**{ method
        @name writeFile
        @function write the string data to the file Filename
        @param FileName name of file to create
        @param data date to write
        @return true = success
    }*/
    public static boolean writeFile(File TheFile,String data) {
        try {
            PrintWriter out = openPrintWriter(TheFile);
            if(out != null) {
                out.print(data);
                out.close();
                return(true);
            }
            return(false);
            // failure
        }
        catch(SecurityException ex) {
            return(false); // browser disallows
        }
    }
    /**{ method
        @name writeFileLines
        @function write the string data to the file Filename
        @param FileName non-null name of file to create
        @param data non-null array of lines to write
        @return true = success
    }*/
    public static boolean writeFileLines(String FileName,String[] data) {
        try {
            PrintWriter out = openPrintWriter(FileName);
            if(out != null) {
                for(int i = 0; i < data.length; i++) 
                    out.println(data[i]);
                out.close();
                return(true);
            }
            return(false);
            // failure
        }
        catch(SecurityException ex) {
            return(false); // browser disallows
        }
    }

    /**{ method
        @name printIndent
        @function add indent blanks to out - this is more efficient than adding one char
             at a time (I hope)
        @param out output stream
        @param indent blanks to add
    }*/
    public static void printIndent(PrintWriter out) {
        printIndent(out,4);
    }

    /**{ method
        @name printIndent
        @function add indent blanks to out - this is more efficient than adding one char
             at a time (I hope)
        @param out output stream
        @param indent blanks to add
    }*/
    public static void printIndent(PrintWriter out,int indent) {
        if(indent <= 0) {
            return;
        }
        out.print(Util.stringOfBlanks(indent));
    }

    /**{ method
        @name printIndent
        @function add indent blanks to out - this is more efficient than adding one char
             at a time (I hope)
        @param out output stream
        @param indent blanks to add
    }*/
    public static void printIndent(PrintStream out,int indent) {
        if(indent <= 0) {
            return;
        }
        out.print(Util.stringOfBlanks(indent));
    }

    /**{ method
        @name copyFile
        @function copy file named src into new file named dst
        @param dst destination file name
        @param src source file name
        @return true for success
    }*/
    public static boolean copyFile(String src,String dst) {
        int bufsize = 1024;
        try {
            RandomAccessFile srcFile = new RandomAccessFile(src,"r");
            long len = srcFile.length();
            if(len > 0x7fffffff) {
                return(false);
            }
            // too large
            int l =(int) len;
            if(l == 0) {
                return(false);
            }
            // failure - no data
            RandomAccessFile dstFile = new RandomAccessFile(dst,"rw");
            int start = 0;
            byte[] buffer = new byte[bufsize];
            while(start + bufsize < l) {
                srcFile.read(buffer,start,bufsize);
                dstFile.write(buffer,start,bufsize);
                start += bufsize;
            }
            int del = l - start;
            if(del > 0) {
                srcFile.read(buffer,start,del);
                dstFile.write(buffer,start,del);
            }
            srcFile.close();
            dstFile.close();
            return(true);
            // success
        }
        catch(IOException ex) {
            return(false);
        }
    }

    /**{ method
        @name renameFile
        @function <Add Comment Here>
        @param oldFile <Add Comment Here>
        @param newFileName <Add Comment Here>
        @param overwrite <Add Comment Here>
        @return <Add Comment Here>
    }*/
    public static boolean renameFile(String oldFile,String newFileName,boolean overwrite) {
        try {
            File realOldFile = new File(oldFile);
            boolean ret = false;
            if(! realOldFile.exists()) {
                return(false);
            }
            // cannot rename non-existant file
            File realNewFile = new File(newFileName);
            if(realNewFile.exists()) {
                if(! overwrite) {
                    return(false);
                }
                // failure overwrite not allowed
                else {
                    try {
                        ret = realNewFile.delete();
                        realNewFile = new File(newFileName);
                    }
                    catch(Exception ex) {
                        Assertion.doNada();
                    }
                }
            }
            ret = realOldFile.renameTo(realNewFile);
            return(ret);
        }
        catch(Exception ex) {
            return(false);
        }
    }

    /**{ method
        @name alphabetizeFile
        @function copy contenst of a file called inFileName to
             a file called outFileName sorting in alphabetical order
        @UnusedParam> iniFileName name of the input file
        @param inFileName <Add Comment Here>
        @param outFileName name of the output file
    }*/
    public static void alphabetizeFile(String inFileName,String outFileName) {
        String s = FileUtilities.readInFile(inFileName);
        if(s != null) {
            String[] Lines = Util.parseLines(s);
            Lines = nonEmptyStrings(Lines);
            Util.sort(Lines);
            PrintWriter out = openPrintWriter(outFileName);
            for(int i = 0; i < Lines.length; i ++) {
                if(Lines[i].length() > 0) {
                    out.println(Lines[i]);
                }
            }
            out.close();
        }
    }

    public static boolean hasExtension(File TheFile,String ext)
    {
        String Test = ext;
        if(!ext.startsWith("."))
            Test = "." + ext;
       if(osIsCaseSensitive()) {
            return(TheFile.getName().endsWith(Test));
        }
        else {
            String TestName = TheFile.getName().toLowerCase();
            return(TestName.endsWith(Test.toLowerCase()));
       }
    }
    
    private static Boolean gOSIsCaseSensitive;
    public static boolean osIsCaseSensitive()
    {
        if(gOSIsCaseSensitive == null) {
            String osName = System.getProperty("os.name").toLowerCase();
            gOSIsCaseSensitive = new Boolean(osName.indexOf("windows") == -1);
        }
        return(gOSIsCaseSensitive.booleanValue());
    }
    
    private static Boolean gOSIsWindows;
    public static boolean osIsWindows()
    {
        if(gOSIsWindows == null) {
            String osName = System.getProperty("os.name").toLowerCase();
            gOSIsWindows = new Boolean(osName.indexOf("windows") == -1);
        }
        return(gOSIsWindows.booleanValue());
    }
//
// Drop empty strings from lines

    /**{ method
        @name nonEmptyStrings
        @function <Add Comment Here>
        @param Lines <Add Comment Here>
        @return <Add Comment Here>
    }*/
    public static String[] nonEmptyStrings(String[] Lines) {
        Vector accumulate = new Vector();
        for(int i = 0; i < Lines.length; i ++) {
            if(! Util.isEmptyString(Lines[i])) {
                accumulate.addElement(Lines[i]);
            }
        }
        String[] out = new String[accumulate.size()];
        accumulate.copyInto(out);
        return(out);
    }

    public static PrintStream makePrintStream(String in) 
    {
       try {
            FileOutputStream outFile = new FileOutputStream(in);
            return(new PrintStream(outFile));
       }
       catch(IOException ex) {
            Assertion.fatalException(ex);
            return(null);
       }
    }
    
    public static void dupFile(String infile,String outfile) throws IOException
    {
        FileReader in = new FileReader(infile);
        FileWriter out = new FileWriter(outfile);
        copyStream(in,out);
    }
    
    public static void dupFile(String infile,Writer out) throws IOException
    {
        FileReader in = new FileReader(infile);
        copyStream(in,out);
    }
    
    public static void dupFile(Reader in,String outfile) throws IOException
    {
        FileWriter out = new FileWriter(outfile);
        copyStream(in,out);
    }
    
    public static void copyStream(Reader in,Writer out) throws IOException
    {
        char[] buffer = new char[2048];
        int nread;
        try {
            nread = in.read(buffer);
            while(nread > 0) {
                out.write(buffer, 0, nread);
                nread = in.read(buffer);
            }
        }
        finally {
            in.close();
            out.close();
        }
    }

    
    /**{ method
        @name getMostRecentFileDate
        @function get all the files in the directory
        @param DirectoryName - non-null Directory name will not recurse
        @return largest lastModified Date - 0 for empty or nonexistant directories
    }*/
    public static long getMostRecentFileDate(String DirectoryName) {
        return(getMostRecentFileDate(DirectoryName,false)); // do not recurse
    }
    
    /**{ method
        @name getMostRecentFileDate
        @function get all the files in the directory
        @param DirectoryName - non-null Directory name will not recurse
        @param recurse - if true recurse to subdirectories - else ignore subdirectories
       @return largest lastModified Date - 0 for empty or nonexistant directories
    }*/
    public static long getMostRecentFileDate(String DirectoryName,boolean recurse) 
    {
        File TestFile = new File(DirectoryName);
        String Files[];
        long ret = 0;
        if(!TestFile.exists() ) {
            return(ret);
        }
        if(!TestFile.isDirectory())
            throw new IllegalArgumentException("Name " + DirectoryName + " must be a directory");

         Files = TestFile.list();
         
         for(int i = 0; i < Files.length; i++) {
            File test = new File(TestFile,Files[i]);
            if(!test.isDirectory()) {
                ret = Math.max(ret,test.lastModified());
            }
            else { 
                if(recurse)
                    ret = Math.max(ret,getMostRecentFileDate(Files[i],recurse));
            }
         }
         return(ret);
    }
    /**{ method
        @name getFilesAfterDate
        @function get all the files in the directory after date
        @param DirectoryName - non-null Directory name will not recurse
        @param date - modified date
        @return largest lastModified Date - 0 for empty or nonexistant directories
    }*/
    public static File[] getFilesAfterDate(String DirectoryName,long date) {
        return(getFilesAfterDate(DirectoryName,date,false)); // do not recurse
    }
    /**{ method
        @name assertFileEsists
        @function easy way to handle errors on a file the program needs
        @param FileName - non-null name of an existing file
        @throws AssertionFailureException if the file does not exists
    }*/
    public static void assertFileExists(String FileName)
    {
        File Test = new File(FileName);
        if(!Test.exists()) {
           String msg = "File " + FileName + " is required and cannot be found";
           System.err.println(msg);
           Assertion.fatalError(msg);
        }
        if(!Test.canRead()) {
           String msg = "File " + FileName + " is required and cannot be read";
           System.err.println(msg);
           Assertion.fatalError(msg);
        }
    }
    
    /**{ method
        @name getFilesAfterDate
        @function get all the files in the directory after date
        @param DirectoryName - non-null Directory name will not recurse
        @param date - modified date
        @param recurse - if true recurse to subdirectories - else ignore subdirectories
        @return - non-null array of qualifying files
    }*/
    public static File[] getFilesAfterDate(String DirectoryName,long date,boolean recurse) {
        File TestFile = new File(DirectoryName);
        if(!TestFile.exists() )  
            return(EMPTY_FILES);
        if(!TestFile.isDirectory())
            throw new IllegalArgumentException("Name " + DirectoryName + " must be a directory");
        Vector holder = new Vector(100);
        accumulateFilesAfterDate(TestFile,date,recurse,holder); // do not recurse
        return((File[])Util.vectorToArray(holder,File.class));
    }
    
    /**{ method
        @name accumulateFilesAfterDate
        @function add all files after date to holder
        @param TestFile - non-null File representing an existing directory
        @param date - modified date
        @param recurse - if true recurse to subdirectories - else ignore subdirectories
        @param holder -  non-null vector accumulating files
    }*/
    protected static void accumulateFilesAfterDate(File TestFile,long date,boolean recurse,
        Vector holder) 
    {
        String[] Files = TestFile.list();
         
         for(int i = 0; i < Files.length; i++) {
            File test = new File(TestFile,Files[i]);
            if(!test.isDirectory()) {
                if(test.lastModified() > date)
                    holder.addElement(test);
            }
            else {
                if(recurse) {
                    accumulateFilesAfterDate(test,date,recurse,holder);
                }
            }
         }
    }
    
    /**
    * This serializes an object to a file
    * @param in - non-null object to Serialize
    * @param FileName - non-null file name
    */
    public static void serializeObject(Serializable in,String FileName)
    {
        try { 
            FileOutputStream fout = new FileOutputStream(FileName);
            ObjectOutputStream out = new ObjectOutputStream(fout);
            out.writeObject(in);
            out.close();
        }
        catch(IOException ex) {
            Assertion.fatalException(ex);
        }
            
    }
    /**
    * This serializes an object to a file
    * @param in - non-null object to Serialize
    * @param FileName - non-null file name
    */
    public static Object deserializeObject(String FileName)
    {
        try { 
            FileInputStream fout = new FileInputStream(FileName);
            ObjectInputStream in = new ObjectInputStream(fout);
            Object ret = in.readObject();
            in.close();
            return(ret);
        }
        catch(ClassNotFoundException ex) {
            Assertion.fatalException(ex);
        }
        catch(IOException ex) {
            Assertion.fatalException(ex);
        }
        return(null);
            
    }
    /**
    * This serializes an object to a file
    * @param in - non-null object to Serialize
    * @param FileName - non-null creatable File
    */
    public static void serializeObject(Serializable in,File TheFile)
    {
        try { 
            FileOutputStream fout = new FileOutputStream(TheFile);
            ObjectOutputStream out = new ObjectOutputStream(fout);
            out.writeObject(in);
            out.close();
        }
        catch(IOException ex) {
            Assertion.fatalException(ex);
        }
            
    }
    /**
    * This serializes an object to a file
    * @param in - non-null object to Serialize
    * @param FileName - non-null existing file holding a serialized object
    */
    public static Object deserializeObject(File TheFile)
    {
        try { 
            FileInputStream fout = new FileInputStream(TheFile);
            ObjectInputStream in = new ObjectInputStream(fout);
            Object ret = in.readObject();
            in.close();
            return(ret);
        }
        catch(ClassNotFoundException ex) {
            Assertion.fatalException(ex);
        }
        catch(IOException ex) {
            Assertion.fatalException(ex);
        }
        return(null);
            
    }
    public static FilenameFilter getExtensionFilter(String ext) {
        return(new HasExtensionFilter(ext));
    }
    
    public static void downloadBinary(URL BaseURL,String Name,File TargetDirectory) throws IOException
    {
        URL TheURL = new URL(BaseURL,Name);
        File TestFile = new File(TargetDirectory,Name);
        downloadBinary(TheURL,TestFile);
    }
    
    public static void downloadBinary(URL TheURL,File TestFile) throws IOException
    {
        OutputStream outf = new FileOutputStream(TestFile);
        String test = TheURL.toString();
        System.out.println(test);
        InputStream in = TheURL.openStream();
        downloadBinary(in,outf);
    }
    
    
    public static void downloadBinary(InputStream ins,OutputStream outf) throws IOException
    {
        byte[] holder = new byte[4096];
        InputStream in = new BufferedInputStream(ins);
        OutputStream out = new BufferedOutputStream(outf);
        int Nread = in.read(holder);
        while(Nread > -1) {
            out.write(holder, 0, Nread);
            Nread = in.read(holder);
        }
        in.close();
        out.close();
    }
     
    /** 
    * @param name non-null name of an existing readable file
    * @return non-null IpuptStream
    * @throws IllegalArgumentException on error
    */
    public static InputStream getInputStream(String name)
    {
        File TheFile = new File(name);
	return getInputStream(TheFile);
    }

    public static InputStream getInputStream(File TheFile)
    {
	validateReadableFile(TheFile);
        try {
            InputStream in = new FileInputStream(TheFile);
            return(in);
        }
        catch(FileNotFoundException ex) {
            String Fullpath = TheFile.getAbsolutePath();
            throw new IllegalStateException("Requested File '" + Fullpath + "' does not exist -  but has been tested - HUH???");
        }
    }
    
  
    /** 
    * @param name non-null name of an existing readable file
    * @return non-null existing readable file
    * @throws IllegalArgumentException on error
    */
    public static File getReadableFile(String name)
    {
        File TheFile = new File(name);
	validateReadableFile(TheFile);
	return TheFile;
    }

    public static void  validateReadableFile(File TheFile)
    {
        if(!TheFile.exists()) {
            String Fullpath = TheFile.getAbsolutePath();
            throw new IllegalArgumentException("Requested File '" + Fullpath + "' does not exist");
        }
        if(!TheFile.canRead()) {
            String Fullpath = TheFile.getAbsolutePath();
            throw new IllegalArgumentException("Requested File '" + Fullpath + "' cannot be read");
        }
        if(TheFile.isDirectory()) {
            String Fullpath = TheFile.getAbsolutePath();
            throw new IllegalArgumentException("Requested File '" + Fullpath + "'is a directory");
        }
    }
    
    
//- *******************
//- End Class FileUtilities
}
/**{ class
    @name HasExtensionFilter
    @function a file name filter which chooses files ending with a
         string - usually an extension
}*/
class HasExtensionFilter implements FilenameFilter {

    //- *******************
    //- Fields
    /**{ field
        @name extension
        @function the test string
    }*/
    private String extension;


    //- *******************
    //- Methods
    /**{ constructor
        @name HasExtensionFilter
        @function Constructor of HasExtensionFilter
        @param e test string
    }*/
    public HasExtensionFilter(String e) {
        if(! e.startsWith(".")) {
            extension = "." + e;
        }
        else {
            extension = e;
        }
}

    /**{ method
        @name accept
        @function test if file should pass filter i.e has proper extension or is
             ending
        @param dir the test directory
        @param name thes name of file in directory dir
        @return true if file passes test
        @policy rarely override
        @primary
    }*/
    public boolean accept(File dir,String name) {
        if(name.endsWith(extension))
            return(true);
        return(new File(dir,name).isDirectory());
    }
    


//- *******************
//- End Class HasExtensionFilter
}
/**{ class
    @name EndsWithFilter
    @function a file name filter which chooses files ending with a
         string - usually an extension
}*/
class EndsWithFilter implements FilenameFilter {

    //- *******************
    //- Fields
    /**{ field
        @name extension
        @function the test string
    }*/
    private String extension;


    //- *******************
    //- Methods
    /**{ constructor
        @name EndsWithFilter
        @function Constructor of EndsWithFilter
        @param e test string
    }*/
    public EndsWithFilter(String e) {
        extension = e;
}

    /**{ method
        @name accept
        @function test if file should pass filter i.e has proper extension or is
             ending
        @param dir the test directory
        @param name thes name of file in directory dir
        @return true if file passes test
        @policy rarely override
        @primary
    }*/
    public boolean accept(File dir,String name) {
        if(name.endsWith(extension)) {
            return(true);
        }
        return(new File(dir,name).isDirectory());
    }


//- *******************
//- End Class EndsWithFilter
}

/**{ class
    @name EndsWithFilter
    @function a file name filter which chooses files ending with a
         string - usually an extension
}*/
class DirectoryNamedFilter implements FilenameFilter {

    //- *******************
    //- Fields
    /**{ field
        @name extension
        @function the test string
    }*/
    private String Name;


    //- *******************
    //- Methods
    /**{ constructor
        @name EndsWithFilter
        @function Constructor of EndsWithFilter
        @param e test string
    }*/
    public DirectoryNamedFilter(String e) {
        Name = e;
}

    /**{ method
        @name accept
        @function test if file should pass filter i.e has proper extension or is
             ending
        @param dir the test directory
        @param name thes name of file in directory dir
        @return true if file passes test
        @policy rarely override
        @primary
    }*/
    public boolean accept(File dir,String name) {
        File test = new File(dir,name);
        if(!test.isDirectory())
            return(false);
        if(name.equals(Name)) {
            return(true);
        }
        return(false);
    }


//- *******************
//- End Class DirectoryNamedFilter
}

/**{ class
    @name IsDirectoryFilter
    @function sorts directories only
}*/
class IsDirectoryFilter implements FilenameFilter {

    //- *******************
    //- Methods
    /**{ constructor
        @name IsDirectoryFilter
        @function Constructor of IsDirectoryFilter
    }*/
    public IsDirectoryFilter() {
}

    /**{ method
        @name accept
        @function test if file should pass filter i.e is a directory
        @param dir the test directory
        @param name this name of file in directory dir
        @return true if file passes test
        @policy <Add Comment Here>
        @primary
    }*/
    public boolean accept(File dir,String name) {
        return(new File(dir,name).isDirectory());
    }


//- *******************
//- End Class IsDirectoryFilter
}
