import com.jacob.com.*;
import com.jacob.activeX.*;
import com.microsoft.excel.*;
import com.microsoft.excel.gen.*;
import com.microsoft.excel.com_enum.*;

/**
 * ExcelTest
 *
 * Starts Excel, creates a chart and exits. 
 * Based on Steve Lewis' java2com example.
 *
 * @author Miika Nurminen
 * @version 0.1 - 27.11.2005
 */
public class ExcelTest {
  
  /** Creates a new instance of ExcelTest */
  public ExcelTest() {
  }
  
  public static void main(String[] args) {
            // Create a new application

           Application  app = new Application();

 

            // Make the application visible

            app.setVisible(true);

 

            // Get all workbooks

           Workbooks  wbs = app.getWorkbooks();

 

            // Add a blank workbook

            Workbook wb = wbs.Add();

 

            // Get the active sheet

           Worksheet  sheet = new Worksheet(wb.getActiveSheet());

            Range rangeA1 = sheet.getRange("A1:D1");

            String[] values = { "North", "South", "East", "West" };

            rangeA1.setValue(values);

            
            // Testing setting cell values with multidimensional range
            
           Range range=new Range(sheet.getRange("A10:B11"));
           Object[][] other={ {"1", "2"}, {"3","4"}};
           range.setValue(other);
           
           // Alternative way using dispatch 
           //Dispatch.put(range.getDispatch(), "Value", other); 

            // Get cell A1

            rangeA1 = sheet.getRange("A2");

            // Set the values into the range

            rangeA1.setValue(new Double(5.2));

           

            sheet.getRange("B2").setValue(new Integer(10));

            sheet.getRange("C2").setValue(new Integer(8));

            sheet.getRange("D2").setValue(new Integer(20));

           

            // Make a Chart

            // Get range

            rangeA1 = sheet.getRange("A1:D2");

            // Make a Chart Group

            ChartObjects TheCharts = new ChartObjects(sheet.ChartObjects());

            // Add a Chart

            ChartObject  TheChart =  TheCharts.Add(100, 30, 400, 250);

             // Get the real chart

            TheCharts.setVisible(true);

            Chart RealChart = TheChart.getChart();

        

             // Get the Wizard

          RealChart.ChartWizard(rangeA1, // source

                XlChartTypeEnum.getOption("xl3DPie").getEnumeratedInteger(), // Gallery

                new Integer(7), //Format,

                XlRowColEnum.getOption("xlRows").getEnumeratedInteger(), //PlotBy,

                new Integer(1), // CategoryLabels,

                new Integer(0), // SeriesLabels,

                new Integer(2), // HasLegend,

                "Sales Percentages"); // Title

        

            // Wait five second;
try {
            Thread.sleep(5000);
}
catch (Exception e) {
  
}
 

            // Close the workbook without saving

          wb.SaveAs("c:\\temp\\test.xls");
//            wb.Close(new Boolean(false));
            

            // Quit the application

            app.Quit();    
  }

}
