import com.jacob.com.ComThread;
import com.jacob.com.Dispatch;
import com.jacob.com.DispatchEvents;
import com.jacob.com.Variant;
import com.jacob.com.WDispatch;
import com.microsoft.word.*;


/**
 * WordTest
 *
 * Starts Word and exists. Also demonstrates events.
 * Note that ApplicationEvents2 event class cannot be directly used
 * with jacob-based events because EventProxy assumes events are 
 * sent to methods of type Variant[]. 
 * Event classes can be used to manually check the available event
 * method names, though.
 *
 * @author Miika Nurminen
 * @version 0.1 - 27.11.2005
 */
public class WordTest {
  
  
  public static class WordEvents extends ApplicationEvents2 {

    public void Quit(Variant[] args) {
      java.lang.System.out.println("quit (no actual parms)!");
    }
        
    public void WindowActivate(Variant[] args) {
      java.lang.System.out.println("window activate (variant)");
       java.lang.System.out.println(args[0]);
       java.lang.System.out.println(args[1]);
    }
    
    public void DocumentBeforeClose(Variant[] args) {
      java.lang.System.out.println("before close (variant)");
       java.lang.System.out.println(args[0]);
       java.lang.System.out.println(args[1]);
    }
    
   
  }
  
  
  public static void main(String[] args) {
    try {
            // Create a new application

           Application  app = new Application();
/*           ApplicationEvents2 a =  new ApplicationEvents2(app) {
    public void DocumentBeforeClose(Document Doc,boolean[] Cancel)
    {
//      super.DocumentBeforeClose(Doc,Cancel);
      java.lang.System.out.println("before close!");
    }
    
        public void Quit() {
//          super.Quit();
      java.lang.System.out.println("quit!");
        }
*/
              
            WordEvents w =  new WordEvents(/*app*/);
          DispatchEvents events = new DispatchEvents(app.getDispatch(),w); 

            // Make the application visible

            app.setVisible(true);

            app.getDocuments().Add();
            app.getDocuments().Add();
            
try {   Thread.sleep(1000); }catch (Exception e) {}

 

            // Quit the application

            app.Quit();  
    }
            finally {
              ComThread.Release();
            }
  }

}
