package com.microsoft.excel.gen;
import com.microsoft.excel.*;
import com.microsoft.excel.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object SeriesCollection
* DO NOT EDIT THIS CODE 
* EDIT the subclass SeriesCollection
* @author S Lewis
*/
public class _SeriesCollection extends WDispatch
{
    public static final String clsid = "{0002086C-0000-0000-C000-000000000046}";
    protected static Map gParamHashAdd;
    protected static Map gParamHashPaste;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAdd = new HashMap();
        gParamHashAdd.put("Source",new Integer(0));
        gParamHashAdd.put("Rowcol",new Integer(1));
        gParamHashAdd.put("SeriesLabels",new Integer(2));
        gParamHashAdd.put("CategoryLabels",new Integer(3));
        gParamHashAdd.put("Replace",new Integer(4));

        gParamHashPaste = new HashMap();
        gParamHashPaste.put("Rowcol",new Integer(0));
        gParamHashPaste.put("SeriesLabels",new Integer(1));
        gParamHashPaste.put("CategoryLabels",new Integer(2));
        gParamHashPaste.put("Replace",new Integer(3));
        gParamHashPaste.put("NewSeries",new Integer(4));

    }
    /**
    * default constructor
    */
    public _SeriesCollection()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _SeriesCollection(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _SeriesCollection(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,148,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return XlCreatorEnum
    */
    public XlCreatorEnum getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,149,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlCreatorEnum ret = XlCreatorEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,150,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param SourceObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @param ReplaceObject
    * @param SourceObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @param ReplaceObject
    * @return Series
    */
    public Series Add(Object Source,XlRowColEnum Rowcol,Object SeriesLabels,Object CategoryLabels,Object Replace)
    {
        Variant[] args = {new Variant(Source),new Variant(Rowcol.getValue()),new Variant(SeriesLabels),new Variant(CategoryLabels),new Variant(Replace)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Series ret = new Series(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Series
    */
    public Series Add(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAdd.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Series ret = new Series(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @param SourceObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @return Series
    */
    public Series Add(Object Source,XlRowColEnum Rowcol,Object SeriesLabels,Object CategoryLabels)
    {
        Variant[] args = {new Variant(Source),new Variant(Rowcol.getValue()),new Variant(SeriesLabels),new Variant(CategoryLabels)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Series ret = new Series(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param SourceObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @return Series
    */
    public Series Add(Object Source,XlRowColEnum Rowcol,Object SeriesLabels)
    {
        Variant[] args = {new Variant(Source),new Variant(Rowcol.getValue()),new Variant(SeriesLabels)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Series ret = new Series(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceObject
    * @param RowcolXlRowColEnum
    * @param SourceObject
    * @param RowcolXlRowColEnum
    * @return Series
    */
    public Series Add(Object Source,XlRowColEnum Rowcol)
    {
        Variant[] args = {new Variant(Source),new Variant(Rowcol.getValue())};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Series ret = new Series(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceObject
    * @param SourceObject
    * @return Series
    */
    public Series Add(Object Source)
    {
        Variant[] args = {new Variant(Source)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Series ret = new Series(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,118,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param SourceObject
    * @param RowcolObject
    * @param CategoryLabelsObject
    * @param SourceObject
    * @param RowcolObject
    * @param CategoryLabelsObject
    * @return Object
    */
    public Object ambig_Extend(Object Source,Object Rowcol,Object CategoryLabels)
    {
        Variant[] args = {new Variant(Source),new Variant(Rowcol),new Variant(CategoryLabels)};
        Variant retVar = invoke_method(args,227,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param SourceObject
    * @param RowcolObject
    * @param SourceObject
    * @param RowcolObject
    * @return Object
    */
    public Object ambig_Extend(Object Source,Object Rowcol)
    {
        Variant[] args = {new Variant(Source),new Variant(Rowcol)};
        Variant retVar = invoke_method(args,227,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param SourceObject
    * @param SourceObject
    * @return Object
    */
    public Object ambig_Extend(Object Source)
    {
        Variant[] args = {new Variant(Source)};
        Variant retVar = invoke_method(args,227,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Series
    */
    public Series Item(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,170,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Series ret = new Series(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig__NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @param ReplaceObject
    * @param NewSeriesObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @param ReplaceObject
    * @param NewSeriesObject
    * @return Object
    */
    public Object ambig_Paste(XlRowColEnum Rowcol,Object SeriesLabels,Object CategoryLabels,Object Replace,Object NewSeries)
    {
        Variant[] args = {new Variant(Rowcol.getValue()),new Variant(SeriesLabels),new Variant(CategoryLabels),new Variant(Replace),new Variant(NewSeries)};
        Variant retVar = invoke_method(args,211,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Object
    */
    public Object ambig_Paste(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashPaste.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,211,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @param ReplaceObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @param ReplaceObject
    * @return Object
    */
    public Object ambig_Paste(XlRowColEnum Rowcol,Object SeriesLabels,Object CategoryLabels,Object Replace)
    {
        Variant[] args = {new Variant(Rowcol.getValue()),new Variant(SeriesLabels),new Variant(CategoryLabels),new Variant(Replace)};
        Variant retVar = invoke_method(args,211,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param CategoryLabelsObject
    * @return Object
    */
    public Object ambig_Paste(XlRowColEnum Rowcol,Object SeriesLabels,Object CategoryLabels)
    {
        Variant[] args = {new Variant(Rowcol.getValue()),new Variant(SeriesLabels),new Variant(CategoryLabels)};
        Variant retVar = invoke_method(args,211,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @param RowcolXlRowColEnum
    * @param SeriesLabelsObject
    * @return Object
    */
    public Object ambig_Paste(XlRowColEnum Rowcol,Object SeriesLabels)
    {
        Variant[] args = {new Variant(Rowcol.getValue()),new Variant(SeriesLabels)};
        Variant retVar = invoke_method(args,211,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param RowcolXlRowColEnum
    * @param RowcolXlRowColEnum
    * @return Object
    */
    public Object ambig_Paste(XlRowColEnum Rowcol)
    {
        Variant[] args = {new Variant(Rowcol.getValue())};
        Variant retVar = invoke_method(args,211,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_Paste()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,211,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Series
    */
    public Series NewSeries()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1117,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Series ret = new Series(retVar.toDispatch());
        return(ret);
    }

}
