package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Cell
* DO NOT EDIT THIS CODE 
* EDIT the subclass Cell
* @author S Lewis
*/
public class _Cell extends WDispatch
{
    public static final String clsid = "{0002094E-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _Cell()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Cell(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Cell(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Range
    */
    public Range getRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return int
    */
    public int getRowIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getColumnIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return float
    */
    public float getWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,6,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setHeight(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,7,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdRowHeightRuleEnum
    */
    public WdRowHeightRuleEnum getHeightRule()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdRowHeightRuleEnum ret = WdRowHeightRuleEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdRowHeightRuleEnum
    * @param arg1WdRowHeightRuleEnum
    */
    public void setHeightRule(WdRowHeightRuleEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdCellVerticalAlignmentEnum
    */
    public WdCellVerticalAlignmentEnum getVerticalAlignment()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1104,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdCellVerticalAlignmentEnum ret = WdCellVerticalAlignmentEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdCellVerticalAlignmentEnum
    * @param arg1WdCellVerticalAlignmentEnum
    */
    public void setVerticalAlignment(WdCellVerticalAlignmentEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1104,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Column
    */
    public Column getColumn()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Column ret = new Column(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Row
    */
    public Row getRow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Row ret = new Row(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Cell
    */
    public Cell getNext()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Cell ret = new Cell(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Cell
    */
    public Cell getPrevious()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Cell ret = new Cell(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Shading
    */
    public Shading getShading()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shading ret = new Shading(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Borders
    */
    public Borders getBorders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Borders ret = new Borders(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Borders
    * @param arg1Borders
    */
    public void setBorders(Borders arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void Select()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,65535,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ShiftCellsObject[]
    * @param ShiftCellsObject[]
    */
    public void Delete(Object[] ShiftCells)
    {
        Variant[] args = {new Variant(ShiftCells)};
        invoke_method_void(args,200,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,200,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormulaObject[]
    * @param NumFormatObject[]
    * @param FormulaObject[]
    * @param NumFormatObject[]
    */
    public void Formula(Object[] Formula,Object[] NumFormat)
    {
        Variant[] args = {new Variant(Formula),new Variant(NumFormat)};
        invoke_method_void(args,201,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormulaObject[]
    * @param FormulaObject[]
    */
    public void Formula(Object[] Formula)
    {
        Variant[] args = {new Variant(Formula)};
        invoke_method_void(args,201,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Formula()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,201,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ColumnWidthfloat
    * @param RulerStyleWdRulerStyleEnum
    * @param ColumnWidthfloat
    * @param RulerStyleWdRulerStyleEnum
    */
    public void SetWidth(float ColumnWidth,WdRulerStyleEnum RulerStyle)
    {
        Variant[] args = {new Variant(ColumnWidth),new Variant(RulerStyle.getValue())};
        invoke_method_void(args,202,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param RowHeightObject[]
    * @param HeightRuleWdRowHeightRuleEnum
    * @param RowHeightObject[]
    * @param HeightRuleWdRowHeightRuleEnum
    */
    public void SetHeight(Object[] RowHeight,WdRowHeightRuleEnum HeightRule)
    {
        Variant[] args = {new Variant(RowHeight),new Variant(HeightRule.getValue())};
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param MergeToCell
    * @param MergeToCell
    */
    public void Merge(Cell MergeTo)
    {
        Variant[] args = {new Variant(MergeTo)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    */
    public void Split(Object[] NumRows,Object[] NumColumns)
    {
        Variant[] args = {new Variant(NumRows),new Variant(NumColumns)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumRowsObject[]
    * @param NumRowsObject[]
    */
    public void Split(Object[] NumRows)
    {
        Variant[] args = {new Variant(NumRows)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Split()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void AutoSum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,206,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return Tables
    */
    public Tables getTables()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Tables ret = new Tables(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getNestingLevel()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getWordWrap()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setWordWrap(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,108,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getPreferredWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setPreferredWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,109,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getFitText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setFitText(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,110,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getTopPadding()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,111,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setTopPadding(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,111,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getBottomPadding()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,112,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setBottomPadding(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,112,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getLeftPadding()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,113,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setLeftPadding(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,113,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getRightPadding()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,114,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setRightPadding(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,114,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,115,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setID(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,115,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdPreferredWidthTypeEnum
    */
    public WdPreferredWidthTypeEnum getPreferredWidthType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,116,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdPreferredWidthTypeEnum ret = WdPreferredWidthTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdPreferredWidthTypeEnum
    * @param arg1WdPreferredWidthTypeEnum
    */
    public void setPreferredWidthType(WdPreferredWidthTypeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,116,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
