package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Hyperlink
* DO NOT EDIT THIS CODE 
* EDIT the subclass Hyperlink
* @author S Lewis
*/
public class _Hyperlink extends WDispatch
{
    public static final String clsid = "{0002099D-0000-0000-C000-000000000046}";
    protected static Map gParamHashFollow;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashFollow = new HashMap();
        gParamHashFollow.put("NewWindow",new Integer(0));
        gParamHashFollow.put("AddHistory",new Integer(1));
        gParamHashFollow.put("ExtraInfo",new Integer(2));
        gParamHashFollow.put("Method",new Integer(3));
        gParamHashFollow.put("HeaderInfo",new Integer(4));

    }
    /**
    * default constructor
    */
    public _Hyperlink()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Hyperlink(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Hyperlink(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return String
    */
    public String getName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1003,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getAddressOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1004,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return int
    */
    public int getType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1005,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1006,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Shape
    */
    public Shape getShape()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1007,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return String
    */
    public String getSubAddressOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1008,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getExtraInfoRequired()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1009,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    */
    public void Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,103,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NewWindowObject[]
    * @param AddHistoryObject[]
    * @param ExtraInfoObject[]
    * @param MethodObject[]
    * @param HeaderInfoObject[]
    * @param NewWindowObject[]
    * @param AddHistoryObject[]
    * @param ExtraInfoObject[]
    * @param MethodObject[]
    * @param HeaderInfoObject[]
    */
    public void Follow(Object[] NewWindow,Object[] AddHistory,Object[] ExtraInfo,Object[] Method,Object[] HeaderInfo)
    {
        Variant[] args = {new Variant(NewWindow),new Variant(AddHistory),new Variant(ExtraInfo),new Variant(Method),new Variant(HeaderInfo)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void Follow(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashFollow.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NewWindowObject[]
    * @param AddHistoryObject[]
    * @param ExtraInfoObject[]
    * @param MethodObject[]
    * @param NewWindowObject[]
    * @param AddHistoryObject[]
    * @param ExtraInfoObject[]
    * @param MethodObject[]
    */
    public void Follow(Object[] NewWindow,Object[] AddHistory,Object[] ExtraInfo,Object[] Method)
    {
        Variant[] args = {new Variant(NewWindow),new Variant(AddHistory),new Variant(ExtraInfo),new Variant(Method)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NewWindowObject[]
    * @param AddHistoryObject[]
    * @param ExtraInfoObject[]
    * @param NewWindowObject[]
    * @param AddHistoryObject[]
    * @param ExtraInfoObject[]
    */
    public void Follow(Object[] NewWindow,Object[] AddHistory,Object[] ExtraInfo)
    {
        Variant[] args = {new Variant(NewWindow),new Variant(AddHistory),new Variant(ExtraInfo)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NewWindowObject[]
    * @param AddHistoryObject[]
    * @param NewWindowObject[]
    * @param AddHistoryObject[]
    */
    public void Follow(Object[] NewWindow,Object[] AddHistory)
    {
        Variant[] args = {new Variant(NewWindow),new Variant(AddHistory)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NewWindowObject[]
    * @param NewWindowObject[]
    */
    public void Follow(Object[] NewWindow)
    {
        Variant[] args = {new Variant(NewWindow)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Follow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void AddToFavorites()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,105,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param EditNowboolean
    * @param Overwriteboolean
    * @param FileNameString
    * @param EditNowboolean
    * @param Overwriteboolean
    */
    public void CreateNewDocument(String FileName,boolean EditNow,boolean Overwrite)
    {
        Variant[] args = {new Variant(FileName),new Variant(EditNow),new Variant(Overwrite)};
        invoke_method_void(args,106,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return String
    */
    public String getAddress()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setAddress(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getSubAddress()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1101,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setSubAddress(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1101,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getEmailSubject()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1010,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setEmailSubject(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1010,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getScreenTip()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1011,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setScreenTip(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1011,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getTextToDisplay()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1012,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setTextToDisplay(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1012,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getTarget()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1013,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setTarget(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1013,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
