package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object InlineShape
* DO NOT EDIT THIS CODE 
* EDIT the subclass InlineShape
* @author S Lewis
*/
public class _InlineShape extends WDispatch
{
    public static final String clsid = "{000209A8-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _InlineShape()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _InlineShape(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _InlineShape(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Borders
    */
    public Borders getBorders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Borders ret = new Borders(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Borders
    * @param arg1Borders
    */
    public void setBorders(Borders arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return LinkFormat
    */
    public LinkFormat getLinkFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        LinkFormat ret = new LinkFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Field
    */
    public Field getField()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Field ret = new Field(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return OLEFormat
    */
    public OLEFormat getOLEFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        OLEFormat ret = new OLEFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return WdInlineShapeTypeEnum
    */
    public WdInlineShapeTypeEnum getType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdInlineShapeTypeEnum ret = WdInlineShapeTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Hyperlink
    */
    public Hyperlink getHyperlink()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return float
    */
    public float getHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setHeight(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getScaleHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setScaleHeight(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,10,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getScaleWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setScaleWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,11,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getLockAspectRatio()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1intRealType - MsoTriState
    * @param arg1intRealType - MsoTriState
    */
    public void setLockAspectRatio(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,12,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return LineFormat
    */
    public LineFormat getLine()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,112,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        LineFormat ret = new LineFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return FillFormat
    */
    public FillFormat getFill()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        FillFormat ret = new FillFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return PictureFormat
    */
    public PictureFormat getPictureFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,118,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        PictureFormat ret = new PictureFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1PictureFormat
    * @param arg1PictureFormat
    */
    public void setPictureFormat(PictureFormat arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,118,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void Activate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,100,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Reset()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Select()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,65535,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return Shape
    */
    public Shape ConvertToShape()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return HorizontalLineFormat
    */
    public HorizontalLineFormat getHorizontalLineFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,119,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        HorizontalLineFormat ret = new HorizontalLineFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Object // @@@Script 

    */
    /*
    public Object // @@@Script 
 getScript()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,122,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object // @@@Script 
 ret = new Object // @@@Script 
((Dispatch)retVar.ForceObjectVal());
        return(ret);
    }
    */

    /**
    * @return int
    */
    public int getOWSAnchor()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,130,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return TextEffectFormat
    */
    public TextEffectFormat getTextEffect()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,120,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        TextEffectFormat ret = new TextEffectFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1TextEffectFormat
    * @param arg1TextEffectFormat
    */
    public void setTextEffect(TextEffectFormat arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,120,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getAlternativeText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,131,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setAlternativeText(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,131,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
