package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object KeyBindings
* DO NOT EDIT THIS CODE 
* EDIT the subclass KeyBindings
* @author S Lewis
*/
public class _KeyBindings extends WDispatch
{
    public static final String clsid = "{00020996-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _KeyBindings()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _KeyBindings(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _KeyBindings(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getContext()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param Indexint
    * @param Indexint
    * @return KeyBinding
    */
    public KeyBinding Item(int Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        KeyBinding ret = new KeyBinding(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param KeyCodeint
    * @param KeyCode2Object[]
    * @param CommandParameterObject[]
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param KeyCodeint
    * @param KeyCode2Object[]
    * @param CommandParameterObject[]
    * @return KeyBinding
    */
    public KeyBinding Add(WdKeyCategoryEnum KeyCategory,String Command,int KeyCode,Object[] KeyCode2,Object[] CommandParameter)
    {
        Variant[] args = {new Variant(KeyCategory.getValue()),new Variant(Command),new Variant(KeyCode),new Variant(KeyCode2),new Variant(CommandParameter)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        KeyBinding ret = new KeyBinding(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param KeyCodeint
    * @param KeyCode2Object[]
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param KeyCodeint
    * @param KeyCode2Object[]
    * @return KeyBinding
    */
    public KeyBinding Add(WdKeyCategoryEnum KeyCategory,String Command,int KeyCode,Object[] KeyCode2)
    {
        Variant[] args = {new Variant(KeyCategory.getValue()),new Variant(Command),new Variant(KeyCode),new Variant(KeyCode2)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        KeyBinding ret = new KeyBinding(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param KeyCodeint
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param KeyCodeint
    * @return KeyBinding
    */
    public KeyBinding Add(WdKeyCategoryEnum KeyCategory,String Command,int KeyCode)
    {
        Variant[] args = {new Variant(KeyCategory.getValue()),new Variant(Command),new Variant(KeyCode)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        KeyBinding ret = new KeyBinding(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void ClearAll()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param KeyCodeint
    * @param KeyCode2Object[]
    * @param KeyCodeint
    * @param KeyCode2Object[]
    * @return KeyBinding
    */
    public KeyBinding Key(int KeyCode,Object[] KeyCode2)
    {
        Variant[] args = {new Variant(KeyCode),new Variant(KeyCode2)};
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        KeyBinding ret = new KeyBinding(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param KeyCodeint
    * @param KeyCodeint
    * @return KeyBinding
    */
    public KeyBinding Key(int KeyCode)
    {
        Variant[] args = {new Variant(KeyCode)};
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        KeyBinding ret = new KeyBinding(retVar.toDispatch());
        return(ret);
    }

}
