package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object MailMergeDataSource
* DO NOT EDIT THIS CODE 
* EDIT the subclass MailMergeDataSource
* @author S Lewis
*/
public class _MailMergeDataSource extends WDispatch
{
    public static final String clsid = "{0002091D-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _MailMergeDataSource()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _MailMergeDataSource(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _MailMergeDataSource(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return String
    */
    public String getName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getHeaderSourceName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return WdMailMergeDataSourceEnum
    */
    public WdMailMergeDataSourceEnum getType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdMailMergeDataSourceEnum ret = WdMailMergeDataSourceEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return WdMailMergeDataSourceEnum
    */
    public WdMailMergeDataSourceEnum getHeaderSourceType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdMailMergeDataSourceEnum ret = WdMailMergeDataSourceEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return String
    */
    public String getConnectString()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getQueryString()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setQueryString(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,6,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdMailMergeActiveRecordEnum
    */
    public WdMailMergeActiveRecordEnum getActiveRecord()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdMailMergeActiveRecordEnum ret = WdMailMergeActiveRecordEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdMailMergeActiveRecordEnum
    * @param arg1WdMailMergeActiveRecordEnum
    */
    public void setActiveRecord(WdMailMergeActiveRecordEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,7,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getFirstRecord()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setFirstRecord(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getLastRecord()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setLastRecord(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return MailMergeFieldNames
    */
    public MailMergeFieldNames getFieldNames()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        MailMergeFieldNames ret = new MailMergeFieldNames(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return MailMergeDataFields
    */
    public MailMergeDataFields getDataFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        MailMergeDataFields ret = new MailMergeDataFields(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FindTextString
    * @param FieldString
    * @param FindTextString
    * @param FieldString
    * @return boolean
    */
    public boolean FindRecord(String FindText,String Field)
    {
        Variant[] args = {new Variant(FindText),new Variant(Field)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

}
