package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Selection
* DO NOT EDIT THIS CODE 
* EDIT the subclass Selection
* @author S Lewis
*/
public class _Selection extends WDispatch
{
    public static final String clsid = "{00020975-0000-0000-C000-000000000046}";
    protected static Map gParamHashInsertFile;
    protected static Map gParamHashConvertToTableOld;
    protected static Map gParamHashInsertDateTimeOld;
    protected static Map gParamHashInsertSymbol;
    protected static Map gParamHashInsertCaption;
    protected static Map gParamHashSortOld;
    protected static Map gParamHashGoTo;
    protected static Map gParamHashPasteSpecial;
    protected static Map gParamHashMoveLeft;
    protected static Map gParamHashMoveRight;
    protected static Map gParamHashMoveUp;
    protected static Map gParamHashMoveDown;
    protected static Map gParamHashInsertDateTime;
    protected static Map gParamHashSort;
    protected static Map gParamHashConvertToTable;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashInsertFile = new HashMap();
        gParamHashInsertFile.put("FileName",new Integer(0));
        gParamHashInsertFile.put("Range",new Integer(1));
        gParamHashInsertFile.put("ConfirmConversions",new Integer(2));
        gParamHashInsertFile.put("Link",new Integer(3));
        gParamHashInsertFile.put("Attachment",new Integer(4));

        gParamHashConvertToTableOld = new HashMap();
        gParamHashConvertToTableOld.put("Separator",new Integer(0));
        gParamHashConvertToTableOld.put("NumRows",new Integer(1));
        gParamHashConvertToTableOld.put("NumColumns",new Integer(2));
        gParamHashConvertToTableOld.put("InitialColumnWidth",new Integer(3));
        gParamHashConvertToTableOld.put("Format",new Integer(4));
        gParamHashConvertToTableOld.put("ApplyBorders",new Integer(5));
        gParamHashConvertToTableOld.put("ApplyShading",new Integer(6));
        gParamHashConvertToTableOld.put("ApplyFont",new Integer(7));
        gParamHashConvertToTableOld.put("ApplyColor",new Integer(8));
        gParamHashConvertToTableOld.put("ApplyHeadingRows",new Integer(9));
        gParamHashConvertToTableOld.put("ApplyLastRow",new Integer(10));
        gParamHashConvertToTableOld.put("ApplyFirstColumn",new Integer(11));
        gParamHashConvertToTableOld.put("ApplyLastColumn",new Integer(12));
        gParamHashConvertToTableOld.put("AutoFit",new Integer(13));

        gParamHashInsertDateTimeOld = new HashMap();
        gParamHashInsertDateTimeOld.put("DateTimeFormat",new Integer(0));
        gParamHashInsertDateTimeOld.put("InsertAsField",new Integer(1));
        gParamHashInsertDateTimeOld.put("InsertAsFullWidth",new Integer(2));

        gParamHashInsertSymbol = new HashMap();
        gParamHashInsertSymbol.put("CharacterNumber",new Integer(0));
        gParamHashInsertSymbol.put("Font",new Integer(1));
        gParamHashInsertSymbol.put("Unicode",new Integer(2));
        gParamHashInsertSymbol.put("Bias",new Integer(3));

        gParamHashInsertCaption = new HashMap();
        gParamHashInsertCaption.put("Label",new Integer(0));
        gParamHashInsertCaption.put("Title",new Integer(1));
        gParamHashInsertCaption.put("TitleAutoText",new Integer(2));
        gParamHashInsertCaption.put("Position",new Integer(3));

        gParamHashSortOld = new HashMap();
        gParamHashSortOld.put("ExcludeHeader",new Integer(0));
        gParamHashSortOld.put("FieldNumber",new Integer(1));
        gParamHashSortOld.put("SortFieldType",new Integer(2));
        gParamHashSortOld.put("SortOrder",new Integer(3));
        gParamHashSortOld.put("FieldNumber2",new Integer(4));
        gParamHashSortOld.put("SortFieldType2",new Integer(5));
        gParamHashSortOld.put("SortOrder2",new Integer(6));
        gParamHashSortOld.put("FieldNumber3",new Integer(7));
        gParamHashSortOld.put("SortFieldType3",new Integer(8));
        gParamHashSortOld.put("SortOrder3",new Integer(9));
        gParamHashSortOld.put("SortColumn",new Integer(10));
        gParamHashSortOld.put("Separator",new Integer(11));
        gParamHashSortOld.put("CaseSensitive",new Integer(12));
        gParamHashSortOld.put("LanguageID",new Integer(13));

        gParamHashGoTo = new HashMap();
        gParamHashGoTo.put("What",new Integer(0));
        gParamHashGoTo.put("Which",new Integer(1));
        gParamHashGoTo.put("Count",new Integer(2));
        gParamHashGoTo.put("Name",new Integer(3));

        gParamHashPasteSpecial = new HashMap();
        gParamHashPasteSpecial.put("IconIndex",new Integer(0));
        gParamHashPasteSpecial.put("Link",new Integer(1));
        gParamHashPasteSpecial.put("Placement",new Integer(2));
        gParamHashPasteSpecial.put("DisplayAsIcon",new Integer(3));
        gParamHashPasteSpecial.put("DataType",new Integer(4));
        gParamHashPasteSpecial.put("IconFileName",new Integer(5));
        gParamHashPasteSpecial.put("IconLabel",new Integer(6));

        gParamHashMoveLeft = new HashMap();
        gParamHashMoveLeft.put("Unit",new Integer(0));
        gParamHashMoveLeft.put("Count",new Integer(1));
        gParamHashMoveLeft.put("Extend",new Integer(2));

        gParamHashMoveRight = new HashMap();
        gParamHashMoveRight.put("Unit",new Integer(0));
        gParamHashMoveRight.put("Count",new Integer(1));
        gParamHashMoveRight.put("Extend",new Integer(2));

        gParamHashMoveUp = new HashMap();
        gParamHashMoveUp.put("Unit",new Integer(0));
        gParamHashMoveUp.put("Count",new Integer(1));
        gParamHashMoveUp.put("Extend",new Integer(2));

        gParamHashMoveDown = new HashMap();
        gParamHashMoveDown.put("Unit",new Integer(0));
        gParamHashMoveDown.put("Count",new Integer(1));
        gParamHashMoveDown.put("Extend",new Integer(2));

        gParamHashInsertDateTime = new HashMap();
        gParamHashInsertDateTime.put("DateTimeFormat",new Integer(0));
        gParamHashInsertDateTime.put("InsertAsField",new Integer(1));
        gParamHashInsertDateTime.put("InsertAsFullWidth",new Integer(2));
        gParamHashInsertDateTime.put("DateLanguage",new Integer(3));
        gParamHashInsertDateTime.put("CalendarType",new Integer(4));

        gParamHashSort = new HashMap();
        gParamHashSort.put("ExcludeHeader",new Integer(0));
        gParamHashSort.put("FieldNumber",new Integer(1));
        gParamHashSort.put("SortFieldType",new Integer(2));
        gParamHashSort.put("SortOrder",new Integer(3));
        gParamHashSort.put("FieldNumber2",new Integer(4));
        gParamHashSort.put("SortFieldType2",new Integer(5));
        gParamHashSort.put("SortOrder2",new Integer(6));
        gParamHashSort.put("FieldNumber3",new Integer(7));
        gParamHashSort.put("SortFieldType3",new Integer(8));
        gParamHashSort.put("SortOrder3",new Integer(9));
        gParamHashSort.put("SortColumn",new Integer(10));
        gParamHashSort.put("Separator",new Integer(11));
        gParamHashSort.put("CaseSensitive",new Integer(12));
        gParamHashSort.put("BidiSort",new Integer(13));
        gParamHashSort.put("IgnoreThe",new Integer(14));
        gParamHashSort.put("IgnoreKashida",new Integer(15));
        gParamHashSort.put("IgnoreDiacritics",new Integer(16));
        gParamHashSort.put("IgnoreHe",new Integer(17));
        gParamHashSort.put("LanguageID",new Integer(18));

        gParamHashConvertToTable = new HashMap();
        gParamHashConvertToTable.put("Separator",new Integer(0));
        gParamHashConvertToTable.put("NumRows",new Integer(1));
        gParamHashConvertToTable.put("NumColumns",new Integer(2));
        gParamHashConvertToTable.put("InitialColumnWidth",new Integer(3));
        gParamHashConvertToTable.put("Format",new Integer(4));
        gParamHashConvertToTable.put("ApplyBorders",new Integer(5));
        gParamHashConvertToTable.put("ApplyShading",new Integer(6));
        gParamHashConvertToTable.put("ApplyFont",new Integer(7));
        gParamHashConvertToTable.put("ApplyColor",new Integer(8));
        gParamHashConvertToTable.put("ApplyHeadingRows",new Integer(9));
        gParamHashConvertToTable.put("ApplyLastRow",new Integer(10));
        gParamHashConvertToTable.put("ApplyFirstColumn",new Integer(11));
        gParamHashConvertToTable.put("ApplyLastColumn",new Integer(12));
        gParamHashConvertToTable.put("AutoFit",new Integer(13));
        gParamHashConvertToTable.put("AutoFitBehavior",new Integer(14));
        gParamHashConvertToTable.put("DefaultTableBehavior",new Integer(15));

    }
    /**
    * default constructor
    */
    public _Selection()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Selection(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Selection(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return String
    */
    public String getText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setText(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,0,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getFormattedText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Range
    * @param arg1Range
    */
    public void setFormattedText(Range arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,2,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getStart()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setStart(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getEnd()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setEnd(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Font
    */
    public Font getFont()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Font ret = new Font(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Font
    * @param arg1Font
    */
    public void setFont(Font arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdSelectionTypeEnum
    */
    public WdSelectionTypeEnum getType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdSelectionTypeEnum ret = WdSelectionTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return WdStoryTypeEnum
    */
    public WdStoryTypeEnum getStoryType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdStoryTypeEnum ret = WdStoryTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_getStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object[]
    * @param arg1Object[]
    */
    public void setStyle(Object[] arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Tables
    */
    public Tables getTables()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,50,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Tables ret = new Tables(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Words
    */
    public Words getWords()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,51,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Words ret = new Words(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Sentences
    */
    public Sentences getSentences()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,52,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Sentences ret = new Sentences(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Characters
    */
    public Characters getCharacters()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,53,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Characters ret = new Characters(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Footnotes
    */
    public Footnotes getFootnotes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,54,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Footnotes ret = new Footnotes(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Endnotes
    */
    public Endnotes getEndnotes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,55,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Endnotes ret = new Endnotes(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Comments
    */
    public Comments getComments()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,56,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Comments ret = new Comments(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Cells
    */
    public Cells getCells()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,57,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Cells ret = new Cells(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Sections
    */
    public Sections getSections()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,58,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Sections ret = new Sections(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Paragraphs
    */
    public Paragraphs getParagraphs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,59,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Paragraphs ret = new Paragraphs(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Borders
    */
    public Borders getBorders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Borders ret = new Borders(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Borders
    * @param arg1Borders
    */
    public void setBorders(Borders arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Shading
    */
    public Shading getShading()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,61,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shading ret = new Shading(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Fields
    */
    public Fields getFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,64,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Fields ret = new Fields(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return FormFields
    */
    public FormFields getFormFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,65,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        FormFields ret = new FormFields(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Frames
    */
    public Frames getFrames()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,66,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Frames ret = new Frames(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return ParagraphFormat
    */
    public ParagraphFormat getParagraphFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1102,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ParagraphFormat ret = new ParagraphFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1ParagraphFormat
    * @param arg1ParagraphFormat
    */
    public void setParagraphFormat(ParagraphFormat arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1102,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return PageSetup
    */
    public PageSetup getPageSetup()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1101,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        PageSetup ret = new PageSetup(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1PageSetup
    * @param arg1PageSetup
    */
    public void setPageSetup(PageSetup arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1101,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Bookmarks
    */
    public Bookmarks getBookmarks()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,75,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Bookmarks ret = new Bookmarks(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getStoryLength()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,152,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return WdLanguageIDEnum
    */
    public WdLanguageIDEnum getLanguageID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,153,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLanguageIDEnum ret = WdLanguageIDEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLanguageIDEnum
    * @param arg1WdLanguageIDEnum
    */
    public void setLanguageID(WdLanguageIDEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,153,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdLanguageIDEnum
    */
    public WdLanguageIDEnum getLanguageIDFarEast()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,154,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLanguageIDEnum ret = WdLanguageIDEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLanguageIDEnum
    * @param arg1WdLanguageIDEnum
    */
    public void setLanguageIDFarEast(WdLanguageIDEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,154,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdLanguageIDEnum
    */
    public WdLanguageIDEnum getLanguageIDOther()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,155,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLanguageIDEnum ret = WdLanguageIDEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLanguageIDEnum
    * @param arg1WdLanguageIDEnum
    */
    public void setLanguageIDOther(WdLanguageIDEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,155,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Hyperlinks
    */
    public Hyperlinks getHyperlinks()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,156,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Hyperlinks ret = new Hyperlinks(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Columns
    */
    public Columns getColumns()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,302,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Columns ret = new Columns(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Rows
    */
    public Rows getRows()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,303,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Rows ret = new Rows(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return HeaderFooter
    */
    public HeaderFooter getHeaderFooter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,306,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        HeaderFooter ret = new HeaderFooter(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getIsEndOfRowMark()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,307,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return int
    */
    public int getBookmarkID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,308,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getPreviousBookmarkID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,309,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Find
    */
    public Find getFind()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,262,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Find ret = new Find(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,400,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TypeWdInformationEnum
    * @param TypeWdInformationEnum
    * @return Object
    */
    public Object ambig_getInformation(WdInformationEnum Type)
    {
        Variant[] args = {new Variant(Type.getValue())};
        Variant retVar = invoke_method(args,401,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return WdSelectionFlagsEnum
    */
    public WdSelectionFlagsEnum getFlags()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,402,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdSelectionFlagsEnum ret = WdSelectionFlagsEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdSelectionFlagsEnum
    * @param arg1WdSelectionFlagsEnum
    */
    public void setFlags(WdSelectionFlagsEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,402,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getActive()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,403,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getStartIsActive()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,404,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setStartIsActive(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,404,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getIPAtEndOfLine()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,405,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getExtendMode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,406,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setExtendMode(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,406,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getColumnSelectMode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,407,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setColumnSelectMode(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,407,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdTextOrientationEnum
    */
    public WdTextOrientationEnum getOrientation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,410,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdTextOrientationEnum ret = WdTextOrientationEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdTextOrientationEnum
    * @param arg1WdTextOrientationEnum
    */
    public void setOrientation(WdTextOrientationEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,410,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return InlineShapes
    */
    public InlineShapes getInlineShapes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,411,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        InlineShapes ret = new InlineShapes(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Document
    */
    public Document getDocument()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1003,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return ShapeRange
    */
    public ShapeRange getShapeRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1004,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ShapeRange ret = new ShapeRange(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void Select()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,65535,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param Startint
    * @param Endint
    * @param Startint
    * @param Endint
    */
    public void SetRange(int Start,int End)
    {
        Variant[] args = {new Variant(Start),new Variant(End)};
        invoke_method_void(args,100,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DirectionObject[]
    * @param DirectionObject[]
    */
    public void Collapse(Object[] Direction)
    {
        Variant[] args = {new Variant(Direction)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Collapse()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param TextString
    */
    public void InsertBefore(String Text)
    {
        Variant[] args = {new Variant(Text)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param TextString
    */
    public void InsertAfter(String Text)
    {
        Variant[] args = {new Variant(Text)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return Range
    */
    public Range Next(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return Range
    */
    public Range Next(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range Next()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return Range
    */
    public Range Previous(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return Range
    */
    public Range Previous(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range Previous()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int StartOf(Object[] Unit,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Extend)};
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int StartOf(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int StartOf()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int EndOf(Object[] Unit,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Extend)};
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int EndOf(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int EndOf()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int Move(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int Move(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int Move()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveStart(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int MoveStart(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int MoveStart()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveEnd(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,111,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int MoveEnd(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,111,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int MoveEnd()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,111,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveWhile(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,112,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveWhile(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,112,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveStartWhile(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,113,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveStartWhile(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,113,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveEndWhile(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,114,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveEndWhile(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,114,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveUntil(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,115,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveUntil(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,115,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveStartUntil(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,116,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveStartUntil(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,116,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveEndUntil(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,117,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveEndUntil(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,117,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    */
    public void Cut()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,119,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Copy()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,120,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Paste()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,121,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TypeObject[]
    * @param TypeObject[]
    */
    public void InsertBreak(Object[] Type)
    {
        Variant[] args = {new Variant(Type)};
        invoke_method_void(args,122,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertBreak()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,122,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param LinkObject[]
    * @param AttachmentObject[]
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param LinkObject[]
    * @param AttachmentObject[]
    */
    public void InsertFile(String FileName,Object[] Range,Object[] ConfirmConversions,Object[] Link,Object[] Attachment)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range),new Variant(ConfirmConversions),new Variant(Link),new Variant(Attachment)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertFile(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertFile.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param LinkObject[]
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param LinkObject[]
    */
    public void InsertFile(String FileName,Object[] Range,Object[] ConfirmConversions,Object[] Link)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range),new Variant(ConfirmConversions),new Variant(Link)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    */
    public void InsertFile(String FileName,Object[] Range,Object[] ConfirmConversions)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range),new Variant(ConfirmConversions)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param FileNameString
    * @param RangeObject[]
    */
    public void InsertFile(String FileName,Object[] Range)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    */
    public void InsertFile(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return boolean
    */
    public boolean InStory(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,125,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return boolean
    */
    public boolean InRange(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,126,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int Delete(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,127,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int Delete(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,127,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,127,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int Expand(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,129,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int Expand()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,129,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    */
    public void InsertParagraph()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,160,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertParagraphAfter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,161,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn,Object[] AutoFit)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn),new Variant(AutoFit)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Table
    */
    public Table ConvertToTableOld(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashConvertToTableOld.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param SeparatorObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator)
    {
        Variant[] args = {new Variant(Separator)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Table
    */
    public Table ConvertToTableOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    */
    public void InsertDateTimeOld(Object[] DateTimeFormat,Object[] InsertAsField,Object[] InsertAsFullWidth)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField),new Variant(InsertAsFullWidth)};
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertDateTimeOld(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertDateTimeOld.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    */
    public void InsertDateTimeOld(Object[] DateTimeFormat,Object[] InsertAsField)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField)};
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param DateTimeFormatObject[]
    */
    public void InsertDateTimeOld(Object[] DateTimeFormat)
    {
        Variant[] args = {new Variant(DateTimeFormat)};
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertDateTimeOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterNumberint
    * @param FontObject[]
    * @param UnicodeObject[]
    * @param BiasObject[]
    * @param CharacterNumberint
    * @param FontObject[]
    * @param UnicodeObject[]
    * @param BiasObject[]
    */
    public void InsertSymbol(int CharacterNumber,Object[] Font,Object[] Unicode,Object[] Bias)
    {
        Variant[] args = {new Variant(CharacterNumber),new Variant(Font),new Variant(Unicode),new Variant(Bias)};
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertSymbol(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertSymbol.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterNumberint
    * @param FontObject[]
    * @param UnicodeObject[]
    * @param CharacterNumberint
    * @param FontObject[]
    * @param UnicodeObject[]
    */
    public void InsertSymbol(int CharacterNumber,Object[] Font,Object[] Unicode)
    {
        Variant[] args = {new Variant(CharacterNumber),new Variant(Font),new Variant(Unicode)};
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterNumberint
    * @param FontObject[]
    * @param CharacterNumberint
    * @param FontObject[]
    */
    public void InsertSymbol(int CharacterNumber,Object[] Font)
    {
        Variant[] args = {new Variant(CharacterNumber),new Variant(Font)};
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterNumberint
    * @param CharacterNumberint
    */
    public void InsertSymbol(int CharacterNumber)
    {
        Variant[] args = {new Variant(CharacterNumber)};
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param InsertAsHyperlinkObject[]
    * @param IncludePositionObject[]
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param InsertAsHyperlinkObject[]
    * @param IncludePositionObject[]
    */
    public void InsertCrossReference(Object[] ReferenceType,WdReferenceKindEnum ReferenceKind,Object[] ReferenceItem,Object[] InsertAsHyperlink,Object[] IncludePosition)
    {
        Variant[] args = {new Variant(ReferenceType),new Variant(ReferenceKind.getValue()),new Variant(ReferenceItem),new Variant(InsertAsHyperlink),new Variant(IncludePosition)};
        invoke_method_void(args,165,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param InsertAsHyperlinkObject[]
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param InsertAsHyperlinkObject[]
    */
    public void InsertCrossReference(Object[] ReferenceType,WdReferenceKindEnum ReferenceKind,Object[] ReferenceItem,Object[] InsertAsHyperlink)
    {
        Variant[] args = {new Variant(ReferenceType),new Variant(ReferenceKind.getValue()),new Variant(ReferenceItem),new Variant(InsertAsHyperlink)};
        invoke_method_void(args,165,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    */
    public void InsertCrossReference(Object[] ReferenceType,WdReferenceKindEnum ReferenceKind,Object[] ReferenceItem)
    {
        Variant[] args = {new Variant(ReferenceType),new Variant(ReferenceKind.getValue()),new Variant(ReferenceItem)};
        invoke_method_void(args,165,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LabelObject[]
    * @param TitleObject[]
    * @param TitleAutoTextObject[]
    * @param PositionObject[]
    * @param LabelObject[]
    * @param TitleObject[]
    * @param TitleAutoTextObject[]
    * @param PositionObject[]
    */
    public void InsertCaption(Object[] Label,Object[] Title,Object[] TitleAutoText,Object[] Position)
    {
        Variant[] args = {new Variant(Label),new Variant(Title),new Variant(TitleAutoText),new Variant(Position)};
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertCaption(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertCaption.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LabelObject[]
    * @param TitleObject[]
    * @param TitleAutoTextObject[]
    * @param LabelObject[]
    * @param TitleObject[]
    * @param TitleAutoTextObject[]
    */
    public void InsertCaption(Object[] Label,Object[] Title,Object[] TitleAutoText)
    {
        Variant[] args = {new Variant(Label),new Variant(Title),new Variant(TitleAutoText)};
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LabelObject[]
    * @param TitleObject[]
    * @param LabelObject[]
    * @param TitleObject[]
    */
    public void InsertCaption(Object[] Label,Object[] Title)
    {
        Variant[] args = {new Variant(Label),new Variant(Title)};
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LabelObject[]
    * @param LabelObject[]
    */
    public void InsertCaption(Object[] Label)
    {
        Variant[] args = {new Variant(Label)};
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CopyAsPicture()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,167,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param LanguageIDObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param LanguageIDObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] LanguageID)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(LanguageID)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void SortOld(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashSortOld.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param ExcludeHeaderObject[]
    */
    public void SortOld(Object[] ExcludeHeader)
    {
        Variant[] args = {new Variant(ExcludeHeader)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SortOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SortAscending()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,169,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SortDescending()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,170,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return boolean
    */
    public boolean IsEqual(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,171,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return float
    */
    public float Calculate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,172,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param WhatObject[]
    * @param WhichObject[]
    * @param CountObject[]
    * @param NameObject[]
    * @param WhatObject[]
    * @param WhichObject[]
    * @param CountObject[]
    * @param NameObject[]
    * @return Range
    */
    public Range GoTo(Object[] What,Object[] Which,Object[] Count,Object[] Name)
    {
        Variant[] args = {new Variant(What),new Variant(Which),new Variant(Count),new Variant(Name)};
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Range
    */
    public Range GoTo(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashGoTo.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatObject[]
    * @param WhichObject[]
    * @param CountObject[]
    * @param WhatObject[]
    * @param WhichObject[]
    * @param CountObject[]
    * @return Range
    */
    public Range GoTo(Object[] What,Object[] Which,Object[] Count)
    {
        Variant[] args = {new Variant(What),new Variant(Which),new Variant(Count)};
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatObject[]
    * @param WhichObject[]
    * @param WhatObject[]
    * @param WhichObject[]
    * @return Range
    */
    public Range GoTo(Object[] What,Object[] Which)
    {
        Variant[] args = {new Variant(What),new Variant(Which)};
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatObject[]
    * @param WhatObject[]
    * @return Range
    */
    public Range GoTo(Object[] What)
    {
        Variant[] args = {new Variant(What)};
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range GoTo()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatWdGoToItemEnum
    * @param WhatWdGoToItemEnum
    * @return Range
    */
    public Range GoToNext(WdGoToItemEnum What)
    {
        Variant[] args = {new Variant(What.getValue())};
        Variant retVar = invoke_method(args,174,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatWdGoToItemEnum
    * @param WhatWdGoToItemEnum
    * @return Range
    */
    public Range GoToPrevious(WdGoToItemEnum What)
    {
        Variant[] args = {new Variant(What.getValue())};
        Variant retVar = invoke_method(args,175,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconFileNameObject[]
    * @param IconLabelObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconFileNameObject[]
    * @param IconLabelObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement,Object[] DisplayAsIcon,Object[] DataType,Object[] IconFileName,Object[] IconLabel)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement),new Variant(DisplayAsIcon),new Variant(DataType),new Variant(IconFileName),new Variant(IconLabel)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void PasteSpecial(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashPasteSpecial.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconFileNameObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement,Object[] DisplayAsIcon,Object[] DataType,Object[] IconFileName)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement),new Variant(DisplayAsIcon),new Variant(DataType),new Variant(IconFileName)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement,Object[] DisplayAsIcon,Object[] DataType)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement),new Variant(DisplayAsIcon),new Variant(DataType)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement,Object[] DisplayAsIcon)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement),new Variant(DisplayAsIcon)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param IconIndexObject[]
    */
    public void PasteSpecial(Object[] IconIndex)
    {
        Variant[] args = {new Variant(IconIndex)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PasteSpecial()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return Field
    */
    public Field PreviousField()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,177,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Field ret = new Field(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Field
    */
    public Field NextField()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,178,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Field ret = new Field(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void InsertParagraphBefore()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,212,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ShiftCellsObject[]
    * @param ShiftCellsObject[]
    */
    public void InsertCells(Object[] ShiftCells)
    {
        Variant[] args = {new Variant(ShiftCells)};
        invoke_method_void(args,214,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertCells()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,214,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterObject[]
    * @param CharacterObject[]
    */
    public void Extend(Object[] Character)
    {
        Variant[] args = {new Variant(Character)};
        invoke_method_void(args,300,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Extend()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,300,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Shrink()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,301,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int MoveLeft(Object[] Unit,Object[] Count,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count),new Variant(Extend)};
        Variant retVar = invoke_method(args,500,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return int
    */
    public int MoveLeft(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashMoveLeft.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,500,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveLeft(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,500,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int MoveLeft(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,500,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int MoveLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,500,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int MoveRight(Object[] Unit,Object[] Count,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count),new Variant(Extend)};
        Variant retVar = invoke_method(args,501,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return int
    */
    public int MoveRight(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashMoveRight.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,501,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveRight(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,501,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int MoveRight(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,501,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int MoveRight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,501,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int MoveUp(Object[] Unit,Object[] Count,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count),new Variant(Extend)};
        Variant retVar = invoke_method(args,502,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return int
    */
    public int MoveUp(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashMoveUp.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,502,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveUp(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,502,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int MoveUp(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,502,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int MoveUp()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,502,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int MoveDown(Object[] Unit,Object[] Count,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count),new Variant(Extend)};
        Variant retVar = invoke_method(args,503,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return int
    */
    public int MoveDown(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashMoveDown.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,503,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveDown(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,503,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int MoveDown(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,503,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int MoveDown()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,503,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int HomeKey(Object[] Unit,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Extend)};
        Variant retVar = invoke_method(args,504,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int HomeKey(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,504,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int HomeKey()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,504,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int EndKey(Object[] Unit,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Extend)};
        Variant retVar = invoke_method(args,505,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int EndKey(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,505,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int EndKey()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,505,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    */
    public void EscapeKey()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,506,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param TextString
    */
    public void TypeText(String Text)
    {
        Variant[] args = {new Variant(Text)};
        invoke_method_void(args,507,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CopyFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,509,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PasteFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,510,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void TypeParagraph()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,512,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void TypeBackspace()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,513,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void NextSubdocument()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,514,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PreviousSubdocument()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,515,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectColumn()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,516,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectCurrentFont()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,517,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectCurrentAlignment()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,518,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectCurrentSpacing()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,519,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectCurrentIndent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,520,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectCurrentTabs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,521,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectCurrentColor()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,522,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CreateTextbox()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,523,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void WholeStory()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,524,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectRow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,525,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SplitTable()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,526,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumRowsObject[]
    * @param NumRowsObject[]
    */
    public void InsertRows(Object[] NumRows)
    {
        Variant[] args = {new Variant(NumRows)};
        invoke_method_void(args,528,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertRows()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,528,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertColumns()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,529,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormulaObject[]
    * @param NumberFormatObject[]
    * @param FormulaObject[]
    * @param NumberFormatObject[]
    */
    public void InsertFormula(Object[] Formula,Object[] NumberFormat)
    {
        Variant[] args = {new Variant(Formula),new Variant(NumberFormat)};
        invoke_method_void(args,530,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormulaObject[]
    * @param FormulaObject[]
    */
    public void InsertFormula(Object[] Formula)
    {
        Variant[] args = {new Variant(Formula)};
        invoke_method_void(args,530,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertFormula()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,530,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param WrapObject[]
    * @param WrapObject[]
    * @return Revision
    */
    public Revision NextRevision(Object[] Wrap)
    {
        Variant[] args = {new Variant(Wrap)};
        Variant retVar = invoke_method(args,531,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Revision ret = new Revision(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Revision
    */
    public Revision NextRevision()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,531,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Revision ret = new Revision(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WrapObject[]
    * @param WrapObject[]
    * @return Revision
    */
    public Revision PreviousRevision(Object[] Wrap)
    {
        Variant[] args = {new Variant(Wrap)};
        Variant retVar = invoke_method(args,532,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Revision ret = new Revision(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Revision
    */
    public Revision PreviousRevision()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,532,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Revision ret = new Revision(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void PasteAsNestedTable()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,533,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NameString
    * @param StyleNameString
    * @param NameString
    * @param StyleNameString
    * @return AutoTextEntry
    */
    public AutoTextEntry CreateAutoTextEntry(String Name,String StyleName)
    {
        Variant[] args = {new Variant(Name),new Variant(StyleName)};
        Variant retVar = invoke_method(args,534,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        AutoTextEntry ret = new AutoTextEntry(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void DetectLanguage()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,535,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SelectCell()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,536,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumRowsObject[]
    * @param NumRowsObject[]
    */
    public void InsertRowsBelow(Object[] NumRows)
    {
        Variant[] args = {new Variant(NumRows)};
        invoke_method_void(args,537,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertRowsBelow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,537,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertColumnsRight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,538,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumRowsObject[]
    * @param NumRowsObject[]
    */
    public void InsertRowsAbove(Object[] NumRows)
    {
        Variant[] args = {new Variant(NumRows)};
        invoke_method_void(args,539,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertRowsAbove()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,539,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void RtlRun()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,600,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void LtrRun()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,601,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void BoldRun()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,602,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ItalicRun()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,603,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void RtlPara()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,605,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void LtrPara()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,606,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateLanguageObject[]
    * @param CalendarTypeObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateLanguageObject[]
    * @param CalendarTypeObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat,Object[] InsertAsField,Object[] InsertAsFullWidth,Object[] DateLanguage,Object[] CalendarType)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField),new Variant(InsertAsFullWidth),new Variant(DateLanguage),new Variant(CalendarType)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertDateTime(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertDateTime.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateLanguageObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateLanguageObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat,Object[] InsertAsField,Object[] InsertAsFullWidth,Object[] DateLanguage)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField),new Variant(InsertAsFullWidth),new Variant(DateLanguage)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat,Object[] InsertAsField,Object[] InsertAsFullWidth)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField),new Variant(InsertAsFullWidth)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat,Object[] InsertAsField)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param DateTimeFormatObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat)
    {
        Variant[] args = {new Variant(DateTimeFormat)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertDateTime()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param LanguageIDObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param LanguageIDObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics,Object[] IgnoreHe,Object[] LanguageID)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics),new Variant(IgnoreHe),new Variant(LanguageID)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void Sort(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashSort.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics,Object[] IgnoreHe)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics),new Variant(IgnoreHe)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param ExcludeHeaderObject[]
    */
    public void Sort(Object[] ExcludeHeader)
    {
        Variant[] args = {new Variant(ExcludeHeader)};
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Sort()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,445,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param AutoFitBehaviorObject[]
    * @param DefaultTableBehaviorObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param AutoFitBehaviorObject[]
    * @param DefaultTableBehaviorObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn,Object[] AutoFit,Object[] AutoFitBehavior,Object[] DefaultTableBehavior)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn),new Variant(AutoFit),new Variant(AutoFitBehavior),new Variant(DefaultTableBehavior)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Table
    */
    public Table ConvertToTable(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashConvertToTable.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param AutoFitBehaviorObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param AutoFitBehaviorObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn,Object[] AutoFit,Object[] AutoFitBehavior)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn),new Variant(AutoFit),new Variant(AutoFitBehavior)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn,Object[] AutoFit)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn),new Variant(AutoFit)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param SeparatorObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator)
    {
        Variant[] args = {new Variant(Separator)};
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Table
    */
    public Table ConvertToTable()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,457,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getNoProofing()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1005,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setNoProofing(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1005,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Tables
    */
    public Tables getTopLevelTables()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1006,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Tables ret = new Tables(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getLanguageDetected()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1007,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setLanguageDetected(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1007,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getFitTextWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1008,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setFitTextWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1008,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
