package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Shapes
* DO NOT EDIT THIS CODE 
* EDIT the subclass Shapes
* @author S Lewis
*/
public class _Shapes extends WDispatch
{
    public static final String clsid = "{0002099F-0000-0000-C000-000000000046}";
    protected static Map gParamHashAddPicture;
    protected static Map gParamHashAddOLEObject;
    protected static Map gParamHashAddOLEControl;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAddPicture = new HashMap();
        gParamHashAddPicture.put("FileName",new Integer(0));
        gParamHashAddPicture.put("LinkToFile",new Integer(1));
        gParamHashAddPicture.put("SaveWithDocument",new Integer(2));
        gParamHashAddPicture.put("Left",new Integer(3));
        gParamHashAddPicture.put("Top",new Integer(4));
        gParamHashAddPicture.put("Width",new Integer(5));
        gParamHashAddPicture.put("Height",new Integer(6));
        gParamHashAddPicture.put("Anchor",new Integer(7));

        gParamHashAddOLEObject = new HashMap();
        gParamHashAddOLEObject.put("ClassType",new Integer(0));
        gParamHashAddOLEObject.put("FileName",new Integer(1));
        gParamHashAddOLEObject.put("LinkToFile",new Integer(2));
        gParamHashAddOLEObject.put("DisplayAsIcon",new Integer(3));
        gParamHashAddOLEObject.put("IconFileName",new Integer(4));
        gParamHashAddOLEObject.put("IconIndex",new Integer(5));
        gParamHashAddOLEObject.put("IconLabel",new Integer(6));
        gParamHashAddOLEObject.put("Left",new Integer(7));
        gParamHashAddOLEObject.put("Top",new Integer(8));
        gParamHashAddOLEObject.put("Width",new Integer(9));
        gParamHashAddOLEObject.put("Height",new Integer(10));
        gParamHashAddOLEObject.put("Anchor",new Integer(11));

        gParamHashAddOLEControl = new HashMap();
        gParamHashAddOLEControl.put("ClassType",new Integer(0));
        gParamHashAddOLEControl.put("Left",new Integer(1));
        gParamHashAddOLEControl.put("Top",new Integer(2));
        gParamHashAddOLEControl.put("Width",new Integer(3));
        gParamHashAddOLEControl.put("Height",new Integer(4));
        gParamHashAddOLEControl.put("Anchor",new Integer(5));

    }
    /**
    * default constructor
    */
    public _Shapes()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Shapes(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Shapes(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @param IndexObject[]
    * @param IndexObject[]
    * @return Shape
    */
    public Shape Item(Object[] Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TypeintRealType - MsoCalloutType
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param AnchorObject[]
    * @param TypeintRealType - MsoCalloutType
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddCallout(int Type,float Left,float Top,float Width,float Height,Object[] Anchor)
    {
        Variant[] args = {new Variant(Type),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height),new Variant(Anchor)};
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TypeintRealType - MsoCalloutType
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param TypeintRealType - MsoCalloutType
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddCallout(int Type,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Type),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TypeintRealType - MsoConnectorType
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @param TypeintRealType - MsoConnectorType
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @return Shape
    */
    public Shape AddConnector(int Type,float BeginX,float BeginY,float EndX,float EndY)
    {
        Variant[] args = {new Variant(Type),new Variant(BeginX),new Variant(BeginY),new Variant(EndX),new Variant(EndY)};
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SafeArrayOfPointsObject[]
    * @param AnchorObject[]
    * @param SafeArrayOfPointsObject[]
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddCurve(Object[] SafeArrayOfPoints,Object[] Anchor)
    {
        Variant[] args = {new Variant(SafeArrayOfPoints),new Variant(Anchor)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SafeArrayOfPointsObject[]
    * @param SafeArrayOfPointsObject[]
    * @return Shape
    */
    public Shape AddCurve(Object[] SafeArrayOfPoints)
    {
        Variant[] args = {new Variant(SafeArrayOfPoints)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param AnchorObject[]
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddLabel(int Orientation,float Left,float Top,float Width,float Height,Object[] Anchor)
    {
        Variant[] args = {new Variant(Orientation),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height),new Variant(Anchor)};
        Variant retVar = invoke_method(args,13,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddLabel(int Orientation,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Orientation),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,13,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @param AnchorObject[]
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddLine(float BeginX,float BeginY,float EndX,float EndY,Object[] Anchor)
    {
        Variant[] args = {new Variant(BeginX),new Variant(BeginY),new Variant(EndX),new Variant(EndY),new Variant(Anchor)};
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @return Shape
    */
    public Shape AddLine(float BeginX,float BeginY,float EndX,float EndY)
    {
        Variant[] args = {new Variant(BeginX),new Variant(BeginY),new Variant(EndX),new Variant(EndY)};
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param AnchorObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddPicture(String FileName,Object[] LinkToFile,Object[] SaveWithDocument,Object[] Left,Object[] Top,Object[] Width,Object[] Height,Object[] Anchor)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile),new Variant(SaveWithDocument),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height),new Variant(Anchor)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Shape
    */
    public Shape AddPicture(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddPicture.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @return Shape
    */
    public Shape AddPicture(String FileName,Object[] LinkToFile,Object[] SaveWithDocument,Object[] Left,Object[] Top,Object[] Width,Object[] Height)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile),new Variant(SaveWithDocument),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @return Shape
    */
    public Shape AddPicture(String FileName,Object[] LinkToFile,Object[] SaveWithDocument,Object[] Left,Object[] Top,Object[] Width)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile),new Variant(SaveWithDocument),new Variant(Left),new Variant(Top),new Variant(Width)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @return Shape
    */
    public Shape AddPicture(String FileName,Object[] LinkToFile,Object[] SaveWithDocument,Object[] Left,Object[] Top)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile),new Variant(SaveWithDocument),new Variant(Left),new Variant(Top)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param LeftObject[]
    * @return Shape
    */
    public Shape AddPicture(String FileName,Object[] LinkToFile,Object[] SaveWithDocument,Object[] Left)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile),new Variant(SaveWithDocument),new Variant(Left)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @return Shape
    */
    public Shape AddPicture(String FileName,Object[] LinkToFile,Object[] SaveWithDocument)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile),new Variant(SaveWithDocument)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @return Shape
    */
    public Shape AddPicture(String FileName,Object[] LinkToFile)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    * @return Shape
    */
    public Shape AddPicture(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SafeArrayOfPointsObject[]
    * @param AnchorObject[]
    * @param SafeArrayOfPointsObject[]
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddPolyline(Object[] SafeArrayOfPoints,Object[] Anchor)
    {
        Variant[] args = {new Variant(SafeArrayOfPoints),new Variant(Anchor)};
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SafeArrayOfPointsObject[]
    * @param SafeArrayOfPointsObject[]
    * @return Shape
    */
    public Shape AddPolyline(Object[] SafeArrayOfPoints)
    {
        Variant[] args = {new Variant(SafeArrayOfPoints)};
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param Typeint
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param AnchorObject[]
    * @param Typeint
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddShape(int Type,float Left,float Top,float Width,float Height,Object[] Anchor)
    {
        Variant[] args = {new Variant(Type),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height),new Variant(Anchor)};
        Variant retVar = invoke_method(args,17,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param Typeint
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param Typeint
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddShape(int Type,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Type),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,17,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param PresetTextEffectintRealType - MsoPresetTextEffect
    * @param TextString
    * @param FontNameString
    * @param FontSizefloat
    * @param FontBoldintRealType - MsoTriState
    * @param FontItalicintRealType - MsoTriState
    * @param Leftfloat
    * @param Topfloat
    * @param AnchorObject[]
    * @param PresetTextEffectintRealType - MsoPresetTextEffect
    * @param TextString
    * @param FontNameString
    * @param FontSizefloat
    * @param FontBoldintRealType - MsoTriState
    * @param FontItalicintRealType - MsoTriState
    * @param Leftfloat
    * @param Topfloat
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddTextEffect(int PresetTextEffect,String Text,String FontName,float FontSize,int FontBold,int FontItalic,float Left,float Top,Object[] Anchor)
    {
        Variant[] args = {new Variant(PresetTextEffect),new Variant(Text),new Variant(FontName),new Variant(FontSize),new Variant(FontBold),new Variant(FontItalic),new Variant(Left),new Variant(Top),new Variant(Anchor)};
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param PresetTextEffectintRealType - MsoPresetTextEffect
    * @param TextString
    * @param FontNameString
    * @param FontSizefloat
    * @param FontBoldintRealType - MsoTriState
    * @param FontItalicintRealType - MsoTriState
    * @param Leftfloat
    * @param Topfloat
    * @param PresetTextEffectintRealType - MsoPresetTextEffect
    * @param TextString
    * @param FontNameString
    * @param FontSizefloat
    * @param FontBoldintRealType - MsoTriState
    * @param FontItalicintRealType - MsoTriState
    * @param Leftfloat
    * @param Topfloat
    * @return Shape
    */
    public Shape AddTextEffect(int PresetTextEffect,String Text,String FontName,float FontSize,int FontBold,int FontItalic,float Left,float Top)
    {
        Variant[] args = {new Variant(PresetTextEffect),new Variant(Text),new Variant(FontName),new Variant(FontSize),new Variant(FontBold),new Variant(FontItalic),new Variant(Left),new Variant(Top)};
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param AnchorObject[]
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddTextbox(int Orientation,float Left,float Top,float Width,float Height,Object[] Anchor)
    {
        Variant[] args = {new Variant(Orientation),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height),new Variant(Anchor)};
        Variant retVar = invoke_method(args,19,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddTextbox(int Orientation,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Orientation),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,19,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @return FreeformBuilder
    */
    public FreeformBuilder BuildFreeform(int EditingType,float X1,float Y1)
    {
        Variant[] args = {new Variant(EditingType),new Variant(X1),new Variant(Y1)};
        Variant retVar = invoke_method(args,20,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        FreeformBuilder ret = new FreeformBuilder(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param IndexObject[]
    * @param IndexObject[]
    * @return ShapeRange
    */
    public ShapeRange Range(Object[] Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,21,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        ShapeRange ret = new ShapeRange(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void SelectAll()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,22,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param AnchorObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex,Object[] IconLabel,Object[] Left,Object[] Top,Object[] Width,Object[] Height,Object[] Anchor)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height),new Variant(Anchor)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Shape
    */
    public Shape AddOLEObject(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddOLEObject.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex,Object[] IconLabel,Object[] Left,Object[] Top,Object[] Width,Object[] Height)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex,Object[] IconLabel,Object[] Left,Object[] Top,Object[] Width)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left),new Variant(Top),new Variant(Width)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex,Object[] IconLabel,Object[] Left,Object[] Top)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left),new Variant(Top)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param LeftObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex,Object[] IconLabel,Object[] Left)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex,Object[] IconLabel)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType,Object[] FileName)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param ClassTypeObject[]
    * @return Shape
    */
    public Shape AddOLEObject(Object[] ClassType)
    {
        Variant[] args = {new Variant(ClassType)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Shape
    */
    public Shape AddOLEObject()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param AnchorObject[]
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param AnchorObject[]
    * @return Shape
    */
    public Shape AddOLEControl(Object[] ClassType,Object[] Left,Object[] Top,Object[] Width,Object[] Height,Object[] Anchor)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height),new Variant(Anchor)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Shape
    */
    public Shape AddOLEControl(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddOLEControl.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param HeightObject[]
    * @return Shape
    */
    public Shape AddOLEControl(Object[] ClassType,Object[] Left,Object[] Top,Object[] Width,Object[] Height)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param WidthObject[]
    * @return Shape
    */
    public Shape AddOLEControl(Object[] ClassType,Object[] Left,Object[] Top,Object[] Width)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Left),new Variant(Top),new Variant(Width)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param TopObject[]
    * @return Shape
    */
    public Shape AddOLEControl(Object[] ClassType,Object[] Left,Object[] Top)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Left),new Variant(Top)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @param ClassTypeObject[]
    * @param LeftObject[]
    * @return Shape
    */
    public Shape AddOLEControl(Object[] ClassType,Object[] Left)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Left)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param ClassTypeObject[]
    * @return Shape
    */
    public Shape AddOLEControl(Object[] ClassType)
    {
        Variant[] args = {new Variant(ClassType)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Shape
    */
    public Shape AddOLEControl()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

}
