package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object View
* DO NOT EDIT THIS CODE 
* EDIT the subclass View
* @author S Lewis
*/
public class _View extends WDispatch
{
    public static final String clsid = "{000209A5-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _View()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _View(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _View(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return WdViewTypeEnum
    */
    public WdViewTypeEnum getType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdViewTypeEnum ret = WdViewTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdViewTypeEnum
    * @param arg1WdViewTypeEnum
    */
    public void setType(WdViewTypeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,0,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getFullScreen()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setFullScreen(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDraft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDraft(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,2,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowAll()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowAll(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowFieldCodes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowFieldCodes(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getMailMergeDataView()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setMailMergeDataView(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getMagnifier()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setMagnifier(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,7,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowFirstLineOnly()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowFirstLineOnly(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowFormat(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Zoom
    */
    public Zoom getZoom()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Zoom ret = new Zoom(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getShowObjectAnchors()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowObjectAnchors(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,11,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowTextBoundaries()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowTextBoundaries(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,12,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowHighlight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,13,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowHighlight(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,13,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowDrawings()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowDrawings(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,14,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowTabs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowTabs(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,15,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowSpaces()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowSpaces(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,16,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowParagraphs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,17,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowParagraphs(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,17,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowHyphens()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowHyphens(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,18,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowHiddenText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,19,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowHiddenText(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,19,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getWrapToWindow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,20,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setWrapToWindow(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,20,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowPicturePlaceHolders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,21,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowPicturePlaceHolders(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,21,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowBookmarks()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,22,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowBookmarks(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,22,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdFieldShadingEnum
    */
    public WdFieldShadingEnum getFieldShading()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,23,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdFieldShadingEnum ret = WdFieldShadingEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdFieldShadingEnum
    * @param arg1WdFieldShadingEnum
    */
    public void setFieldShading(WdFieldShadingEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,23,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowAnimation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowAnimation(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,24,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getTableGridlines()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,25,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setTableGridlines(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,25,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getEnlargeFontsLessThan()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,26,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setEnlargeFontsLessThan(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,26,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowMainTextLayer()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,27,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowMainTextLayer(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,27,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdSeekViewEnum
    */
    public WdSeekViewEnum getSeekView()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,28,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdSeekViewEnum ret = WdSeekViewEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdSeekViewEnum
    * @param arg1WdSeekViewEnum
    */
    public void setSeekView(WdSeekViewEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,28,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdSpecialPaneEnum
    */
    public WdSpecialPaneEnum getSplitSpecial()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,29,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdSpecialPaneEnum ret = WdSpecialPaneEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdSpecialPaneEnum
    * @param arg1WdSpecialPaneEnum
    */
    public void setSplitSpecial(WdSpecialPaneEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,29,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getBrowseToWindow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,30,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setBrowseToWindow(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,30,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowOptionalBreaks()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,31,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowOptionalBreaks(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,31,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param RangeObject[]
    * @param RangeObject[]
    */
    public void CollapseOutline(Object[] Range)
    {
        Variant[] args = {new Variant(Range)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CollapseOutline()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param RangeObject[]
    * @param RangeObject[]
    */
    public void ExpandOutline(Object[] Range)
    {
        Variant[] args = {new Variant(Range)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ExpandOutline()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ShowAllHeadings()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,103,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param Levelint
    * @param Levelint
    */
    public void ShowHeading(int Level)
    {
        Variant[] args = {new Variant(Level)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PreviousHeaderFooter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,105,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void NextHeaderFooter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,106,DispatchConstants.DISPATCH_METHOD);
    }

}
