/*
 * Copyright (c) 1999 Dan Adler, 315 E72 St. NY, NY, 10021, USA.
 * mailto:danadler@rcn.com. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 3. Redistributions in any form must be accompanied by information on
 *    how to obtain complete source code for the JACOB software.
 *
 * Redistribution of the JACOB software is not permitted as part of any
 * commercial product that is targeted primarily at Java developers.
 * Such products include, but are not limited to: Java virtual machines,
 * integrated development environments, code libraries, and application
 * server products. Licensing terms for such distribution may be
 * obtained from the copyright holder.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
package com.jacob.activeX;

import com.jacob.com.Dispatch;
import com.jacob.com.*;

/**
 * This class simulates com.ms.activeX.ActiveXComponent only as
 * it used for creating Dispatch objects
 */
public class JDispatch
{
    public static Variant[] NULL_VARIANT_ARRAY = {} ;
    
    private Dispatch m_Dispatch;

  public JDispatch(String progid)
  {
    setDispatch(new Dispatch(progid));
  }
  
  public JDispatch(int progid)
  {
    setDispatch(new Dispatch(progid));
  }
  
  public JDispatch(String progid,ThreadingModelEnum ThreadingModel)
  {
    setDispatch(new Dispatch(progid,ThreadingModel));
  }
  

  public JDispatch(Object theObj) {
    //   setDispatch(dispatchFromObj(theObj));
  } 
  
  protected void setDispatch(Dispatch d) 
  {
      if(d.getDispatch() == 0)
            m_Dispatch = d; // break here - should be an exception
      m_Dispatch = d;
  }
  /*
  protected static Dispatch dispatchFromObj(Object theObj)
  {
      if(theObj instanceof Dispatch) {
         return((Dispatch)theObj);
      }
      if(theObj instanceof Jvariant) {
         return(((Jvariant)theObj).toDispatch());
      }
      if(theObj instanceof Variant) {
         return(((Variant)theObj).toDispatch());
      }
      throw new IllegalArgumentException("Wrong class to build dispatch "  + getClassName(theObj));
     */
     /* if(theObj instanceof Integer) {
         return(new Dispatch(((Integer)theObj).intValue()));
      }
      
      
  }
  
  */

  public JDispatch(String id,String DCOMServer ) { 
    throw new UnsupportedOperationException("No support for DCOM");
  } 
  
/*
    public synchronized native int CreateObject(String s)
        throws ComException;

    public synchronized native int CreateObjectDCOM(String s, String s1);

    public native void IDispatch_Invoke(int i, Jvariant ajvariant[], int j, short word0, Jvariant jvariant)
        throws ComException;

    public native void IDispatch_Invoke_propget(int i, int j, Jvariant jvariant);

    public native void IDispatch_Invoke_propput(int i, Jvariant jvariant, int j);

    public native int IDispatch_addListener(int i, String s, EventListener eventlistener, String s1);

    public native void IDispatch_removeListener(int i);
    public void ReleaseObject()
    {
        ReleaseObject(IDispatch);
    }

    public synchronized native void ReleaseObject(int i);

    public void addListener(String s, EventListener eventlistener)
    {
        String s1 = eventlistener.getClass().getSuperclass().getName();
        int i = s1.lastIndexOf(".");
        String s2 = s1.substring(0, i);
        pCEventListener = IDispatch_addListener(IDispatch, s, eventlistener, s2);
    }

    protected synchronized void finalize()
    {
        if(containedDispatch == null)
            ReleaseObject(IDispatch);
    }
    public void removeListener(String s, EventListener eventlistener)
    {
        IDispatch_removeListener(pCEventListener);
    }

*/
    public void addListener(String s, Object eventlistener)
    {
        String s1 = eventlistener.getClass().getSuperclass().getName();
        int i = s1.lastIndexOf(".");
        String s2 = s1.substring(0, i);
        throw new UnsupportedOperationException("Fix This");
    //    pCEventListener = IDispatch_addListener(IDispatch, s, eventlistener, s2);
    }

    public void removeListener(String s, Object eventlistener)
    {
        throw new UnsupportedOperationException("Fix This");
  //      IDispatch_removeListener(pCEventListener);
    }

    public static String getClassName(Object obj)
    {
        return obj.getClass().getName();
    }

    public Jvariant invoke_method(Jvariant ajvariant[], int DispID, short wFlags)
    {
        int err = 0;
        int[] uArgErr = { err };
        Variant[] args = buildVariantArray(ajvariant);
        Variant ret = Dispatch.invokev(m_Dispatch, DispID, wFlags,args , uArgErr);
        Jvariant jvariant = new Jvariant(ret);
        return jvariant;
    }

    public void invoke_method_void(Jvariant ajvariant[], int DispID, short wFlags)
    {
        int err = 0;
        int[] uArgErr = { err };
        Variant[] args = buildVariantArray(ajvariant);
        Dispatch.invokev(m_Dispatch, DispID, wFlags,args, uArgErr);
    }
    
    protected Variant[] buildVariantArray(Jvariant[] in) 
    {
        if(in == null)
            return(NULL_VARIANT_ARRAY);
        Variant[] ret = new Variant[in.length];
        for(int i = 0; i < in.length; i++) {
            ret[i] = in[i].getVariant();
        }
        return(ret);
    }

    public Jvariant invoke_propget(int i)
    {
        Jvariant jvariant = new Jvariant();
   //     IDispatch_Invoke_propget(IDispatch, i, jvariant);
        System.out.println("propget - " + jvariant);
        return jvariant;
    }

    public void invoke_propput(Jvariant jvariant, int i)
    {
  //      IDispatch_Invoke_propput(IDispatch, jvariant, i);
    }


  public Variant invoke(String name, Variant[] args)
  {
    return Dispatch.callN(m_Dispatch, name, args);
  }

  public Variant getProperty(String name)
  {
    return Dispatch.get(m_Dispatch, name);
  }

  public void setProperty(String name, Variant arg)
  {
    Dispatch.put(m_Dispatch, name, arg);
  }
  
  public Dispatch getDispatch()
  {
      return(m_Dispatch);
  }
}
