/*
 * Copyright (c) 1999 Dan Adler, 315 E72 St. NY, NY, 10021, USA.
 * mailto:danadler@rcn.com. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in 
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 3. Redistributions in any form must be accompanied by information on
 *    how to obtain complete source code for the JACOB software.
 *
 * Redistribution of the JACOB software is not permitted as part of any
 * commercial product that is targeted primarily at Java developers.
 * Such products include, but are not limited to: Java virtual machines,
 * integrated development environments, code libraries, and application
 * server products. Licensing terms for such distribution may be
 * obtained from the copyright holder.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
package com.jacob.activeX;
import java.io.PrintStream;
import java.util.Date;


import com.jacob.com.*;

/**
 * This class simulates com.ms.activeX.ActiveXComponent only as
 * it used for creating Dispatch objects
 */
public class Jvariant  implements COMconstants
{
    private Variant m_var;
    private long vt;
    public Jvariant(Variant v)
    {
        m_var = v;
        
    }
    
    public Jvariant(Object o, int i)
    {
        m_var  = new Variant(o,((i & VT_BYREF) != 0));
        vt = (long) i;
    }
    
    public Jvariant(boolean bool, int i)
    {
        m_var  = new Variant(bool);
        vt = (long) i;
    }

    public Jvariant()
    {
        m_var  = new Variant();
    }

    public Jvariant(byte b, int i)
    {
        m_var  = new Variant(b);
        vt = (long) i;
    }

    public Jvariant(double d, int i)
    {
        m_var  = new Variant(d);
        vt = (long) i;
    }

    public Jvariant(float f, int i)
    {
        m_var  = new Variant(f);
        vt = (long) i;
    }

    public Jvariant(int i, int j)
    {
        m_var  = new Variant(i);
        vt = (long) j;
    }
    
    public Variant getVariant()
    {
        return(m_var);
    }
    
    public int getIID() 
    {
        return m_var.getIID();
    }


    
    public int intVal()
    {
        return m_var.getInt();
    }
    public short shortVal()
    {
        return m_var.getShort();
    }
    public byte byteVal()
    {
        return m_var.getByte();
    }
    public float floatVal()
    {
        return m_var.getFloat();
    }
    public double doubleVal()
    {
        return m_var.getDouble();
    }
    public boolean booleanVal()
    {
        return m_var.getBoolean();
    }
    public String StringVal()
    {
        return m_var.getString();
    }
    
    public Object ObjectVal()
    {
        return m_var.getObject();
    }
    
  /*  public Dispatch toDispatch()
    {
       return m_var.toDispatch();
    }
    
    public Object ForceObjectVal()
    {
         return m_var.ForceObjectVal();
    }
    */
}