
package com.jacob.com;

/**
* This exposes several important utility functions
* @author Steve Lewis
*/
public abstract class COMUtils
{

  static {
    System.loadLibrary("jacob");
  }

    /** 
    * @param in non-null id
    * @return non-null String
    */
    public static String stringFromCLSID(String in) {
        return(doStringFromCLSID(in));
    }
    
    protected static native String doStringFromCLSID(String in);
    
    /** 
    * @param in non-null id
    * @return non-null String
    */
    public static String CLSIDFromString(String in) {
        return(doCLSIDFromString(in));
    }
    
    protected static native String doCLSIDFromString(String in);
    
    
    /** 
    * @param in non-null id
    * @return non-null String
    */
    public static String stringFromIID(String in) {
        return(doStringFromIID(in));
    }
    
    protected static native String doStringFromIID(String in);
    
    
    /** 
    * @param in non-null id
    * @return non-null String
    */
    public static String IIDFromString(String in) {
        return(doIIDFromString(in));
    }
    
    protected static native String doIIDFromString(String in);
    
    
    /** 
    * @param in non-null id
    * @return non-null String
    */
    public static String progIDFromCLSID(String in) {
        return(doProgIDFromCLSID(in));
    }
    
    protected static native String doProgIDFromCLSID(String in);
    
    /** 
    * @param in non-null id
    * @return non-null String
    */
    public static String CLSIDFromProgID(String in) {
        return(doCLSIDFromProgID(in));
    }
    
    protected static native String doCLSIDFromProgID(String in);

    /** 
    * @param in non-null id
    * @return non-null String
    */
    public static String stringFromGUID2(String in) {
        return(doStringFromGUID2(in));
    }
    
    protected static native String doStringFromGUID2(String in);
}
