package jp.jcomgenerator;
import jp.ne.so_net.ga2.no_ji.jcom.*;
import java.io.*;
import java.util.*;
import java.text.DateFormat;

/**
	w肵ITypeInfoJava-COMubW𐶐NXB
	
	COMJavåTOIȑΉ
	ITypeLib	package
	ITypeInfo	class
	\bh	\bh

*/
public class CollectTypeLib {
	protected String packagename = null;
	protected String outdirs = null;
	
	public void setPackage(String packagename) { this.packagename = packagename; }
	public void setOutDirs(String outdirs) { this.outdirs = outdirs; }
	public String getPath() {
		String path = "";
		if(outdirs != null) {
			path = outdirs;
		}
		if(packagename != null) {
			if(path.length() > 0 && ! path.endsWith(File.separator))
				path += File.separator;
			path += packagename.replace('.', File.separatorChar);	// '\\'
		}
		return path;
	}
	public boolean makedirs() {
		return (new File(getPath())).mkdir();
	}
	public String getFilename(String classname) {
		String path = getPath();
		return path + File.separator + classname + ".java";
	}

	/**
		TYPEATTR.typekind ɂAꍇ
	*/
	public boolean generate(ITypeInfo info) {
		try {
			ITypeInfo.TypeAttr attr = info.getTypeAttr();
			// ׂĂ̓T|[gĂȂB(;_;)
			switch(attr.getTypeKind()) {
				case ITypeInfo.TypeAttr.TKIND_ENUM:			return generateEnum(info);
				case ITypeInfo.TypeAttr.TKIND_DISPATCH:		return generateDispatch(info);
				case ITypeInfo.TypeAttr.TKIND_COCLASS:		return generateCoClass(info);
				case ITypeInfo.TypeAttr.TKIND_RECORD:		
				case ITypeInfo.TypeAttr.TKIND_MODULE:		
				case ITypeInfo.TypeAttr.TKIND_INTERFACE:	// 3
				case ITypeInfo.TypeAttr.TKIND_ALIAS:		
				case ITypeInfo.TypeAttr.TKIND_UNION:		
//					return generateNoSupport(info);
					System.out.println("@@@ Ή TypeKind="+attr.getTypeKind());
					break;
				default: 
					System.out.println("@@@@HI "+attr.getTypeKind());
			}
			return true;
		}catch(Exception e) { e.printStackTrace(); }
		return false;
	}
	/**
		t@Cwb_o
	*/
	void outHeader(PrintWriter out) {
		// ݓ擾B
		Date now = Calendar.getInstance().getTime();
		String nowstr = DateFormat.getDateTimeInstance().format(now);
		out.println("// Something in Japanese");
		out.println("//");
		out.println("// generated by "+this.getClass().toString()+" at "+nowstr);
		out.println("// JCom ?.??   URL=http://www02.so-net.ne.jp/~no-ji");
		if(packagename!=null) out.println("package "+packagename+";");
		out.println();
		out.println("import jp.ne.so_net.ga2.no_ji.jcom.*;");
		out.println();
	}

	/**
		T|[gĂȂ^CṽC^[tF[X𐶐܂B
		TYPEATTR.typekind  TKIND_???? ̃mɑ΂Đ
		fobOpɏo͂܂B
	*/
	public boolean generateNoSupport(ITypeInfo info) {
		try {
			String[] docs = info.getDocumentation(-1);
			// t@CI[v
			makedirs();
			String fname = getFilename(docs[0]);
			PrintWriter out = 
					new PrintWriter(new BufferedWriter(new FileWriter(fname)));
			// t@Cwb_o
			outHeader(out);
			// o
			ITypeInfo.TypeAttr attr = info.getTypeAttr();
			out.println("@@@ Ή TypeKind="+attr.getTypeKind());
			switch(attr.getTypeKind()) {
				case ITypeInfo.TypeAttr.TKIND_ENUM:			out.print("TKIND_ENUM");	break;
				case ITypeInfo.TypeAttr.TKIND_DISPATCH:		out.print("TKIND_DISPATCH");	break;
				case ITypeInfo.TypeAttr.TKIND_RECORD:		out.print("TKIND_RECORD");	break;
				case ITypeInfo.TypeAttr.TKIND_MODULE:		out.print("TKIND_MODULE");	break;
				case ITypeInfo.TypeAttr.TKIND_INTERFACE:	out.print("TKIND_INTERFACE");	break;
				case ITypeInfo.TypeAttr.TKIND_COCLASS:		out.print("TKIND_COCLASS");	break;
				case ITypeInfo.TypeAttr.TKIND_ALIAS:		out.print("TKIND_ALIAS");	break;
				case ITypeInfo.TypeAttr.TKIND_UNION:		out.print("TKIND_UNION");	break;
			}
			// t@C
			out.close();
			return true;
		}catch(Exception e) { e.printStackTrace(); }
		return false;
	}

	/**
		񋓌^̃NX𐶐܂B
		TYPEATTR.typekind  TKIND_ENUM ̃mɑ΂Đ
		varkind  VAR_CONST ̂̂ΉĂ܂񂪁A
		Excel̏ꍇAꂵȂ悤łB
	*/
	public boolean generateEnum(ITypeInfo info) {
		try {
			String[] docs = info.getDocumentation(-1);
			// t@CI[v
			makedirs();
			String fname = getFilename(docs[0]);
			PrintWriter out = 
					new PrintWriter(new BufferedWriter(new FileWriter(fname)));
			// t@Cwb_o
			outHeader(out);
			// ֐wb_o
			out.println("/**");
			out.println("\tEnum "+docs[0]+((docs[1]!=null)?docs[1]:""));
			out.println("\t"+docs[3]+" "+docs[2]);
			out.println("*/");
			out.println("public class "+docs[0]+" {");
			// W̃oo
			ITypeInfo.TypeAttr attr = info.getTypeAttr();
			// ֐o
			if(attr.getFuncs()!=0) {
				out.print("Enumɂ͊֐͂Ȃ񂶂Ȃ́H");
				return false;
			}
			for(int f=0; f<attr.getVars(); f++) {
				ITypeInfo.VarDesc   vardesc   = info.getVarDesc(f);
				ITypeInfo.ElemDesc  elemVar   = vardesc.getVar();
				String[]            names     = vardesc.getNames();
				Object              value     = vardesc.getValue();
				switch(vardesc.getVarKind()) {
					case ITypeInfo.VarDesc.VAR_CONST:		// 2
						out.println("\tpublic static final "+getJavaType(elemVar.toString())+" "+ names[0]+" = "+value+";");
						break;
					case ITypeInfo.VarDesc.VAR_PERINSTANCE:	// 0
					case ITypeInfo.VarDesc.VAR_STATIC:		// 1
					case ITypeInfo.VarDesc.VAR_DISPATCH:	// 3
						out.print("\t/* @@@ Ή Enum "+vardesc.toString()+" */");
					break;
				}
			}
			out.println("}");
			// t@C
			out.close();
			return true;
		}catch(Exception e) { e.printStackTrace(); }
		return false;
	}

	//	TYPEATTR.typekind  TKIND_DISPATCH ̃mɑ΂Đ
	public boolean generateDispatch(ITypeInfo info) {
		// t@C 
		try {
			String[] docs = info.getDocumentation(-1);
			// t@CI[v
			makedirs();
			String fname = getFilename(docs[0]);
			PrintWriter out = 
					new PrintWriter(new BufferedWriter(new FileWriter(fname)));
			// t@Cwb_o
			outHeader(out);
			// NXwb_o
			out.println("/**");
			out.println("\tDispatch "+docs[0]+((docs[1]!=null)?docs[1]:""));
			out.println("\t"+docs[3]+" "+docs[2]);
			out.println("*/");
			out.println("public class "+docs[0]+" extends IDispatch {");
			// W̃oóBinterface ID
			ITypeInfo.TypeAttr attr = info.getTypeAttr();
			out.println("\t/**");
			out.println("\t\tC^[tF[XhcłB");
			out.println("\t\t@see\tGUID");
			out.println("\t*/");
			out.println("\tpublic static GUID IID = GUID.parse(\""+attr.getIID().toString()+"\");");
			out.println();
			// W̃oóBIDispatch̐
			out.println("\t/**");
			out.println("\t\tIDispatch琶B߂l琶ƂɎgp");
			out.println("\t*/");
			out.println("\tpublic "+docs[0]+"(IDispatch disp) { super(disp); }");
			out.println();
			// ֐o
			for(int f=0; f<attr.getFuncs(); f++) {
				ITypeInfo.FuncDesc   funcdesc   = info.getFuncDesc(f);
				ITypeInfo.ElemDesc   elemFunc   = funcdesc.getFunc();
				ITypeInfo.ElemDesc[] elemParams = funcdesc.getParams();
				String[]             names      = funcdesc.getNames();
				// IDispatchȊO̊֐𐶐BQueryInterface()Ȃǂ͂Ȃ
				if(! isIDispatchFunction(names[0])) {
					// ֐wb_𐶐BȂׂȀo͂ĂB
					out.print("\t/*\n");
					out.print("\t\t"+funcdesc.toString()+"\n");
					String[] funcdocs = info.getDocumentation(f);
					if(funcdocs != null) {
						out.print("\t\t");
						if(funcdocs[0]!=null) out.print(funcdocs[0]+" ");
						if(funcdocs[1]!=null) out.print(funcdocs[1]+" ");
						if(funcdocs[2]!=null) out.print(funcdocs[2]+" ");
						if(funcdocs[3]!=null) out.print(funcdocs[3]+" ");
						out.print("\n");
					}
					out.print("\t*/\n");
					String flagname = "";
					switch(funcdesc.getInvokeKind()) {
						case ITypeInfo.FuncDesc.INVOKE_FUNC:
							flagname = "IDispatch.METHOD";
							break;
						case ITypeInfo.FuncDesc.INVOKE_PROPERTYGET:
							flagname = "IDispatch.PROPERTYGET";
							break;
						case ITypeInfo.FuncDesc.INVOKE_PROPERTYPUT:
							flagname = "IDispatch.PROPERTYPUT";
							break;
						case ITypeInfo.FuncDesc.INVOKE_PROPERTYPUTREF:
							out.print("\t// @@@ Ή INVOKE_PROPERTYPUTREF\n");
							flagname = "IDispatch.PROPERTYPUTREF";
							break;
					}
					// \bh錾
					out.print("\t"+getJavaType(elemFunc.getTypeDesc())+" "+names[0]+"(");
					if(elemParams != null) {
						for(int p=0; p<elemParams.length; p++) {
							String argname = (names.length>p+1) ? names[p+1] : ("_"+p);		// OȂƂ "_1"
							out.print(getJavaType(elemParams[p].getTypeDesc())+" "+argname);
							if(p==elemParams.length-1)
								out.print(") {\n");
							else {
								out.print(", ");
								// TƂɉsĂBȐSB
								if(p%5==4) out.print("\n\t\t\t\t\t");
							}
						}
					}
					else {
						out.println(") {");
					}
					// ϊAĂяo
					if(elemParams!=null && elemParams.length>0) {
						out.print("\t\tObject[] params = new Object["+(elemParams.length)+"];\n");
						for(int i=0; i<elemParams.length; i++) {
							out.print("\t\tparams["+i+"] = ");
							String argname = (names.length>i+1) ? names[i+1] : ("_"+i);		// OȂƂ "_1"
							out.print(generateArgument(elemParams[i], argname)+";\n");
						}
						out.print("\t\tObject rc = invoke(\""+names[0]+"\", "+flagname+", params);\n");
					}
					else {
						out.print("\t\tObject rc = invoke(\""+names[0]+"\", "+flagname+", null);\n");
					}
					// return Xe[ggo
					out.print("\t\t"+generateReturnStatement(elemFunc,"rc")+"\n");
					out.println("\t}");
				}
			}
			out.println("}");
			// t@C
			out.close();
			return true;
		}catch(Exception e) { e.printStackTrace(); }
		return false;
	}

	//	TYPEATTR.typekind  TKIND_COCLASS ̃mɑ΂Đ
	public boolean generateCoClass(ITypeInfo info) {
		// t@C 
		try {
			String[] docs = info.getDocumentation(-1);
			// t@CI[v
			makedirs();
			String fname = getFilename(docs[0]);
			PrintWriter out = 
					new PrintWriter(new BufferedWriter(new FileWriter(fname)));
			// t@Cwb_o
			outHeader(out);
			// ֐wb_o
			out.println("/**");
			out.println("\tCoClass "+docs[0]+((docs[1]!=null)?docs[1]:""));
			out.println("\t"+docs[3]+" "+docs[2]);
			ITypeInfo.TypeAttr attr = info.getTypeAttr();
			for(int i=0; i<attr.getImplTypes(); i++) {
				ITypeInfo imp = info.getImplType(i);
				out.println("\t"+imp.getDocumentation(-1)[0]);
			}
			out.println("*/");
			ITypeInfo impl = info.getImplType(0);
			out.println("public class "+docs[0]+" extends "+impl.getDocumentation(-1)[0]+" {");
			// W̃oo
			out.println("\t/**");
			out.println("\t\tIDispatch琶B߂l琶ƂɎgp");
			out.println("\t*/");
			out.println("\tpublic "+docs[0]+"(IDispatch disp) { super(disp); }");
			out.println();
			out.println("}");
			// t@C
			out.close();
			return true;
		}catch(Exception e) { e.printStackTrace(); }
		return false;
	}
	/**
		IDispatchC^[tF[XŒ`Ă֐ǂ𒲂ׂB
		PɊ֐ŔfĂ邾B
	*/
	protected boolean isIDispatchFunction(String funcname) {
		String[] fnames = {
			"QueryInterface",
			"AddRef",
			"Release",
			"GetTypeInfoCount",
			"GetTypeInfo",
			"GetIDsOfNames",
			"Invoke" };
		for(int i=0; i<fnames.length; i++) {
			if(funcname.equals(fnames[i])) return true;
		}
		return false;
	}
	/**
		VARIANŤ^Javǎ^ɕϊ
	*/
	protected String getJavaType(String type) {
		if(type.equals("VT_INT")) return "int";
		if(type.equals("VT_I4")) return "int";
		if(type.startsWith("VT_PTR+VT_USERDEFINED:")) return type.substring("VT_PTR+VT_USERDEFINED:".length());
		if(type.equals("VT_R4")) return "float";
		if(type.equals("VT_R8")) return "double";
		if(type.equals("VT_BSTR")) return "String";
		if(type.equals("VT_VOID")) return "void";
		if(type.equals("VT_VARIANT")) return "Object";
		if(type.equals("VT_BOOL")) return "boolean";
		if(type.equals("VT_DISPATCH")) return "IDispatch";
		if(type.equals("VT_UNKNOWN")) return "IUnknown";
		if(type.equals("VT_DATE")) return "java.util.Date";

		// VT_PTR̂ȂVT_USERDEFINEDEnumƌȂAEnumintƂ݂ȂBƗ\H
		if(type.startsWith("VT_USERDEFINED:")) 
		    return "int";
		return "@@@"+type;
	}
	/**
		ݒ肷ӏ𐶐
	*/
	String generateArgument(ITypeInfo.ElemDesc elem, String name) {
		String jtype = getJavaType(elem.getTypeDesc());
		if(jtype.equals("boolean")) return "new Boolean("+name+")";
		if(jtype.equals("int")) return "new Integer("+name+")";
		if(jtype.equals("double")) return "new Double("+name+")";
		if(jtype.equals("float")) return "new Float("+name+")";
		if(jtype.equals("String")) return name;
		if(jtype.equals("Object")) return name;
		if(elem.getTypeDesc().startsWith("VT_PTR+VT_USERDEFINED:")) return name;
		return "@@@"+name;
	}
	/**
		return𐶐
	*/
	String generateReturnStatement(ITypeInfo.ElemDesc elem, String var) {
		String jtype = getJavaType(elem.getTypeDesc());
		if(jtype.equals("void")) return "return;";
		if(jtype.equals("int")) return "return ((Integer)"+var+").intValue();";
		if(jtype.equals("double")) return "return ((Double)"+var+").doubleValue();";
		if(jtype.equals("float")) return "return ((Float)"+var+").floatValue();";
		if(jtype.equals("boolean")) return "return ((Boolean)"+var+").booleanValue();";
		if(jtype.equals("Object")) return "return "+var+";";
		if(jtype.equals("String")) return "return (String)"+var+";";
		if(jtype.equals("java.util.Date")) return "return (java.util.Date)"+var+";";
		if(elem.getTypeDesc().startsWith("VT_PTR+VT_USERDEFINED:"))
				return "return new "+getJavaType(elem.getTypeDesc())+"((IDispatch)"+var+");";
		if(elem.getTypeDesc().equals("VT_DISPATCH"))
				return "return (IDispatch)"+var+";";
		if(elem.getTypeDesc().equals("VT_UNKNOWN"))
				return "return (IUnknown)"+var+";";

		return "return "+jtype+"@@@"+var;
	}
	/**
		g
	*/
	public static void usage() {
		System.out.println(" Something in JapaneseB");
		System.out.println();
		System.out.println("g: JComGenerator [<options>] <ProgID>");
		System.out.println("options");
		System.out.println("  -package <packagename>   pbP[Wɂ܂");
		System.out.println("  -d <directory>            Something in Japanese");
		System.out.println();
		System.out.println(": JComGenerator \"Excel.Application\"");
		System.out.println("      Something in Japanese"); //ׂẴIuWFNg̃\[X𐶐܂B");
		System.out.println(": JComGenerator \"Excel.Application.8\" jp.ne.so_net.ga2.no_ji.jcom.excel8");
		System.out.println("    _Application  Something in Japanese"); //IuWFNg̃\[X𐶐܂B");
		System.out.println();
		System.out.println(" Something in Japanese"); //\I ProgID  Interface");
		System.out.println(" Excel.Application _Application");
		System.out.println(" InternetExplorer.Application IWebBrowser");
	}
	public static void main(String[] args) throws Exception {
		// 
		if(args.length==0) { JComGenerator.usage(); return; }
		String packagename = null;
		String outdirs = null;
		String target = null;
		String progID = null;
		for(int i=0; i<args.length; i++) {
			if(args[i].equals("-package")) {
				packagename = args[++i];
			}
			else if(args[i].equals("-d")) {
				outdirs = args[++i];
			}
			else {
				progID = args[i];
			}
		}
		if(progID==null) { JComGenerator.usage(); return; }

		JComGenerator generator = new JComGenerator();
		generator.setPackage(packagename);
		generator.setOutDirs(outdirs);

		ReleaseManager rm = new ReleaseManager();
		try {
			System.out.println(progID+"Something in Japanese...");
			IDispatch xlApp = new IDispatch(rm, progID);

			ITypeInfo typeInfo = xlApp.getTypeInfo();
			ITypeLib typeLib = typeInfo.getTypeLib();
			int infocount = typeLib.getTypeInfoCount();
			if(target == null) {
				// ׂẴR|[lg\B
				for(int i=0; i<infocount; i++) {
					ITypeInfo info = typeLib.getTypeInfo(i);
					System.out.println(info.getDocumentation(-1)[0]);
					generator.generate(info);
				}
				System.out.println(""+infocount+" file(s)");
			}
			else {
				// w肵IuWFNg\B
				for(int i=0; i<infocount; i++) {
					ITypeInfo info = typeLib.getTypeInfo(i);
					if(info.getDocumentation(-1)[0].equals(target)) {
//						System.out.println(info.getDocumentation(-1)[0]);
						generator.generate(info);
						System.out.println("o͂܂B");
						break;	// I
					}
				}
			}
		}
		catch(Exception e) { e.printStackTrace(); }
		finally { rm.release(); }
	}
}
/*
"Excel.Sheet"
*/