#include "atlbase.h"
#include "atlconv.h"
#include <stdio.h>

//------------------------------------------------------------------------------
void print_bstring(OLECHAR* psz)
{
    char bufA[256];
    if(psz==NULL) { printf("(null)"); return; }
    WideCharToMultiByte(CP_ACP, NULL, psz, -1, bufA, 256, NULL, NULL);
	printf("%s", bufA);
}

//------------------------------------------------------------------------------
//	SFAߋŃj[NȒlB
void print_GUID(GUID* guid)
{
	printf("%08X-%04X-%04X-%02X%02X-",
		guid->Data1, guid->Data2, guid->Data3, guid->Data4[0], guid->Data4[1]);
	for(int i=2; i<8; i++) {
		printf("%02X", guid->Data4[i]);
	}
}

//------------------------------------------------------------------------------
//	VARTYPE^(unsinged short)\
void print_VARTYPE(VARTYPE vt)
{
	printf("0x%02X(", vt);
	if(vt == VT_ILLEGAL) printf("VT_ILLEGAL");
	if(vt & VT_BYREF) { printf("VT_BYREF|");	vt &= (~VT_BYREF); }
	if(vt & VT_ARRAY) { printf("VT_ARRAY|");	vt &= (~VT_ARRAY); }
	if(vt & VT_VECTOR) { printf("VT_VECTOR|");	vt &= (~VT_VECTOR); }
	switch(vt) {
	case VT_EMPTY:				printf("VT_EMPTY");			break;
	case VT_NULL:				printf("VT_NULL");			break;
	case VT_I2:					printf("VT_I2");			break;
	case VT_I4:					printf("VT_I4");			break;
	case VT_R4:					printf("VT_R4");			break;
	case VT_R8:					printf("VT_R8");			break;
	case VT_CY:					printf("VT_CY");			break;
	case VT_DATE:				printf("VT_DATE");			break;
	case VT_BSTR:				printf("VT_BSTR");			break;
	case VT_DISPATCH:			printf("VT_DISPATCH");		break;
	case VT_ERROR:				printf("VT_ERROR");			break;
	case VT_BOOL:				printf("VT_BOOL");			break;
	case VT_VARIANT:			printf("VT_VARIANT");		break;
	case VT_UNKNOWN:			printf("VT_UNKNOWN");		break;
	case VT_DECIMAL:			printf("VT_DECIMAL");		break;
	case VT_I1:					printf("VT_I1");			break;
	case VT_UI1:				printf("VT_UI1");			break;
	case VT_UI2:				printf("VT_UI2");			break;
	case VT_UI4:				printf("VT_UI4");			break;
	case VT_I8:					printf("VT_I8");			break;
	case VT_UI8:				printf("VT_UI8");			break;
	case VT_INT:				printf("VT_INT");			break;
	case VT_UINT:				printf("VT_UINT");			break;
	case VT_VOID:				printf("VT_VOID");			break;
	case VT_HRESULT:			printf("VT_HRESULT");		break;
	case VT_PTR:				printf("VT_PTR");			break;
	case VT_SAFEARRAY:			printf("VT_SAFEARRAY");		break;
	case VT_CARRAY:				printf("VT_CARRAY");		break;
	case VT_USERDEFINED:		printf("VT_USERDEFINED");	break;
	case VT_LPSTR:				printf("VT_LPSTR");			break;
	case VT_LPWSTR:				printf("VT_LPWSTR");		break;
	case VT_FILETIME:			printf("VT_FILETIME");		break;
	case VT_BLOB:				printf("VT_BLOB");			break;
	case VT_STREAM:				printf("VT_STREAM");		break;
	case VT_STORAGE:			printf("VT_STORAGE");		break;
	case VT_STREAMED_OBJECT:	printf("VT_STREAMED_OBJECT");	break;
	case VT_STORED_OBJECT:		printf("VT_STORED_OBJECT");	break;
	case VT_BLOB_OBJECT:		printf("VT_BLOB_OBJECT");	break;
	case VT_CF:					printf("VT_CF");			break;
	case VT_CLSID:				printf("VT_CLSID");			break;
	default:					printf("VT_???");
    };
    printf(")");
}
void print2_VARTYPE(VARTYPE vt)
{
	switch(vt) {
	case VT_EMPTY:				printf("EMPTY");			break;
	case VT_NULL:				printf("NULL");				break;
	case VT_I2:					printf("I2");				break;
	case VT_I4:					printf("I4");				break;
	case VT_R4:					printf("R4");				break;
	case VT_R8:					printf("R8");				break;
	case VT_CY:					printf("CY");				break;
	case VT_DATE:				printf("DATE");				break;
	case VT_BSTR:				printf("BSTR");				break;
	case VT_DISPATCH:			printf("DISPATCH");			break;
	case VT_ERROR:				printf("ERROR");			break;
	case VT_BOOL:				printf("BOOL");				break;
	case VT_VARIANT:			printf("VARIANT");			break;
	case VT_UNKNOWN:			printf("UNKNOWN");			break;
	case VT_DECIMAL:			printf("DECIMAL");			break;
	case VT_I1:					printf("I1");				break;
	case VT_UI1:				printf("UI1");				break;
	case VT_UI2:				printf("UI2");				break;
	case VT_UI4:				printf("UI4");				break;
	case VT_I8:					printf("I8");				break;
	case VT_UI8:				printf("UI8");				break;
	case VT_INT:				printf("INT");				break;
	case VT_UINT:				printf("UINT");				break;
	case VT_VOID:				printf("VOID");				break;
	case VT_HRESULT:			printf("HRESULT");			break;
	case VT_PTR:				printf("PTR");				break;
	case VT_SAFEARRAY:			printf("SAFEARRAY");		break;
	case VT_CARRAY:				printf("CARRAY");			break;
	case VT_USERDEFINED:		printf("USERDEFINED");		break;
	case VT_LPSTR:				printf("LPSTR");			break;
	case VT_LPWSTR:				printf("LPWSTR");			break;
	case VT_FILETIME:			printf("FILETIME");			break;
	case VT_BLOB:				printf("BLOB");				break;
	case VT_STREAM:				printf("STREAM");			break;
	case VT_STORAGE:			printf("STORAGE");			break;
	case VT_STREAMED_OBJECT:	printf("STREAMED_OBJECT");	break;
	case VT_STORED_OBJECT:		printf("STORED_OBJECT");	break;
	case VT_BLOB_OBJECT:		printf("BLOB_OBJECT");		break;
	case VT_CF:					printf("CF");				break;
	case VT_CLSID:				printf("CLSID");			break;
	default:					printf("???");
    };
}

//------------------------------------------------------------------------------
//	VARTYPE^(unsinged short)\
void print_VARIANT(VARIANT* v)
{
	printf("["); print_VARTYPE(v->vt);	printf("]=");
	switch(v->vt) {
	case VT_EMPTY:											break;
	case VT_NULL:				printf("(null)");			break;
	case VT_I2:					printf("%d",v->iVal);		break;
	case VT_I4:					printf("%d",v->lVal);		break;
	case VT_R4:					printf("VT_R4");			break;
	case VT_R8:					printf("VT_R8");			break;
	case VT_CY:					printf("VT_CY");			break;
	case VT_DATE:				printf("VT_DATE");			break;
	case VT_BSTR:				printf("VT_BSTR");			break;
	case VT_DISPATCH:			printf("VT_DISPATCH");		break;
	case VT_ERROR:				printf("VT_ERROR");			break;
	case VT_BOOL:				printf("%d",v->boolVal);	break;
	case VT_VARIANT:			printf("VT_VARIANT");		break;
	case VT_UNKNOWN:			printf("VT_UNKNOWN");		break;
	case VT_DECIMAL:			printf("VT_DECIMAL");		break;
	case VT_I1:					printf("VT_I1");			break;
	case VT_UI1:				printf("VT_UI1");			break;
	case VT_UI2:				printf("VT_UI2");			break;
	case VT_UI4:				printf("VT_UI4");			break;
	case VT_I8:					printf("VT_I8");			break;
	case VT_UI8:				printf("VT_UI8");			break;
	case VT_INT:				printf("VT_INT");			break;
	case VT_UINT:				printf("VT_UINT");			break;
	case VT_VOID:				printf("VT_VOID");			break;
	case VT_HRESULT:			printf("VT_HRESULT");		break;
	case VT_PTR:				printf("VT_PTR");			break;
	case VT_SAFEARRAY:			printf("VT_SAFEARRAY");		break;
	case VT_CARRAY:				printf("VT_CARRAY");		break;
	case VT_USERDEFINED:		printf("VT_USERDEFINED");	break;
	case VT_LPSTR:				printf("VT_LPSTR");			break;
	case VT_LPWSTR:				printf("VT_LPWSTR");		break;
	case VT_FILETIME:			printf("VT_FILETIME");		break;
	case VT_BLOB:				printf("VT_BLOB");			break;
	case VT_STREAM:				printf("VT_STREAM");		break;
	case VT_STORAGE:			printf("VT_STORAGE");		break;
	case VT_STREAMED_OBJECT:	printf("VT_STREAMED_OBJECT");	break;
	case VT_STORED_OBJECT:		printf("VT_STORED_OBJECT");	break;
	case VT_BLOB_OBJECT:		printf("VT_BLOB_OBJECT");	break;
	case VT_CF:					printf("VT_CF");			break;
	case VT_CLSID:				printf("VT_CLSID");			break;
	default:					printf("VT_???");
    };
}
#if 0

VARIANT and VARIANTARG
Use VARIANTARG to describe arguments passed within DISPPARAMS, and VARIANT to specify variant data that cannot be passed by reference. The VARIANT type cannot have the VT_BYREF bit set. VARIANTs can be passed by value, even if VARIANTARGs cannot. 

typedef struct FARSTRUCT tagVARIANT VARIANT;
typedef struct FARSTRUCT tagVARIANT VARIANTARG;

typedef struct tagVARIANT  {
	VARTYPE vt;
	unsigned short wReserved1;
	unsigned short wReserved2;
	unsigned short wReserved3;
	union {
		unsigned char		bVal;				// VT_UI1.
		short				iVal;				// VT_I2	.
		long				lVal;				// VT_I4	.
		float				fltVal;				// VT_R4	.
		double				dblVal;				// VT_R8	.
		VARIANT_BOOL		bool;				// VT_BOOL.
		RETURN VALUE		return value;		// VT_ERROR.
		CY					cyVal;				// VT_CY	.
		DATE				date;				// VT_DATE.
		BSTR				bstrVal;			// VT_BSTR.
		IUnknown			FAR* punkVal;		// VT_UNKNOWN.
		IDispatch			FAR* pdispVal;		// VT_DISPATCH.
		SAFEARRAY			FAR* parray;		// VT_ARRAY|*.
		unsigned char		FAR *pbVal;			// VT_BYREF|VT_UI1.
		short				FAR* piVal;			// VT_BYREF|VT_I2.
		long				FAR* plVal;			// VT_BYREF|VT_I4.
		float				FAR* pfltVal;		// VT_BYREF|VT_R4.
		double				FAR* pdblVal;		// VT_BYREF|VT_R8.
		VARIANT_BOOL		FAR* pbool;			// VT_BYREF|VT_BOOL.
		RETURN VALUE		FAR* preturn value;	// VT_BYREF|VT_ERROR.
		CY					FAR* pcyVal;		// VT_BYREF|VT_CY.
		DATE				FAR* pdate;			// VT_BYREF|VT_DATE.
		BSTR				FAR* pbstrVal;		// VT_BYREF|VT_BSTR.
		IUnknown FAR*		FAR* ppunkVal;		// VT_BYREF|VT_UNKNOWN.
		IDispatch FAR*		FAR* ppdispVal;		// VT_BYREF|VT_DISPATCH.
		SAFEARRAY FAR*		FAR* parray;		// VT_ARRAY|*.
		VARIANT				FAR* pvarVal;		// VT_BYREF|VT_VARIANT.
		void				FAR* byref;			// Generic ByRef.
	};
};
 
#endif

