package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Range
* DO NOT EDIT THIS CODE 
* EDIT the subclass Range
* @author S Lewis
*/
public class _Range extends WDispatch
{
    public static final String clsid = "{0002095E-0000-0000-C000-000000000046}";
    protected static Map gParamHashInsertFile;
    protected static Map gParamHashConvertToTableOld;
    protected static Map gParamHashInsertDateTimeOld;
    protected static Map gParamHashInsertSymbol;
    protected static Map gParamHashInsertCaption;
    protected static Map gParamHashSortOld;
    protected static Map gParamHashGoTo;
    protected static Map gParamHashPasteSpecial;
    protected static Map gParamHashCreatePublisher;
    protected static Map gParamHashInsertDatabase;
    protected static Map gParamHashCheckSpelling;
    protected static Map gParamHashGetSpellingSuggestions;
    protected static Map gParamHashConvertHangulAndHanja;
    protected static Map gParamHashPhoneticGuide;
    protected static Map gParamHashInsertDateTime;
    protected static Map gParamHashSort;
    protected static Map gParamHashConvertToTable;
    protected static Map gParamHashTCSCConverter;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashInsertFile = new HashMap();
        gParamHashInsertFile.put("FileName",new Integer(0));
        gParamHashInsertFile.put("Range",new Integer(1));
        gParamHashInsertFile.put("ConfirmConversions",new Integer(2));
        gParamHashInsertFile.put("Link",new Integer(3));
        gParamHashInsertFile.put("Attachment",new Integer(4));

        gParamHashConvertToTableOld = new HashMap();
        gParamHashConvertToTableOld.put("Separator",new Integer(0));
        gParamHashConvertToTableOld.put("NumRows",new Integer(1));
        gParamHashConvertToTableOld.put("NumColumns",new Integer(2));
        gParamHashConvertToTableOld.put("InitialColumnWidth",new Integer(3));
        gParamHashConvertToTableOld.put("Format",new Integer(4));
        gParamHashConvertToTableOld.put("ApplyBorders",new Integer(5));
        gParamHashConvertToTableOld.put("ApplyShading",new Integer(6));
        gParamHashConvertToTableOld.put("ApplyFont",new Integer(7));
        gParamHashConvertToTableOld.put("ApplyColor",new Integer(8));
        gParamHashConvertToTableOld.put("ApplyHeadingRows",new Integer(9));
        gParamHashConvertToTableOld.put("ApplyLastRow",new Integer(10));
        gParamHashConvertToTableOld.put("ApplyFirstColumn",new Integer(11));
        gParamHashConvertToTableOld.put("ApplyLastColumn",new Integer(12));
        gParamHashConvertToTableOld.put("AutoFit",new Integer(13));

        gParamHashInsertDateTimeOld = new HashMap();
        gParamHashInsertDateTimeOld.put("DateTimeFormat",new Integer(0));
        gParamHashInsertDateTimeOld.put("InsertAsField",new Integer(1));
        gParamHashInsertDateTimeOld.put("InsertAsFullWidth",new Integer(2));

        gParamHashInsertSymbol = new HashMap();
        gParamHashInsertSymbol.put("CharacterNumber",new Integer(0));
        gParamHashInsertSymbol.put("Font",new Integer(1));
        gParamHashInsertSymbol.put("Unicode",new Integer(2));
        gParamHashInsertSymbol.put("Bias",new Integer(3));

        gParamHashInsertCaption = new HashMap();
        gParamHashInsertCaption.put("Label",new Integer(0));
        gParamHashInsertCaption.put("Title",new Integer(1));
        gParamHashInsertCaption.put("TitleAutoText",new Integer(2));
        gParamHashInsertCaption.put("Position",new Integer(3));

        gParamHashSortOld = new HashMap();
        gParamHashSortOld.put("ExcludeHeader",new Integer(0));
        gParamHashSortOld.put("FieldNumber",new Integer(1));
        gParamHashSortOld.put("SortFieldType",new Integer(2));
        gParamHashSortOld.put("SortOrder",new Integer(3));
        gParamHashSortOld.put("FieldNumber2",new Integer(4));
        gParamHashSortOld.put("SortFieldType2",new Integer(5));
        gParamHashSortOld.put("SortOrder2",new Integer(6));
        gParamHashSortOld.put("FieldNumber3",new Integer(7));
        gParamHashSortOld.put("SortFieldType3",new Integer(8));
        gParamHashSortOld.put("SortOrder3",new Integer(9));
        gParamHashSortOld.put("SortColumn",new Integer(10));
        gParamHashSortOld.put("Separator",new Integer(11));
        gParamHashSortOld.put("CaseSensitive",new Integer(12));
        gParamHashSortOld.put("LanguageID",new Integer(13));

        gParamHashGoTo = new HashMap();
        gParamHashGoTo.put("What",new Integer(0));
        gParamHashGoTo.put("Which",new Integer(1));
        gParamHashGoTo.put("Count",new Integer(2));
        gParamHashGoTo.put("Name",new Integer(3));

        gParamHashPasteSpecial = new HashMap();
        gParamHashPasteSpecial.put("IconIndex",new Integer(0));
        gParamHashPasteSpecial.put("Link",new Integer(1));
        gParamHashPasteSpecial.put("Placement",new Integer(2));
        gParamHashPasteSpecial.put("DisplayAsIcon",new Integer(3));
        gParamHashPasteSpecial.put("DataType",new Integer(4));
        gParamHashPasteSpecial.put("IconFileName",new Integer(5));
        gParamHashPasteSpecial.put("IconLabel",new Integer(6));

        gParamHashCreatePublisher = new HashMap();
        gParamHashCreatePublisher.put("Edition",new Integer(0));
        gParamHashCreatePublisher.put("ContainsPICT",new Integer(1));
        gParamHashCreatePublisher.put("ContainsRTF",new Integer(2));
        gParamHashCreatePublisher.put("ContainsText",new Integer(3));

        gParamHashInsertDatabase = new HashMap();
        gParamHashInsertDatabase.put("Format",new Integer(0));
        gParamHashInsertDatabase.put("Style",new Integer(1));
        gParamHashInsertDatabase.put("LinkToSource",new Integer(2));
        gParamHashInsertDatabase.put("Connection",new Integer(3));
        gParamHashInsertDatabase.put("SQLStatement",new Integer(4));
        gParamHashInsertDatabase.put("SQLStatement1",new Integer(5));
        gParamHashInsertDatabase.put("PasswordDocument",new Integer(6));
        gParamHashInsertDatabase.put("PasswordTemplate",new Integer(7));
        gParamHashInsertDatabase.put("WritePasswordDocument",new Integer(8));
        gParamHashInsertDatabase.put("WritePasswordTemplate",new Integer(9));
        gParamHashInsertDatabase.put("DataSource",new Integer(10));
        gParamHashInsertDatabase.put("From",new Integer(11));
        gParamHashInsertDatabase.put("To",new Integer(12));
        gParamHashInsertDatabase.put("IncludeFields",new Integer(13));

        gParamHashCheckSpelling = new HashMap();
        gParamHashCheckSpelling.put("CustomDictionary",new Integer(0));
        gParamHashCheckSpelling.put("IgnoreUppercase",new Integer(1));
        gParamHashCheckSpelling.put("AlwaysSuggest",new Integer(2));
        gParamHashCheckSpelling.put("CustomDictionary2",new Integer(3));
        gParamHashCheckSpelling.put("CustomDictionary3",new Integer(4));
        gParamHashCheckSpelling.put("CustomDictionary4",new Integer(5));
        gParamHashCheckSpelling.put("CustomDictionary5",new Integer(6));
        gParamHashCheckSpelling.put("CustomDictionary6",new Integer(7));
        gParamHashCheckSpelling.put("CustomDictionary7",new Integer(8));
        gParamHashCheckSpelling.put("CustomDictionary8",new Integer(9));
        gParamHashCheckSpelling.put("CustomDictionary9",new Integer(10));
        gParamHashCheckSpelling.put("CustomDictionary10",new Integer(11));

        gParamHashGetSpellingSuggestions = new HashMap();
        gParamHashGetSpellingSuggestions.put("CustomDictionary",new Integer(0));
        gParamHashGetSpellingSuggestions.put("IgnoreUppercase",new Integer(1));
        gParamHashGetSpellingSuggestions.put("MainDictionary",new Integer(2));
        gParamHashGetSpellingSuggestions.put("SuggestionMode",new Integer(3));
        gParamHashGetSpellingSuggestions.put("CustomDictionary2",new Integer(4));
        gParamHashGetSpellingSuggestions.put("CustomDictionary3",new Integer(5));
        gParamHashGetSpellingSuggestions.put("CustomDictionary4",new Integer(6));
        gParamHashGetSpellingSuggestions.put("CustomDictionary5",new Integer(7));
        gParamHashGetSpellingSuggestions.put("CustomDictionary6",new Integer(8));
        gParamHashGetSpellingSuggestions.put("CustomDictionary7",new Integer(9));
        gParamHashGetSpellingSuggestions.put("CustomDictionary8",new Integer(10));
        gParamHashGetSpellingSuggestions.put("CustomDictionary9",new Integer(11));
        gParamHashGetSpellingSuggestions.put("CustomDictionary10",new Integer(12));

        gParamHashConvertHangulAndHanja = new HashMap();
        gParamHashConvertHangulAndHanja.put("ConversionsMode",new Integer(0));
        gParamHashConvertHangulAndHanja.put("FastConversion",new Integer(1));
        gParamHashConvertHangulAndHanja.put("CheckHangulEnding",new Integer(2));
        gParamHashConvertHangulAndHanja.put("EnableRecentOrdering",new Integer(3));
        gParamHashConvertHangulAndHanja.put("CustomDictionary",new Integer(4));

        gParamHashPhoneticGuide = new HashMap();
        gParamHashPhoneticGuide.put("Text",new Integer(0));
        gParamHashPhoneticGuide.put("Alignment",new Integer(1));
        gParamHashPhoneticGuide.put("Raise",new Integer(2));
        gParamHashPhoneticGuide.put("FontSize",new Integer(3));
        gParamHashPhoneticGuide.put("FontName",new Integer(4));

        gParamHashInsertDateTime = new HashMap();
        gParamHashInsertDateTime.put("DateTimeFormat",new Integer(0));
        gParamHashInsertDateTime.put("InsertAsField",new Integer(1));
        gParamHashInsertDateTime.put("InsertAsFullWidth",new Integer(2));
        gParamHashInsertDateTime.put("DateLanguage",new Integer(3));
        gParamHashInsertDateTime.put("CalendarType",new Integer(4));

        gParamHashSort = new HashMap();
        gParamHashSort.put("ExcludeHeader",new Integer(0));
        gParamHashSort.put("FieldNumber",new Integer(1));
        gParamHashSort.put("SortFieldType",new Integer(2));
        gParamHashSort.put("SortOrder",new Integer(3));
        gParamHashSort.put("FieldNumber2",new Integer(4));
        gParamHashSort.put("SortFieldType2",new Integer(5));
        gParamHashSort.put("SortOrder2",new Integer(6));
        gParamHashSort.put("FieldNumber3",new Integer(7));
        gParamHashSort.put("SortFieldType3",new Integer(8));
        gParamHashSort.put("SortOrder3",new Integer(9));
        gParamHashSort.put("SortColumn",new Integer(10));
        gParamHashSort.put("Separator",new Integer(11));
        gParamHashSort.put("CaseSensitive",new Integer(12));
        gParamHashSort.put("BidiSort",new Integer(13));
        gParamHashSort.put("IgnoreThe",new Integer(14));
        gParamHashSort.put("IgnoreKashida",new Integer(15));
        gParamHashSort.put("IgnoreDiacritics",new Integer(16));
        gParamHashSort.put("IgnoreHe",new Integer(17));
        gParamHashSort.put("LanguageID",new Integer(18));

        gParamHashConvertToTable = new HashMap();
        gParamHashConvertToTable.put("Separator",new Integer(0));
        gParamHashConvertToTable.put("NumRows",new Integer(1));
        gParamHashConvertToTable.put("NumColumns",new Integer(2));
        gParamHashConvertToTable.put("InitialColumnWidth",new Integer(3));
        gParamHashConvertToTable.put("Format",new Integer(4));
        gParamHashConvertToTable.put("ApplyBorders",new Integer(5));
        gParamHashConvertToTable.put("ApplyShading",new Integer(6));
        gParamHashConvertToTable.put("ApplyFont",new Integer(7));
        gParamHashConvertToTable.put("ApplyColor",new Integer(8));
        gParamHashConvertToTable.put("ApplyHeadingRows",new Integer(9));
        gParamHashConvertToTable.put("ApplyLastRow",new Integer(10));
        gParamHashConvertToTable.put("ApplyFirstColumn",new Integer(11));
        gParamHashConvertToTable.put("ApplyLastColumn",new Integer(12));
        gParamHashConvertToTable.put("AutoFit",new Integer(13));
        gParamHashConvertToTable.put("AutoFitBehavior",new Integer(14));
        gParamHashConvertToTable.put("DefaultTableBehavior",new Integer(15));

        gParamHashTCSCConverter = new HashMap();
        gParamHashTCSCConverter.put("WdTCSCConverterDirection",new Integer(0));
        gParamHashTCSCConverter.put("CommonTerms",new Integer(1));
        gParamHashTCSCConverter.put("UseVariants",new Integer(2));

    }
    /**
    * default constructor
    */
    public _Range()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Range(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Range(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return String
    */
    public String getText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setText(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,0,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getFormattedText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Range
    * @param arg1Range
    */
    public void setFormattedText(Range arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,2,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getStart()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setStart(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getEnd()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setEnd(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Font
    */
    public Font getFont()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Font ret = new Font(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Font
    * @param arg1Font
    */
    public void setFont(Font arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getDuplicate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return WdStoryTypeEnum
    */
    public WdStoryTypeEnum getStoryType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdStoryTypeEnum ret = WdStoryTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Tables
    */
    public Tables getTables()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,50,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Tables ret = new Tables(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Words
    */
    public Words getWords()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,51,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Words ret = new Words(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Sentences
    */
    public Sentences getSentences()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,52,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Sentences ret = new Sentences(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Characters
    */
    public Characters getCharacters()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,53,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Characters ret = new Characters(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Footnotes
    */
    public Footnotes getFootnotes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,54,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Footnotes ret = new Footnotes(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Endnotes
    */
    public Endnotes getEndnotes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,55,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Endnotes ret = new Endnotes(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Comments
    */
    public Comments getComments()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,56,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Comments ret = new Comments(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Cells
    */
    public Cells getCells()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,57,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Cells ret = new Cells(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Sections
    */
    public Sections getSections()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,58,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Sections ret = new Sections(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Paragraphs
    */
    public Paragraphs getParagraphs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,59,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Paragraphs ret = new Paragraphs(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Borders
    */
    public Borders getBorders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Borders ret = new Borders(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Borders
    * @param arg1Borders
    */
    public void setBorders(Borders arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Shading
    */
    public Shading getShading()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,61,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shading ret = new Shading(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return TextRetrievalMode
    */
    public TextRetrievalMode getTextRetrievalMode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,62,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        TextRetrievalMode ret = new TextRetrievalMode(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1TextRetrievalMode
    * @param arg1TextRetrievalMode
    */
    public void setTextRetrievalMode(TextRetrievalMode arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,62,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Fields
    */
    public Fields getFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,64,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Fields ret = new Fields(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return FormFields
    */
    public FormFields getFormFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,65,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        FormFields ret = new FormFields(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Frames
    */
    public Frames getFrames()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,66,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Frames ret = new Frames(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return ParagraphFormat
    */
    public ParagraphFormat getParagraphFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1102,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ParagraphFormat ret = new ParagraphFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1ParagraphFormat
    * @param arg1ParagraphFormat
    */
    public void setParagraphFormat(ParagraphFormat arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1102,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return ListFormat
    */
    public ListFormat getListFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,68,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ListFormat ret = new ListFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Bookmarks
    */
    public Bookmarks getBookmarks()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,75,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Bookmarks ret = new Bookmarks(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return int
    */
    public int getBold()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,130,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setBold(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,130,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getItalic()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,131,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setItalic(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,131,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdUnderlineEnum
    */
    public WdUnderlineEnum getUnderline()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,139,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdUnderlineEnum ret = WdUnderlineEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdUnderlineEnum
    * @param arg1WdUnderlineEnum
    */
    public void setUnderline(WdUnderlineEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,139,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdEmphasisMarkEnum
    */
    public WdEmphasisMarkEnum getEmphasisMark()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,140,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdEmphasisMarkEnum ret = WdEmphasisMarkEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdEmphasisMarkEnum
    * @param arg1WdEmphasisMarkEnum
    */
    public void setEmphasisMark(WdEmphasisMarkEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,140,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisableCharacterSpaceGrid()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,141,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisableCharacterSpaceGrid(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,141,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Revisions
    */
    public Revisions getRevisions()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,150,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Revisions ret = new Revisions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_getStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,151,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object[]
    * @param arg1Object[]
    */
    public void setStyle(Object[] arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,151,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getStoryLength()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,152,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return WdLanguageIDEnum
    */
    public WdLanguageIDEnum getLanguageID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,153,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLanguageIDEnum ret = WdLanguageIDEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLanguageIDEnum
    * @param arg1WdLanguageIDEnum
    */
    public void setLanguageID(WdLanguageIDEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,153,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return SynonymInfo
    */
    public SynonymInfo getSynonymInfo()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,155,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        SynonymInfo ret = new SynonymInfo(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Hyperlinks
    */
    public Hyperlinks getHyperlinks()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,156,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Hyperlinks ret = new Hyperlinks(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return ListParagraphs
    */
    public ListParagraphs getListParagraphs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,157,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ListParagraphs ret = new ListParagraphs(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Subdocuments
    */
    public Subdocuments getSubdocuments()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,159,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Subdocuments ret = new Subdocuments(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getGrammarChecked()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,260,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setGrammarChecked(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,260,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getSpellingChecked()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,261,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setSpellingChecked(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,261,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdColorIndexEnum
    */
    public WdColorIndexEnum getHighlightColorIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,301,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdColorIndexEnum ret = WdColorIndexEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdColorIndexEnum
    * @param arg1WdColorIndexEnum
    */
    public void setHighlightColorIndex(WdColorIndexEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,301,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Columns
    */
    public Columns getColumns()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,302,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Columns ret = new Columns(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Rows
    */
    public Rows getRows()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,303,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Rows ret = new Rows(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCanEdit()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,304,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getCanPaste()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,305,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getIsEndOfRowMark()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,307,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return int
    */
    public int getBookmarkID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,308,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getPreviousBookmarkID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,309,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Find
    */
    public Find getFind()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,262,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Find ret = new Find(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return PageSetup
    */
    public PageSetup getPageSetup()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1101,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        PageSetup ret = new PageSetup(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1PageSetup
    * @param arg1PageSetup
    */
    public void setPageSetup(PageSetup arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1101,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return ShapeRange
    */
    public ShapeRange getShapeRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,311,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ShapeRange ret = new ShapeRange(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return WdCharacterCaseEnum
    */
    public WdCharacterCaseEnum getCase()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,312,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdCharacterCaseEnum ret = WdCharacterCaseEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdCharacterCaseEnum
    * @param arg1WdCharacterCaseEnum
    */
    public void setCase(WdCharacterCaseEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,312,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param TypeWdInformationEnum
    * @param TypeWdInformationEnum
    * @return Object
    */
    public Object ambig_getInformation(WdInformationEnum Type)
    {
        Variant[] args = {new Variant(Type.getValue())};
        Variant retVar = invoke_method(args,313,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return ReadabilityStatistics
    */
    public ReadabilityStatistics getReadabilityStatistics()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,314,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ReadabilityStatistics ret = new ReadabilityStatistics(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return ProofreadingErrors
    */
    public ProofreadingErrors getGrammaticalErrors()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,315,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ProofreadingErrors ret = new ProofreadingErrors(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return ProofreadingErrors
    */
    public ProofreadingErrors getSpellingErrors()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,316,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ProofreadingErrors ret = new ProofreadingErrors(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return WdTextOrientationEnum
    */
    public WdTextOrientationEnum getOrientation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,317,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdTextOrientationEnum ret = WdTextOrientationEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdTextOrientationEnum
    * @param arg1WdTextOrientationEnum
    */
    public void setOrientation(WdTextOrientationEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,317,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return InlineShapes
    */
    public InlineShapes getInlineShapes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,319,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        InlineShapes ret = new InlineShapes(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getNextStoryRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,320,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return WdLanguageIDEnum
    */
    public WdLanguageIDEnum getLanguageIDFarEast()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,321,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLanguageIDEnum ret = WdLanguageIDEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLanguageIDEnum
    * @param arg1WdLanguageIDEnum
    */
    public void setLanguageIDFarEast(WdLanguageIDEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,321,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdLanguageIDEnum
    */
    public WdLanguageIDEnum getLanguageIDOther()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,322,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLanguageIDEnum ret = WdLanguageIDEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLanguageIDEnum
    * @param arg1WdLanguageIDEnum
    */
    public void setLanguageIDOther(WdLanguageIDEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,322,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void Select()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,65535,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param Startint
    * @param Endint
    * @param Startint
    * @param Endint
    */
    public void SetRange(int Start,int End)
    {
        Variant[] args = {new Variant(Start),new Variant(End)};
        invoke_method_void(args,100,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DirectionObject[]
    * @param DirectionObject[]
    */
    public void Collapse(Object[] Direction)
    {
        Variant[] args = {new Variant(Direction)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Collapse()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param TextString
    */
    public void InsertBefore(String Text)
    {
        Variant[] args = {new Variant(Text)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param TextString
    */
    public void InsertAfter(String Text)
    {
        Variant[] args = {new Variant(Text)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return Range
    */
    public Range Next(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return Range
    */
    public Range Next(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range Next()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return Range
    */
    public Range Previous(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return Range
    */
    public Range Previous(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range Previous()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int StartOf(Object[] Unit,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Extend)};
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int StartOf(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int StartOf()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param ExtendObject[]
    * @param UnitObject[]
    * @param ExtendObject[]
    * @return int
    */
    public int EndOf(Object[] Unit,Object[] Extend)
    {
        Variant[] args = {new Variant(Unit),new Variant(Extend)};
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int EndOf(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int EndOf()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int Move(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int Move(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int Move()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveStart(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int MoveStart(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int MoveStart()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveEnd(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,111,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int MoveEnd(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,111,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int MoveEnd()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,111,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveWhile(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,112,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveWhile(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,112,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveStartWhile(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,113,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveStartWhile(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,113,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveEndWhile(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,114,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveEndWhile(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,114,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveUntil(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,115,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveUntil(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,115,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveStartUntil(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,116,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveStartUntil(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,116,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CountObject[]
    * @param CsetObject[]
    * @param CountObject[]
    * @return int
    */
    public int MoveEndUntil(Object[] Cset,Object[] Count)
    {
        Variant[] args = {new Variant(Cset),new Variant(Count)};
        Variant retVar = invoke_method(args,117,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param CsetObject[]
    * @param CsetObject[]
    * @return int
    */
    public int MoveEndUntil(Object[] Cset)
    {
        Variant[] args = {new Variant(Cset)};
        Variant retVar = invoke_method(args,117,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    */
    public void Cut()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,119,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Copy()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,120,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Paste()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,121,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TypeObject[]
    * @param TypeObject[]
    */
    public void InsertBreak(Object[] Type)
    {
        Variant[] args = {new Variant(Type)};
        invoke_method_void(args,122,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertBreak()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,122,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param LinkObject[]
    * @param AttachmentObject[]
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param LinkObject[]
    * @param AttachmentObject[]
    */
    public void InsertFile(String FileName,Object[] Range,Object[] ConfirmConversions,Object[] Link,Object[] Attachment)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range),new Variant(ConfirmConversions),new Variant(Link),new Variant(Attachment)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertFile(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertFile.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param LinkObject[]
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param LinkObject[]
    */
    public void InsertFile(String FileName,Object[] Range,Object[] ConfirmConversions,Object[] Link)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range),new Variant(ConfirmConversions),new Variant(Link)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    * @param FileNameString
    * @param RangeObject[]
    * @param ConfirmConversionsObject[]
    */
    public void InsertFile(String FileName,Object[] Range,Object[] ConfirmConversions)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range),new Variant(ConfirmConversions)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param FileNameString
    * @param RangeObject[]
    */
    public void InsertFile(String FileName,Object[] Range)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    */
    public void InsertFile(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return boolean
    */
    public boolean InStory(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,125,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return boolean
    */
    public boolean InRange(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,126,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param CountObject[]
    * @param UnitObject[]
    * @param CountObject[]
    * @return int
    */
    public int Delete(Object[] Unit,Object[] Count)
    {
        Variant[] args = {new Variant(Unit),new Variant(Count)};
        Variant retVar = invoke_method(args,127,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int Delete(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,127,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,127,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    */
    public void WholeStory()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,128,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param UnitObject[]
    * @param UnitObject[]
    * @return int
    */
    public int Expand(Object[] Unit)
    {
        Variant[] args = {new Variant(Unit)};
        Variant retVar = invoke_method(args,129,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int Expand()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,129,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    */
    public void InsertParagraph()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,160,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertParagraphAfter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,161,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn,Object[] AutoFit)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn),new Variant(AutoFit)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Table
    */
    public Table ConvertToTableOld(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashConvertToTableOld.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows,Object[] NumColumns)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator,Object[] NumRows)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param SeparatorObject[]
    * @return Table
    */
    public Table ConvertToTableOld(Object[] Separator)
    {
        Variant[] args = {new Variant(Separator)};
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Table
    */
    public Table ConvertToTableOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,162,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    */
    public void InsertDateTimeOld(Object[] DateTimeFormat,Object[] InsertAsField,Object[] InsertAsFullWidth)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField),new Variant(InsertAsFullWidth)};
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertDateTimeOld(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertDateTimeOld.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    */
    public void InsertDateTimeOld(Object[] DateTimeFormat,Object[] InsertAsField)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField)};
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param DateTimeFormatObject[]
    */
    public void InsertDateTimeOld(Object[] DateTimeFormat)
    {
        Variant[] args = {new Variant(DateTimeFormat)};
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertDateTimeOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,163,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterNumberint
    * @param FontObject[]
    * @param UnicodeObject[]
    * @param BiasObject[]
    * @param CharacterNumberint
    * @param FontObject[]
    * @param UnicodeObject[]
    * @param BiasObject[]
    */
    public void InsertSymbol(int CharacterNumber,Object[] Font,Object[] Unicode,Object[] Bias)
    {
        Variant[] args = {new Variant(CharacterNumber),new Variant(Font),new Variant(Unicode),new Variant(Bias)};
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertSymbol(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertSymbol.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterNumberint
    * @param FontObject[]
    * @param UnicodeObject[]
    * @param CharacterNumberint
    * @param FontObject[]
    * @param UnicodeObject[]
    */
    public void InsertSymbol(int CharacterNumber,Object[] Font,Object[] Unicode)
    {
        Variant[] args = {new Variant(CharacterNumber),new Variant(Font),new Variant(Unicode)};
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterNumberint
    * @param FontObject[]
    * @param CharacterNumberint
    * @param FontObject[]
    */
    public void InsertSymbol(int CharacterNumber,Object[] Font)
    {
        Variant[] args = {new Variant(CharacterNumber),new Variant(Font)};
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CharacterNumberint
    * @param CharacterNumberint
    */
    public void InsertSymbol(int CharacterNumber)
    {
        Variant[] args = {new Variant(CharacterNumber)};
        invoke_method_void(args,164,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param InsertAsHyperlinkObject[]
    * @param IncludePositionObject[]
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param InsertAsHyperlinkObject[]
    * @param IncludePositionObject[]
    */
    public void InsertCrossReference(Object[] ReferenceType,WdReferenceKindEnum ReferenceKind,Object[] ReferenceItem,Object[] InsertAsHyperlink,Object[] IncludePosition)
    {
        Variant[] args = {new Variant(ReferenceType),new Variant(ReferenceKind.getValue()),new Variant(ReferenceItem),new Variant(InsertAsHyperlink),new Variant(IncludePosition)};
        invoke_method_void(args,165,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param InsertAsHyperlinkObject[]
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param InsertAsHyperlinkObject[]
    */
    public void InsertCrossReference(Object[] ReferenceType,WdReferenceKindEnum ReferenceKind,Object[] ReferenceItem,Object[] InsertAsHyperlink)
    {
        Variant[] args = {new Variant(ReferenceType),new Variant(ReferenceKind.getValue()),new Variant(ReferenceItem),new Variant(InsertAsHyperlink)};
        invoke_method_void(args,165,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    * @param ReferenceTypeObject[]
    * @param ReferenceKindWdReferenceKindEnum
    * @param ReferenceItemObject[]
    */
    public void InsertCrossReference(Object[] ReferenceType,WdReferenceKindEnum ReferenceKind,Object[] ReferenceItem)
    {
        Variant[] args = {new Variant(ReferenceType),new Variant(ReferenceKind.getValue()),new Variant(ReferenceItem)};
        invoke_method_void(args,165,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LabelObject[]
    * @param TitleObject[]
    * @param TitleAutoTextObject[]
    * @param PositionObject[]
    * @param LabelObject[]
    * @param TitleObject[]
    * @param TitleAutoTextObject[]
    * @param PositionObject[]
    */
    public void InsertCaption(Object[] Label,Object[] Title,Object[] TitleAutoText,Object[] Position)
    {
        Variant[] args = {new Variant(Label),new Variant(Title),new Variant(TitleAutoText),new Variant(Position)};
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertCaption(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertCaption.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LabelObject[]
    * @param TitleObject[]
    * @param TitleAutoTextObject[]
    * @param LabelObject[]
    * @param TitleObject[]
    * @param TitleAutoTextObject[]
    */
    public void InsertCaption(Object[] Label,Object[] Title,Object[] TitleAutoText)
    {
        Variant[] args = {new Variant(Label),new Variant(Title),new Variant(TitleAutoText)};
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LabelObject[]
    * @param TitleObject[]
    * @param LabelObject[]
    * @param TitleObject[]
    */
    public void InsertCaption(Object[] Label,Object[] Title)
    {
        Variant[] args = {new Variant(Label),new Variant(Title)};
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LabelObject[]
    * @param LabelObject[]
    */
    public void InsertCaption(Object[] Label)
    {
        Variant[] args = {new Variant(Label)};
        invoke_method_void(args,166,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CopyAsPicture()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,167,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param LanguageIDObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param LanguageIDObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] LanguageID)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(LanguageID)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void SortOld(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashSortOld.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] FieldNumber)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param ExcludeHeaderObject[]
    */
    public void SortOld(Object[] ExcludeHeader)
    {
        Variant[] args = {new Variant(ExcludeHeader)};
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SortOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,168,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SortAscending()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,169,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SortDescending()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,170,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return boolean
    */
    public boolean IsEqual(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,171,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return float
    */
    public float Calculate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,172,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param WhatObject[]
    * @param WhichObject[]
    * @param CountObject[]
    * @param NameObject[]
    * @param WhatObject[]
    * @param WhichObject[]
    * @param CountObject[]
    * @param NameObject[]
    * @return Range
    */
    public Range GoTo(Object[] What,Object[] Which,Object[] Count,Object[] Name)
    {
        Variant[] args = {new Variant(What),new Variant(Which),new Variant(Count),new Variant(Name)};
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Range
    */
    public Range GoTo(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashGoTo.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatObject[]
    * @param WhichObject[]
    * @param CountObject[]
    * @param WhatObject[]
    * @param WhichObject[]
    * @param CountObject[]
    * @return Range
    */
    public Range GoTo(Object[] What,Object[] Which,Object[] Count)
    {
        Variant[] args = {new Variant(What),new Variant(Which),new Variant(Count)};
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatObject[]
    * @param WhichObject[]
    * @param WhatObject[]
    * @param WhichObject[]
    * @return Range
    */
    public Range GoTo(Object[] What,Object[] Which)
    {
        Variant[] args = {new Variant(What),new Variant(Which)};
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatObject[]
    * @param WhatObject[]
    * @return Range
    */
    public Range GoTo(Object[] What)
    {
        Variant[] args = {new Variant(What)};
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range GoTo()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,173,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatWdGoToItemEnum
    * @param WhatWdGoToItemEnum
    * @return Range
    */
    public Range GoToNext(WdGoToItemEnum What)
    {
        Variant[] args = {new Variant(What.getValue())};
        Variant retVar = invoke_method(args,174,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WhatWdGoToItemEnum
    * @param WhatWdGoToItemEnum
    * @return Range
    */
    public Range GoToPrevious(WdGoToItemEnum What)
    {
        Variant[] args = {new Variant(What.getValue())};
        Variant retVar = invoke_method(args,175,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconFileNameObject[]
    * @param IconLabelObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconFileNameObject[]
    * @param IconLabelObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement,Object[] DisplayAsIcon,Object[] DataType,Object[] IconFileName,Object[] IconLabel)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement),new Variant(DisplayAsIcon),new Variant(DataType),new Variant(IconFileName),new Variant(IconLabel)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void PasteSpecial(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashPasteSpecial.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconFileNameObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement,Object[] DisplayAsIcon,Object[] DataType,Object[] IconFileName)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement),new Variant(DisplayAsIcon),new Variant(DataType),new Variant(IconFileName)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param DataTypeObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement,Object[] DisplayAsIcon,Object[] DataType)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement),new Variant(DisplayAsIcon),new Variant(DataType)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param DisplayAsIconObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement,Object[] DisplayAsIcon)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement),new Variant(DisplayAsIcon)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param PlacementObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link,Object[] Placement)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link),new Variant(Placement)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param LinkObject[]
    * @param IconIndexObject[]
    * @param LinkObject[]
    */
    public void PasteSpecial(Object[] IconIndex,Object[] Link)
    {
        Variant[] args = {new Variant(IconIndex),new Variant(Link)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IconIndexObject[]
    * @param IconIndexObject[]
    */
    public void PasteSpecial(Object[] IconIndex)
    {
        Variant[] args = {new Variant(IconIndex)};
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PasteSpecial()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,176,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void LookupNameProperties()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,177,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param StatisticWdStatisticEnum
    * @param StatisticWdStatisticEnum
    * @return int
    */
    public int ComputeStatistics(WdStatisticEnum Statistic)
    {
        Variant[] args = {new Variant(Statistic.getValue())};
        Variant retVar = invoke_method(args,178,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param Directionint
    * @param Directionint
    */
    public void Relocate(int Direction)
    {
        Variant[] args = {new Variant(Direction)};
        invoke_method_void(args,179,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CheckSynonyms()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,180,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param EditionString
    * @param FormatObject[]
    * @param EditionString
    * @param FormatObject[]
    */
    public void SubscribeTo(String Edition,Object[] Format)
    {
        Variant[] args = {new Variant(Edition),new Variant(Format)};
        invoke_method_void(args,181,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param EditionString
    * @param EditionString
    */
    public void SubscribeTo(String Edition)
    {
        Variant[] args = {new Variant(Edition)};
        invoke_method_void(args,181,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param EditionObject[]
    * @param ContainsPICTObject[]
    * @param ContainsRTFObject[]
    * @param ContainsTextObject[]
    * @param EditionObject[]
    * @param ContainsPICTObject[]
    * @param ContainsRTFObject[]
    * @param ContainsTextObject[]
    */
    public void CreatePublisher(Object[] Edition,Object[] ContainsPICT,Object[] ContainsRTF,Object[] ContainsText)
    {
        Variant[] args = {new Variant(Edition),new Variant(ContainsPICT),new Variant(ContainsRTF),new Variant(ContainsText)};
        invoke_method_void(args,182,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void CreatePublisher(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashCreatePublisher.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,182,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param EditionObject[]
    * @param ContainsPICTObject[]
    * @param ContainsRTFObject[]
    * @param EditionObject[]
    * @param ContainsPICTObject[]
    * @param ContainsRTFObject[]
    */
    public void CreatePublisher(Object[] Edition,Object[] ContainsPICT,Object[] ContainsRTF)
    {
        Variant[] args = {new Variant(Edition),new Variant(ContainsPICT),new Variant(ContainsRTF)};
        invoke_method_void(args,182,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param EditionObject[]
    * @param ContainsPICTObject[]
    * @param EditionObject[]
    * @param ContainsPICTObject[]
    */
    public void CreatePublisher(Object[] Edition,Object[] ContainsPICT)
    {
        Variant[] args = {new Variant(Edition),new Variant(ContainsPICT)};
        invoke_method_void(args,182,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param EditionObject[]
    * @param EditionObject[]
    */
    public void CreatePublisher(Object[] Edition)
    {
        Variant[] args = {new Variant(Edition)};
        invoke_method_void(args,182,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CreatePublisher()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,182,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertAutoText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,183,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param DataSourceObject[]
    * @param FromObject[]
    * @param ToObject[]
    * @param IncludeFieldsObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param DataSourceObject[]
    * @param FromObject[]
    * @param ToObject[]
    * @param IncludeFieldsObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] WritePasswordDocument,Object[] WritePasswordTemplate,Object[] DataSource,Object[] From,Object[] To,Object[] IncludeFields)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate),new Variant(DataSource),new Variant(From),new Variant(To),new Variant(IncludeFields)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertDatabase(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertDatabase.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param DataSourceObject[]
    * @param FromObject[]
    * @param ToObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param DataSourceObject[]
    * @param FromObject[]
    * @param ToObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] WritePasswordDocument,Object[] WritePasswordTemplate,Object[] DataSource,Object[] From,Object[] To)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate),new Variant(DataSource),new Variant(From),new Variant(To)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param DataSourceObject[]
    * @param FromObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param DataSourceObject[]
    * @param FromObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] WritePasswordDocument,Object[] WritePasswordTemplate,Object[] DataSource,Object[] From)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate),new Variant(DataSource),new Variant(From)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param DataSourceObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param DataSourceObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] WritePasswordDocument,Object[] WritePasswordTemplate,Object[] DataSource)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate),new Variant(DataSource)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] WritePasswordDocument,Object[] WritePasswordTemplate)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param WritePasswordDocumentObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] WritePasswordDocument)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(WritePasswordDocument)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1,Object[] PasswordDocument,Object[] PasswordTemplate)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1),new Variant(PasswordDocument),new Variant(PasswordTemplate)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param PasswordDocumentObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1,Object[] PasswordDocument)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1),new Variant(PasswordDocument)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param SQLStatement1Object[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement,Object[] SQLStatement1)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement),new Variant(SQLStatement1)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param SQLStatementObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection,Object[] SQLStatement)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection),new Variant(SQLStatement)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param ConnectionObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource,Object[] Connection)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource),new Variant(Connection)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    * @param LinkToSourceObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style,Object[] LinkToSource)
    {
        Variant[] args = {new Variant(Format),new Variant(Style),new Variant(LinkToSource)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param StyleObject[]
    * @param FormatObject[]
    * @param StyleObject[]
    */
    public void InsertDatabase(Object[] Format,Object[] Style)
    {
        Variant[] args = {new Variant(Format),new Variant(Style)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FormatObject[]
    * @param FormatObject[]
    */
    public void InsertDatabase(Object[] Format)
    {
        Variant[] args = {new Variant(Format)};
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertDatabase()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,194,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void AutoFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,195,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CheckGrammar()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionary9Object[]
    * @param CustomDictionary10Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionary9Object[]
    * @param CustomDictionary10Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6,Object[] CustomDictionary7,Object[] CustomDictionary8,Object[] CustomDictionary9,Object[] CustomDictionary10)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6),new Variant(CustomDictionary7),new Variant(CustomDictionary8),new Variant(CustomDictionary9),new Variant(CustomDictionary10)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void CheckSpelling(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashCheckSpelling.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionary9Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionary9Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6,Object[] CustomDictionary7,Object[] CustomDictionary8,Object[] CustomDictionary9)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6),new Variant(CustomDictionary7),new Variant(CustomDictionary8),new Variant(CustomDictionary9)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6,Object[] CustomDictionary7,Object[] CustomDictionary8)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6),new Variant(CustomDictionary7),new Variant(CustomDictionary8)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6,Object[] CustomDictionary7)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6),new Variant(CustomDictionary7)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2,Object[] CustomDictionary3)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2),new Variant(CustomDictionary3)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionary2Object[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest,Object[] CustomDictionary2)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest),new Variant(CustomDictionary2)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param AlwaysSuggestObject[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] AlwaysSuggest)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(AlwaysSuggest)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    */
    public void CheckSpelling(Object[] CustomDictionary,Object[] IgnoreUppercase)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param CustomDictionaryObject[]
    */
    public void CheckSpelling(Object[] CustomDictionary)
    {
        Variant[] args = {new Variant(CustomDictionary)};
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CheckSpelling()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,205,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionary9Object[]
    * @param CustomDictionary10Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionary9Object[]
    * @param CustomDictionary10Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6,Object[] CustomDictionary7,Object[] CustomDictionary8,Object[] CustomDictionary9,Object[] CustomDictionary10)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6),new Variant(CustomDictionary7),new Variant(CustomDictionary8),new Variant(CustomDictionary9),new Variant(CustomDictionary10)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashGetSpellingSuggestions.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionary9Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionary9Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6,Object[] CustomDictionary7,Object[] CustomDictionary8,Object[] CustomDictionary9)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6),new Variant(CustomDictionary7),new Variant(CustomDictionary8),new Variant(CustomDictionary9)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionary8Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6,Object[] CustomDictionary7,Object[] CustomDictionary8)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6),new Variant(CustomDictionary7),new Variant(CustomDictionary8)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionary7Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6,Object[] CustomDictionary7)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6),new Variant(CustomDictionary7)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionary6Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5,Object[] CustomDictionary6)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5),new Variant(CustomDictionary6)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionary5Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4,Object[] CustomDictionary5)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4),new Variant(CustomDictionary5)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionary4Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2,Object[] CustomDictionary3,Object[] CustomDictionary4)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2),new Variant(CustomDictionary3),new Variant(CustomDictionary4)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionary3Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2,Object[] CustomDictionary3)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2),new Variant(CustomDictionary3)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionary2Object[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode,Object[] CustomDictionary2)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode),new Variant(CustomDictionary2)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param SuggestionModeObject[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary,Object[] SuggestionMode)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary),new Variant(SuggestionMode)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param MainDictionaryObject[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase,Object[] MainDictionary)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase),new Variant(MainDictionary)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @param CustomDictionaryObject[]
    * @param IgnoreUppercaseObject[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary,Object[] IgnoreUppercase)
    {
        Variant[] args = {new Variant(CustomDictionary),new Variant(IgnoreUppercase)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param CustomDictionaryObject[]
    * @param CustomDictionaryObject[]
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions(Object[] CustomDictionary)
    {
        Variant[] args = {new Variant(CustomDictionary)};
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return SpellingSuggestions
    */
    public SpellingSuggestions GetSpellingSuggestions()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,209,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        SpellingSuggestions ret = new SpellingSuggestions(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void InsertParagraphBefore()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,212,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void NextSubdocument()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,219,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PreviousSubdocument()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,220,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ConversionsModeObject[]
    * @param FastConversionObject[]
    * @param CheckHangulEndingObject[]
    * @param EnableRecentOrderingObject[]
    * @param CustomDictionaryObject[]
    * @param ConversionsModeObject[]
    * @param FastConversionObject[]
    * @param CheckHangulEndingObject[]
    * @param EnableRecentOrderingObject[]
    * @param CustomDictionaryObject[]
    */
    public void ConvertHangulAndHanja(Object[] ConversionsMode,Object[] FastConversion,Object[] CheckHangulEnding,Object[] EnableRecentOrdering,Object[] CustomDictionary)
    {
        Variant[] args = {new Variant(ConversionsMode),new Variant(FastConversion),new Variant(CheckHangulEnding),new Variant(EnableRecentOrdering),new Variant(CustomDictionary)};
        invoke_method_void(args,221,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void ConvertHangulAndHanja(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashConvertHangulAndHanja.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,221,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ConversionsModeObject[]
    * @param FastConversionObject[]
    * @param CheckHangulEndingObject[]
    * @param EnableRecentOrderingObject[]
    * @param ConversionsModeObject[]
    * @param FastConversionObject[]
    * @param CheckHangulEndingObject[]
    * @param EnableRecentOrderingObject[]
    */
    public void ConvertHangulAndHanja(Object[] ConversionsMode,Object[] FastConversion,Object[] CheckHangulEnding,Object[] EnableRecentOrdering)
    {
        Variant[] args = {new Variant(ConversionsMode),new Variant(FastConversion),new Variant(CheckHangulEnding),new Variant(EnableRecentOrdering)};
        invoke_method_void(args,221,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ConversionsModeObject[]
    * @param FastConversionObject[]
    * @param CheckHangulEndingObject[]
    * @param ConversionsModeObject[]
    * @param FastConversionObject[]
    * @param CheckHangulEndingObject[]
    */
    public void ConvertHangulAndHanja(Object[] ConversionsMode,Object[] FastConversion,Object[] CheckHangulEnding)
    {
        Variant[] args = {new Variant(ConversionsMode),new Variant(FastConversion),new Variant(CheckHangulEnding)};
        invoke_method_void(args,221,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ConversionsModeObject[]
    * @param FastConversionObject[]
    * @param ConversionsModeObject[]
    * @param FastConversionObject[]
    */
    public void ConvertHangulAndHanja(Object[] ConversionsMode,Object[] FastConversion)
    {
        Variant[] args = {new Variant(ConversionsMode),new Variant(FastConversion)};
        invoke_method_void(args,221,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ConversionsModeObject[]
    * @param ConversionsModeObject[]
    */
    public void ConvertHangulAndHanja(Object[] ConversionsMode)
    {
        Variant[] args = {new Variant(ConversionsMode)};
        invoke_method_void(args,221,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ConvertHangulAndHanja()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,221,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PasteAsNestedTable()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,222,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param StyleObject[]
    * @param SymbolObject[]
    * @param EnclosedTextObject[]
    * @param StyleObject[]
    * @param SymbolObject[]
    * @param EnclosedTextObject[]
    */
    public void ModifyEnclosure(Object[] Style,Object[] Symbol,Object[] EnclosedText)
    {
        Variant[] args = {new Variant(Style),new Variant(Symbol),new Variant(EnclosedText)};
        invoke_method_void(args,223,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param StyleObject[]
    * @param SymbolObject[]
    * @param StyleObject[]
    * @param SymbolObject[]
    */
    public void ModifyEnclosure(Object[] Style,Object[] Symbol)
    {
        Variant[] args = {new Variant(Style),new Variant(Symbol)};
        invoke_method_void(args,223,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param StyleObject[]
    * @param StyleObject[]
    */
    public void ModifyEnclosure(Object[] Style)
    {
        Variant[] args = {new Variant(Style)};
        invoke_method_void(args,223,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param AlignmentWdPhoneticGuideAlignmentTypeEnum
    * @param Raiseint
    * @param FontSizeint
    * @param FontNameString
    * @param TextString
    * @param AlignmentWdPhoneticGuideAlignmentTypeEnum
    * @param Raiseint
    * @param FontSizeint
    * @param FontNameString
    */
    public void PhoneticGuide(String Text,WdPhoneticGuideAlignmentTypeEnum Alignment,int Raise,int FontSize,String FontName)
    {
        Variant[] args = {new Variant(Text),new Variant(Alignment.getValue()),new Variant(Raise),new Variant(FontSize),new Variant(FontName)};
        invoke_method_void(args,224,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void PhoneticGuide(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashPhoneticGuide.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,224,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param AlignmentWdPhoneticGuideAlignmentTypeEnum
    * @param Raiseint
    * @param FontSizeint
    * @param TextString
    * @param AlignmentWdPhoneticGuideAlignmentTypeEnum
    * @param Raiseint
    * @param FontSizeint
    */
    public void PhoneticGuide(String Text,WdPhoneticGuideAlignmentTypeEnum Alignment,int Raise,int FontSize)
    {
        Variant[] args = {new Variant(Text),new Variant(Alignment.getValue()),new Variant(Raise),new Variant(FontSize)};
        invoke_method_void(args,224,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param AlignmentWdPhoneticGuideAlignmentTypeEnum
    * @param Raiseint
    * @param TextString
    * @param AlignmentWdPhoneticGuideAlignmentTypeEnum
    * @param Raiseint
    */
    public void PhoneticGuide(String Text,WdPhoneticGuideAlignmentTypeEnum Alignment,int Raise)
    {
        Variant[] args = {new Variant(Text),new Variant(Alignment.getValue()),new Variant(Raise)};
        invoke_method_void(args,224,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param AlignmentWdPhoneticGuideAlignmentTypeEnum
    * @param TextString
    * @param AlignmentWdPhoneticGuideAlignmentTypeEnum
    */
    public void PhoneticGuide(String Text,WdPhoneticGuideAlignmentTypeEnum Alignment)
    {
        Variant[] args = {new Variant(Text),new Variant(Alignment.getValue())};
        invoke_method_void(args,224,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TextString
    * @param TextString
    */
    public void PhoneticGuide(String Text)
    {
        Variant[] args = {new Variant(Text)};
        invoke_method_void(args,224,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateLanguageObject[]
    * @param CalendarTypeObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateLanguageObject[]
    * @param CalendarTypeObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat,Object[] InsertAsField,Object[] InsertAsFullWidth,Object[] DateLanguage,Object[] CalendarType)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField),new Variant(InsertAsFullWidth),new Variant(DateLanguage),new Variant(CalendarType)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void InsertDateTime(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsertDateTime.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateLanguageObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateLanguageObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat,Object[] InsertAsField,Object[] InsertAsFullWidth,Object[] DateLanguage)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField),new Variant(InsertAsFullWidth),new Variant(DateLanguage)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param InsertAsFullWidthObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat,Object[] InsertAsField,Object[] InsertAsFullWidth)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField),new Variant(InsertAsFullWidth)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    * @param DateTimeFormatObject[]
    * @param InsertAsFieldObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat,Object[] InsertAsField)
    {
        Variant[] args = {new Variant(DateTimeFormat),new Variant(InsertAsField)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DateTimeFormatObject[]
    * @param DateTimeFormatObject[]
    */
    public void InsertDateTime(Object[] DateTimeFormat)
    {
        Variant[] args = {new Variant(DateTimeFormat)};
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void InsertDateTime()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,444,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param LanguageIDObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param LanguageIDObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics,Object[] IgnoreHe,Object[] LanguageID)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics),new Variant(IgnoreHe),new Variant(LanguageID)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void Sort(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashSort.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics,Object[] IgnoreHe)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics),new Variant(IgnoreHe)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive,Object[] BidiSort)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive),new Variant(BidiSort)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param CaseSensitiveObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator,Object[] CaseSensitive)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator),new Variant(CaseSensitive)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param SeparatorObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn,Object[] Separator)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn),new Variant(Separator)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param SortColumnObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3,Object[] SortColumn)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3),new Variant(SortColumn)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param SortOrder3Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3,Object[] SortOrder3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3),new Variant(SortOrder3)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param SortFieldType3Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3,Object[] SortFieldType3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3),new Variant(SortFieldType3)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param FieldNumber3Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2,Object[] FieldNumber3)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2),new Variant(FieldNumber3)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param SortOrder2Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2,Object[] SortOrder2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2),new Variant(SortOrder2)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param SortFieldType2Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2,Object[] SortFieldType2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2),new Variant(SortFieldType2)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param FieldNumber2Object[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder,Object[] FieldNumber2)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder),new Variant(FieldNumber2)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType,Object[] SortOrder)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType),new Variant(SortOrder)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param SortFieldTypeObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber,Object[] SortFieldType)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber),new Variant(SortFieldType)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    * @param ExcludeHeaderObject[]
    * @param FieldNumberObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] FieldNumber)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(FieldNumber)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param ExcludeHeaderObject[]
    */
    public void Sort(Object[] ExcludeHeader)
    {
        Variant[] args = {new Variant(ExcludeHeader)};
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Sort()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,484,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void DetectLanguage()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param AutoFitBehaviorObject[]
    * @param DefaultTableBehaviorObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param AutoFitBehaviorObject[]
    * @param DefaultTableBehaviorObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn,Object[] AutoFit,Object[] AutoFitBehavior,Object[] DefaultTableBehavior)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn),new Variant(AutoFit),new Variant(AutoFitBehavior),new Variant(DefaultTableBehavior)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Table
    */
    public Table ConvertToTable(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashConvertToTable.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param AutoFitBehaviorObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param AutoFitBehaviorObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn,Object[] AutoFit,Object[] AutoFitBehavior)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn),new Variant(AutoFit),new Variant(AutoFitBehavior)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param AutoFitObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn,Object[] AutoFit)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn),new Variant(AutoFit)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param ApplyLastColumnObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn,Object[] ApplyLastColumn)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn),new Variant(ApplyLastColumn)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param ApplyFirstColumnObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow,Object[] ApplyFirstColumn)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow),new Variant(ApplyFirstColumn)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param ApplyLastRowObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows,Object[] ApplyLastRow)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows),new Variant(ApplyLastRow)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param ApplyHeadingRowsObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor,Object[] ApplyHeadingRows)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor),new Variant(ApplyHeadingRows)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param ApplyColorObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont,Object[] ApplyColor)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont),new Variant(ApplyColor)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param ApplyFontObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading,Object[] ApplyFont)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading),new Variant(ApplyFont)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param ApplyShadingObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders,Object[] ApplyShading)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders),new Variant(ApplyShading)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param ApplyBordersObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format,Object[] ApplyBorders)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format),new Variant(ApplyBorders)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param FormatObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth,Object[] Format)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth),new Variant(Format)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param InitialColumnWidthObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns,Object[] InitialColumnWidth)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns),new Variant(InitialColumnWidth)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param NumColumnsObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows,Object[] NumColumns)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows),new Variant(NumColumns)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @param SeparatorObject[]
    * @param NumRowsObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator,Object[] NumRows)
    {
        Variant[] args = {new Variant(Separator),new Variant(NumRows)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param SeparatorObject[]
    * @return Table
    */
    public Table ConvertToTable(Object[] Separator)
    {
        Variant[] args = {new Variant(Separator)};
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Table
    */
    public Table ConvertToTable()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,498,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Table ret = new Table(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param WdTCSCConverterDirectionWdTCSCConverterDirectionEnum
    * @param CommonTermsboolean
    * @param UseVariantsboolean
    * @param WdTCSCConverterDirectionWdTCSCConverterDirectionEnum
    * @param CommonTermsboolean
    * @param UseVariantsboolean
    */
    public void TCSCConverter(WdTCSCConverterDirectionEnum WdTCSCConverterDirection,boolean CommonTerms,boolean UseVariants)
    {
        Variant[] args = {new Variant(WdTCSCConverterDirection.getValue()),new Variant(CommonTerms),new Variant(UseVariants)};
        invoke_method_void(args,499,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void TCSCConverter(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashTCSCConverter.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,499,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param WdTCSCConverterDirectionWdTCSCConverterDirectionEnum
    * @param CommonTermsboolean
    * @param WdTCSCConverterDirectionWdTCSCConverterDirectionEnum
    * @param CommonTermsboolean
    */
    public void TCSCConverter(WdTCSCConverterDirectionEnum WdTCSCConverterDirection,boolean CommonTerms)
    {
        Variant[] args = {new Variant(WdTCSCConverterDirection.getValue()),new Variant(CommonTerms)};
        invoke_method_void(args,499,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param WdTCSCConverterDirectionWdTCSCConverterDirectionEnum
    * @param WdTCSCConverterDirectionWdTCSCConverterDirectionEnum
    */
    public void TCSCConverter(WdTCSCConverterDirectionEnum WdTCSCConverterDirection)
    {
        Variant[] args = {new Variant(WdTCSCConverterDirection.getValue())};
        invoke_method_void(args,499,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void TCSCConverter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,499,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return boolean
    */
    public boolean getLanguageDetected()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,263,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setLanguageDetected(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,263,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getFitTextWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,264,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setFitTextWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,264,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdHorizontalInVerticalTypeEnum
    */
    public WdHorizontalInVerticalTypeEnum getHorizontalInVertical()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,265,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdHorizontalInVerticalTypeEnum ret = WdHorizontalInVerticalTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdHorizontalInVerticalTypeEnum
    * @param arg1WdHorizontalInVerticalTypeEnum
    */
    public void setHorizontalInVertical(WdHorizontalInVerticalTypeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,265,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdTwoLinesInOneTypeEnum
    */
    public WdTwoLinesInOneTypeEnum getTwoLinesInOne()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,266,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdTwoLinesInOneTypeEnum ret = WdTwoLinesInOneTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdTwoLinesInOneTypeEnum
    * @param arg1WdTwoLinesInOneTypeEnum
    */
    public void setTwoLinesInOne(WdTwoLinesInOneTypeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,266,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getCombineCharacters()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,267,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCombineCharacters(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,267,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getNoProofing()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,323,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setNoProofing(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,323,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Tables
    */
    public Tables getTopLevelTables()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,324,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Tables ret = new Tables(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Object // @@@Scripts 

    */
    /*
    public Object // @@@Scripts 
 getScripts()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,325,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object // @@@Scripts 
 ret = new Object // @@@Scripts 
((Dispatch)retVar.ForceObjectVal());
        return(ret);
    }
    */

    /**
    * @return WdCharacterWidthEnum
    */
    public WdCharacterWidthEnum getCharacterWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,326,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdCharacterWidthEnum ret = WdCharacterWidthEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdCharacterWidthEnum
    * @param arg1WdCharacterWidthEnum
    */
    public void setCharacterWidth(WdCharacterWidthEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,326,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdKanaEnum
    */
    public WdKanaEnum getKana()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,327,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdKanaEnum ret = WdKanaEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdKanaEnum
    * @param arg1WdKanaEnum
    */
    public void setKana(WdKanaEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,327,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getBoldBi()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,400,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setBoldBi(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,400,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getItalicBi()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,401,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setItalicBi(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,401,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,405,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setID(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,405,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
